/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "ChooseFromCatDlg.h"
#include "resource.h"
struct ChooseDGEngine : ChooseFromCatDlg {
	enum DG_ORIENTATION m_orientation;
	ChooseDGEngine(CATID catid) : ChooseFromCatDlg(catid),m_orientation(DGO_DOWN) {}
	LRESULT Initialize(UINT m,WPARAM w,LPARAM l,BOOL&hand) {
		ChooseFromCatDlg::Initialize(m,w,l,hand);
		setDirection();
		return 0;
	}
	void setDirection() {
		int idc;
		for(idc = IDC_Down; idc<=IDC_Left; ++idc)
			SendDlgItemMessage(idc,BM_SETCHECK,BST_UNCHECKED);
		switch(m_orientation) {
		case DGO_DOWN: idc = IDC_Down;
			break;
		case DGO_RIGHT: idc = IDC_Right;
			break;
		case DGO_UP: idc = IDC_Up;
			break;
		case DGO_LEFT: idc = IDC_Left;
			break;
		}
		SendDlgItemMessage(idc,BM_SETCHECK,BST_CHECKED);
	}

	enum DG_ORIENTATION getDirection() {
		if(SendDlgItemMessage(IDC_Down,BM_GETCHECK)==BST_CHECKED)
			return DGO_DOWN;
		else if(SendDlgItemMessage(IDC_Right,BM_GETCHECK)==BST_CHECKED)
			return DGO_RIGHT;
		else if(SendDlgItemMessage(IDC_Up,BM_GETCHECK)==BST_CHECKED)
			return DGO_UP;
		else if(SendDlgItemMessage(IDC_Left,BM_GETCHECK)==BST_CHECKED)
			return DGO_LEFT;
		else {
			_ASSERTE(0);
			return DGO_DOWN;
		}
	}
	void FinishUp() {
		m_orientation = getDirection();
	}
};