/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include <List>
class BootDG :
	public CComObjectRoot,
	public CComCoClass<BootDG,&CLSID_DGMBootDynagraph>,
	public IInitializeOther,
    public IDGMBootDynagraph
{
    CComPtr<IInitializeOther> m_initEng;
public:
	REGISTER_GENERIC(L"DGBootstrapper")
	BootDG() {
		CONSTRUCTORTRACE(BootDG);
	}
	~BootDG() {
		DESTRUCTORTRACE(BootDG);
	}
BEGIN_CATEGORY_MAP(BootDG)
	IMPLEMENTED_CATEGORY(CATID_MCCStarter)
END_CATEGORY_MAP()

BEGIN_COM_MAP(BootDG)
	COM_INTERFACE_ENTRY(IInitializeOther)
    COM_INTERFACE_ENTRY(IDGMBootDynagraph)
END_COM_MAP()
// IInitializeOther
	STDMETHODIMP InitializeOther(IUnknown *munk);
// IDGMBootDynagraph
    STDMETHODIMP put_EngineInitializer(IInitializeOther *initEng) {
        m_initEng = initEng;
        return S_OK;
    }
};
class BootShapeNodeNodeSource :
	public CComObjectRoot,
	public CComCoClass<BootShapeNodeNodeSource,&CLSID_DGMBootShapeNodeNodeSource>,
	public IInitializeOther
{
public:
	REGISTER_GENERIC(L"BootShapeNodeNodeSource")
	BootShapeNodeNodeSource() {
		CONSTRUCTORTRACE(BootShapeNodeNodeSource);
	}
	~BootShapeNodeNodeSource() {
		DESTRUCTORTRACE(BootShapeNodeNodeSource);
	}
BEGIN_CATEGORY_MAP(BootShapeNodeNodeSource)
	IMPLEMENTED_CATEGORY(CATID_MCCStarter)
END_CATEGORY_MAP()

BEGIN_COM_MAP(BootShapeNodeNodeSource)
	COM_INTERFACE_ENTRY(IInitializeOther)
END_COM_MAP()
// IInitializeOther
	STDMETHODIMP InitializeOther(IUnknown *munk);
};
class DGMBoot :
	public CComObjectRoot,
	public CComCoClass<DGMBoot,&CLSID_DGMBoot>,
	public IInitializeOther
{
public:
	REGISTER_GENERIC(L"DGMBootstrapper")
	DGMBoot() {
		CONSTRUCTORTRACE(DGMBoot);
	}
	~DGMBoot() {
		DESTRUCTORTRACE(DGMBoot);
	}
BEGIN_CATEGORY_MAP(DGMBoot)
	IMPLEMENTED_CATEGORY(CATID_MCCStarter)
END_CATEGORY_MAP()

BEGIN_COM_MAP(DGMBoot)
	COM_INTERFACE_ENTRY(IInitializeOther)
END_COM_MAP()
// IInitializeOther
	STDMETHODIMP InitializeOther(IUnknown *munk);
};
