/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


typedef struct Agnode_s Agnode_t;
struct DOTFileFormat : CComObjectRoot,
	CComCoClass<DOTFileFormat,&CLSID_DGMDOTFileFormat>,
	INeedSomePointers,
	IMCCFileFormat,
	IPersist
{
	CComPtr<IDGMDrawer> m_drawer;
	CComPtr<IMCCLayer> m_mainLayer;
REGISTER_GENERIC(L"DOTImport");
	DOTFileFormat();
	~DOTFileFormat();
BEGIN_COM_MAP(DOTFileFormat)
	COM_INTERFACE_ENTRY(INeedSomePointers)
	COM_INTERFACE_ENTRY(IMCCFileFormat)
	COM_INTERFACE_ENTRY(IPersist)
END_COM_MAP()
	HRESULT drawNode(IMoniker *mkG,Agnode_t *n,IDGDrawnNode **ret);
// INeedSomePointers
	STDMETHODIMP TakePointers(IEnumUnknown *eu,IEnumMoniker *ms);
// IMCCFileFormat
	STDMETHODIMP Import(LPCOLESTR filename);
	STDMETHODIMP Export(LPCOLESTR filename);
// IPersist
	STDMETHODIMP GetClassID(CLSID *ret) {
		*ret = GetObjectCLSID();
		return S_OK;
	}
};