/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "MontageConfig.h"
#include "ensureNativeFormat.h"
struct DynaDiagram : MontageConfig<DynaDiagram,&CLSID_DynagraphControl,
	MontageCreator<&CLSID_MontageControlContainer,&CLSID_DGMBoot>,IDR_MontageApp> {
BEGIN_REGMAP()
	REGMAP_GUID(L"CLSID",CLSID_DynagraphControl)
	REGMAP_GUID(L"TypeLib",LIBID_DGM)
	REGMAP_STRING(L"DocName",L"Dynagraph Diagram")
	REGMAP_STRING(L"AppName",L"Dynagraph")
	REGMAP_STRING(L"Short",L"Diagram")
	REGMAP_STRING(L"ProgID",L"DGM.Diagram.1")
	REGMAP_STRING(L"VersIndProgID",L"DGM.Diagram")
	REGMAP_FUN(L"ProgDir",progdirString)
	REGMAP_STRING(L"DefaultExt",L".dot,Dot Graph Description (.dot)")
	REGMAP_STRING(L"Extra",
	L"HKCR { '.dgm' = s 'DGM.Diagram' { val 'Content Type' = s 'application/dynagraph' } "
			//L"'.dot' = s 'DGM.Diagram' { val 'Content Type' = s 'text/dotdiagram' } "
			L"NoRemove MIME { NoRemove Database { NoRemove 'Content Type' { application/dynagraph { val Extension = s '.dgm' } "
																		  L"text/dynagraph { val Extension = s '.dot' } } } } }")
END_REGMAP()
	static HRESULT moreReg() {
		return ensureNativeFormat(L"dgm");
	}
};
