/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


class EdgeConnector :
	public CComObjectRoot,
	public CComCoClass<EdgeConnector,&CLSID_DGMEdgeConnector>,
	public IDispatchImpl<DIDGMConnector>,
	public IDGEdgeShadow,
	public IMCCSiteOwner,
	public IMCCSiteEvents,
	public IMCCExpandSelection,
	public INeedSomePointers,
	public IObjectWithSite,
	public IPersist
{
	CComPtr<IUnknown> m_site; // thru IObjectWithSite
	CComQIPtr<IMCCSite> m_msite;
	CComQIPtr<IDGDrawnEdge> m_edge; // thru INeedSomePointers

	long m_nextState; // when engine is stopped

	bool m_inserted;
	DWORD m_dwEdgeCookie;
public:
	EdgeConnector();
	~EdgeConnector();
	REGISTER_GENERIC(L"EdgeConnector")
BEGIN_COM_MAP(EdgeConnector)
	COM_INTERFACE_ENTRY(DIDGMConnector)
	COM_INTERFACE_ENTRY(IDGEdgeShadow)
	COM_INTERFACE_ENTRY(IMCCSiteOwner)
	COM_INTERFACE_ENTRY(IMCCSiteEvents)
	COM_INTERFACE_ENTRY(IMCCExpandSelection)
	COM_INTERFACE_ENTRY(INeedSomePointers)
	COM_INTERFACE_ENTRY(IObjectWithSite)
	COM_INTERFACE_ENTRY(IPersist)
END_COM_MAP()
// DIDGMConnector
	STDMETHODIMP put_LayoutObject(IUnknown *val);
	STDMETHODIMP get_LayoutObject(IUnknown **ret);
	STDMETHODIMP put_Site(DIMCCSite *val);
// IDGEdgeShadow:
    STDMETHODIMP Insert();
    STDMETHODIMP Delete();
    STDMETHODIMP Modify(int flags);
// IMCCSiteOwner
    STDMETHODIMP Move(MCC_POS_INFO *mpi);
    STDMETHODIMP PutBefore(IMCCSite *other);
    STDMETHODIMP PutBehind(IMCCSite *other);
	STDMETHODIMP Intend(long intent);
// IMCCSiteEvents
	STDMETHODIMP Moving(LPCRECT winRect);
	STDMETHODIMP Shifting(long oldState, long newState);
	STDMETHODIMP Layering(IMCCLayer *newLayer);
	STDMETHODIMP ZChanged();
	STDMETHODIMP Wakeup();
// IMCCExpandSelection
	STDMETHODIMP Expand(IItemSet *selection);
// INeedSomePointers
	STDMETHODIMP TakePointers(IEnumUnknown *os,IEnumMoniker *ms);
// IObjectWithSite
	STDMETHODIMP SetSite(IUnknown *pUnkSite);
	STDMETHODIMP GetSite(REFIID riid, void **ppvSite);
// IPersist
	STDMETHODIMP GetClassID(CLSID *ret) {
		*ret = GetObjectCLSID();
		return S_OK;
	}
};
