/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


class EngineConnector :
	public CComCoClass<EngineConnector,&CLSID_DGMEngineConnector>,
	public CComObjectRoot,
	public IDGMEngineConnector,
	public IDispatchImpl<DIDGMEngineConnector>,
	public INeedSomePointers,
	public IDGLayoutShadow,
	public IMontageContainerEvents,
	public IPersist
{
	CComPtr<DIMontageContainerRef> m_mref;
	CComPtr<IDGLayout> m_engine;
	CComPtr<IDGMDrawer> m_drawer;
	DWORD m_chocolateChip;
public:
	EngineConnector();
	~EngineConnector();
	REGISTER_GENERIC(L"EngineConnector")
BEGIN_COM_MAP(EngineConnector)
	COM_INTERFACE_ENTRY(IDGMEngineConnector)
	COM_INTERFACE_ENTRY(DIDGMEngineConnector)
	COM_INTERFACE_ENTRY(INeedSomePointers)
	COM_INTERFACE_ENTRY(IDGLayoutShadow)
	COM_INTERFACE_ENTRY(IMontageContainerEvents)
	COM_INTERFACE_ENTRY(IPersist)
END_COM_MAP()

// IDGMEngineConnector
	STDMETHODIMP Initialize(IMontageContainer *montage, IDGLayout *engine,IDGMDrawer *drawer);
// DIDGMEngineConnector
	STDMETHODIMP Initialize(DIMontageContainer *montage, DIDGLayout *engine,DIDGMDrawer *drawer);
// INeedSomePointers
	STDMETHODIMP TakePointers(IEnumUnknown *os,IEnumMoniker *ms);
// IDGLayoutShadow
    STDMETHODIMP OnBoundsChanged(PRECTD pNewBounds);
    STDMETHODIMP OnChangeRect(PRECTD pNewBounds);
	STDMETHODIMP OnLinesChanged();
	STDMETHODIMP OnNewNode(IDGDrawnNode *node);
	STDMETHODIMP OnNewEdge(IDGDrawnEdge *edge);
	STDMETHODIMP OnStringsChanged();
// IMontageContainerEvents
	STDMETHODIMP Shutdown();
	STDMETHODIMP Resize(SIZE size);
	STDMETHODIMP NewExtent(SIZEL ext);
	STDMETHODIMP Viewing(HDC hdc,LPCRECTL lpcrOut, LPCRECTL lpcrCanv);
	STDMETHODIMP NewTransform(IMCCTransform *);
	STDMETHODIMP GroupOp(BOOL);
	STDMETHODIMP SiteDeleted(IMCCSite*);
	STDMETHODIMP LayerDeleted(IMCCLayer*);
	STDMETHODIMP Shifting(long oldState,long newState);
	STDMETHODIMP ShowArea(LPCRECTL r) { return S_FALSE; }
    STDMETHODIMP FocusChanged() { return S_FALSE; }
// IPersist
    STDMETHODIMP GetClassID(CLSID *pClassID);
};