/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "StdAfx.h"
#include <common/Geometry.h>

bool FakePolyBezier(POINT *pts,int n,vector<POINT> &ret) {
	Coord *src = new Coord[n];
	for(int j = 0;j<n; ++j) {
		src[j].x = pts[j].x;
		src[j].y = pts[j].y;
	}
	Coord first = Bezier(src,3,0.0);
	ret.push_back(point(ROUND(first.x),ROUND(first.y)));
	for(j = 0;j<n-1;j+=3)
		for(double i = 0.1;i<=1.0;i+=0.1) {
			Coord next = Bezier(src+j,3,i);
			ret.push_back(point(ROUND(next.x),ROUND(next.y)));
		}
	delete src;
	return true;
}