/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


struct LabelModePersistor :
	CComCoClass<LabelModePersistor,&CLSID_DGMLabelModePersistor>,
	CComObjectRoot,
	IDGMLabelModePersistor,
	IDGMLabelModeEvents,
	IDispatchImpl<DIPersistor>,
	IGroupItem,
	IPersistStream
{
	CComPtr<IGroup> m_group;
	CComQIPtr<IDGMLabelMode> m_subject;
	DWORD m_MintnCreme;

	CComPtr<IMoniker> m_mkLayout, m_mkContent, m_mkLabelSource,m_mkReader;
	vector<IMoniker*> siteMks;
	union labelInfo {
		struct {
			double whereF;
		};
		struct {
			POINTD size;
			enum DG_NODELABELALIGN whereA;
		};
	};
	vector<labelInfo> labelInf;

	LabelModePersistor();
	~LabelModePersistor();

	void clear();
	HRESULT infer();

REGISTER_GENERIC(L"LabelModePersistor")

BEGIN_COM_MAP(LabelModePersistor)
	COM_INTERFACE_ENTRY(IDGMLabelModePersistor)
	COM_INTERFACE_ENTRY(IDGMLabelModeEvents)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(DIPersistor)
	COM_INTERFACE_ENTRY(IGroupItem)
	COM_INTERFACE_ENTRY(IPersistStream)
END_COM_MAP()
// IDGMLabelModePersistor
	STDMETHODIMP Initialize(IMoniker *mkLabelSource,IMoniker *mkReader);
	STDMETHODIMP put_LayoutMk(IMoniker *val);
// IMCCLabelModeEvents
	STDMETHODIMP LabelsChanged();
// DIPersistor
	STDMETHODIMP SetSubject(VARIANT_BOOL realized,IUnknown *pUnkSite);
	STDMETHODIMP get_Subject(IUnknown **ret);
// IGroupItem
	STDMETHODIMP Connect(IGroup *group);
	STDMETHODIMP Copy(IBindCtx *bctx, IGroup *dest, IUnknown *aggr, REFIID riid, void **ret);
	STDMETHODIMP Realize(IBindCtx *bctx);
	STDMETHODIMP Remove();
// IPersistStream
	STDMETHODIMP GetClassID(CLSID *pClassID);
	STDMETHODIMP IsDirty(void);
	STDMETHODIMP Load(IStream *pStm);
	STDMETHODIMP Save(IStream *pStm,BOOL fClearDirty);
	STDMETHODIMP GetSizeMax(ULARGE_INTEGER *pcbSize);
};