/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


class NodeShadow :
	public CComObjectRoot,
	public CComCoClass<NodeShadow,&CLSID_DGMNodeConnector>,
	public IDispatchImpl<DIDGMConnector>,
	public IDGNodeShadow,
	public IMCCSiteOwner,
	public IMCCSiteEvents,
	public INeedOnePointer,
	public IObjectWithSite,
	public IAdviseSink,
	public IPersist,
	public IMCCInThreadTrigger
{
	CComQIPtr<IDGDrawnNode> m_node;
	CComPtr<IUnknown> m_site;
	CComQIPtr<IMCCSite> m_msite;

	long m_nextState;

	SIZEL m_extent; // you can't trust the control to hold the extent. (GetExtent doesn't return SetExtent)

	bool m_inserted,
		m_amSettingExtent; // SetExtent can fire Move event

	DWORD m_dwNodeCookie, m_dwSiteOwnerCookie, m_dwSiteEventsCookie,m_mandm;

	DECLARE_GET_CONTROLLING_UNKNOWN()

	HRESULT getExtent();
	HRESULT getrect(POINTL pos,PRECTL prc);
	// determines whether shape can be inferred from control and sets
	// up advisory connection if so
	HRESULT adviseIfAppropriate();
	// get shape from metafile, or just creates rect shape if control isn't CATID_DGMMetafileShape
	HRESULT findShape();
	// gets shape from metafile into m_shape
	void getShape(FORMATETC *fetc, STGMEDIUM *stgm);
	PDGSHAPESDESC m_shape;
	void freeShape();
public:
BEGIN_COM_MAP(NodeShadow)
	COM_INTERFACE_ENTRY(DIDGMConnector)
	COM_INTERFACE_ENTRY(IDGNodeShadow)
	COM_INTERFACE_ENTRY(IMCCSiteOwner)
	COM_INTERFACE_ENTRY(IMCCSiteEvents)
	COM_INTERFACE_ENTRY(INeedOnePointer)
	COM_INTERFACE_ENTRY(IObjectWithSite)
	COM_INTERFACE_ENTRY(IAdviseSink)
	COM_INTERFACE_ENTRY(IPersist)
END_COM_MAP()
	REGISTER_GENERIC(L"NodeShadow")
	NodeShadow();
	~NodeShadow();
// DIDGMConnector
	STDMETHODIMP put_LayoutObject(IUnknown *val);
	STDMETHODIMP get_LayoutObject(IUnknown **ret);
	STDMETHODIMP put_Site(DIMCCSite *val);
// IDGNodeShadow
    STDMETHODIMP Insert(void);
    STDMETHODIMP Delete(void);
    STDMETHODIMP Modify(int flags);
// IMCCSiteOwner
    STDMETHODIMP Move(MCC_POS_INFO *pos);
    STDMETHODIMP PutBefore(IMCCSite *other);
    STDMETHODIMP PutBehind(IMCCSite *other);
	STDMETHODIMP Intend(long intent);
// IMCCInThreadTrigger
	void STDMETHODCALLTYPE Trigger();
// IMCCSiteEvents
	STDMETHODIMP Moving(LPCRECT winRect);
	STDMETHODIMP Shifting(long oldState, long newState);
	STDMETHODIMP Layering(IMCCLayer *newLayer);
	STDMETHODIMP ZChanged();
// INeedOnePointer
	STDMETHODIMP TakePointer(IUnknown *o,IMoniker *m);
// IObjectWithSite
	STDMETHODIMP SetSite(IUnknown *pUnkSite);
	STDMETHODIMP GetSite(REFIID riid, void **ppvSite);
// IAdviseSink
    void STDMETHODCALLTYPE OnDataChange(
         FORMATETC *pFormatetc,
         STGMEDIUM *pStgmed);

    void STDMETHODCALLTYPE OnViewChange(
         DWORD dwAspect,
         LONG lindex);

    void STDMETHODCALLTYPE OnRename(
         IMoniker *pmk);

    void STDMETHODCALLTYPE OnSave(void);

    void STDMETHODCALLTYPE OnClose(void);
// IPersist
	STDMETHODIMP GetClassID(CLSID *ret);
};
