/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


struct Spine :
	CComObjectRoot,
	CComCoClass<Spine,&CLSID_DGMSpine>,
	IDGMSpine,
	IMCCInThreadTrigger,
	IDGIncrClientEvents,
	IMCCPlayControlsEvents,
	INeedSomePointers,
	IPersistImpl<Spine>
{
	CComPtr<DIMontageContainerRef> m_mref;
	CComPtr<IDGLayout> m_dynagraph;
    CComPtr<IDGIncrClient> m_incrClient;
	DWORD m_yellowOreo, // i kid you not.  "springtime" or some such
		m_oldFashionedMolasses;
	CComPtr<IMCCPlayControls> m_play;
	bool m_wasForward,
		m_respond; // whether to do anything on ReceivedResponse

	Spine();
	~Spine();

	REGISTER_GENERIC(L"Spine")

BEGIN_COM_MAP(Spine)
	COM_INTERFACE_ENTRY(IDGMSpine)
	COM_INTERFACE_ENTRY(IMCCInThreadTrigger)
	COM_INTERFACE_ENTRY(IDGIncrClientEvents)
	COM_INTERFACE_ENTRY(IMCCPlayControlsEvents)
	COM_INTERFACE_ENTRY(IPersist)
	COM_INTERFACE_ENTRY(INeedSomePointers)
END_COM_MAP()

// IDGMSpine
	STDMETHODIMP Initialize(IMontageContainer *mc,IDGLayout *dynagraph,IDGIncrClient *incrClient,IMCCPlayControls *playControls);
	STDMETHODIMP put_AutoRespond(VARIANT_BOOL val);
// IMCCInThreadTrigger
	void STDMETHODCALLTYPE Trigger();
// IDGIncrClientEvents
	STDMETHODIMP ReceivedResponse();
// IMCCPlayControlsEvents
	STDMETHODIMP Before(enum MCCPLAY_BUTTONS button, BOOL *wait);
	STDMETHODIMP After(enum MCCPLAY_BUTTONS button);
// INeedSomePointers
	STDMETHODIMP TakePointers(IEnumUnknown *os,IEnumMoniker *ms);
};