/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// dgm.cpp : Class factory, DLL Exports.

#include "stdafx.h"
#include "initguid.h"

#include "Diagram.h"

#include "DGMBoot.h"
#include "EngineConnector.h"
#include "NodeShadow.h"
#include "EdgeConnector.h"
#include "SimpleEdge.h"
#include "LabelMode.h"
#include "LabelModePersistor.h"

#include "objsafe.h"
#include "GraphDrawMode.h"
#include "Drawer.h"
#include "DOTFileFormat.h"

#include "ShapeNode.h"
#include "ShapeNodeProp.h"
#include "NestingControl.h"

#include "Spine.h"
#include "BootSpine.h"

CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
	OBJECT_ENTRY(CLSID_DynagraphControl,DynaDiagram)
	OBJECT_ENTRY(CLSID_DGMBoot, DGMBoot)
	OBJECT_ENTRY(CLSID_DGMBootDynagraph, BootDG)
	OBJECT_ENTRY(CLSID_DGMBootShapeNodeNodeSource, BootShapeNodeNodeSource)
	OBJECT_ENTRY(CLSID_DGMEngineConnector, EngineConnector)
	OBJECT_ENTRY(CLSID_DGMNodeConnector, NodeShadow)
	OBJECT_ENTRY(CLSID_DGMEdgeConnector, EdgeConnector)
	OBJECT_ENTRY(CLSID_DGMSimpleEdge, SimpleEdge)
	OBJECT_ENTRY(CLSID_DGMLabelMode, LabelMode)
	OBJECT_ENTRY(CLSID_DGMLabelModePersistor, LabelModePersistor)
	OBJECT_ENTRY(CLSID_DGMGraphDrawMode, GraphDrawMode)
	OBJECT_ENTRY(CLSID_DGMDrawer, Drawer)
	OBJECT_ENTRY(CLSID_DGMDOTFileFormat, DOTFileFormat)

	OBJECT_ENTRY(CLSID_ShapeNode, ShapeNode)
	OBJECT_ENTRY(CLSID_ShapeNodeProp, ShapeNodeProp)
	OBJECT_ENTRY(CLSID_NestingControl, NestingControl)

	OBJECT_ENTRY(CLSID_DGMSpine, Spine)
	OBJECT_ENTRY(CLSID_DGMBootSpine,BootSpine)
END_OBJECT_MAP()

/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point

extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		_Module.Init(ObjectMap, hInstance,&LIBID_DGM);
		DisableThreadLibraryCalls(hInstance);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
		_Module.Term();
	return TRUE;    // ok
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
	return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
	return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry
STDAPI DllRegisterServer(void)
{
	return _Module.RegisterServer(true);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
	return _Module.UnregisterServer(true);
}
