/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


inline CComPtr<IDGMLabelMode> labelModeFromSite(IMCCSite *s) {
    FUNTRACE(labelModeFromSite);
	CComPtr<IDGMLabelMode> labelMode;
	// hack: silly way to get label mode
	SLOOK(getSinkWhichImplements(s,IID_IMCCSiteEvents,&labelMode));
	return labelMode;
}
inline HRESULT labelNodeSite(IUnknown *site,BSTR text,IMCCSite **retLabelSite) {
    FUNTRACE(labelNodeSite);
	CComPtr<IDGMLabelMode> labelMode = labelModeFromSite(CComQIPtr<IMCCSite>(site));
	// try to reuse first label but otherwise create
	CComPtr<IEnumDGMLabelInfo> eli;
	SRUN(labelMode->EnumLabels(&eli));
	enumLI ili(eli);
	CComQIPtr<IMCCSite> labelSite;
    CComPtr<IDGLabel> label;
	if(ili!=enumLI())
		labelSite = ili->content,
        label = ili->layout;
	else
		SRUN(labelMode->NewLabel(0,&labelSite,&label));
	CComPtr<IMCCTextEdit> textEdit;
	SRUN(labelSite->GetControl(riidret(&textEdit)));
	SRUN(textEdit->put_Text(text));
	if(retLabelSite)
		labelSite.CopyTo(retLabelSite);
	return S_OK;
}
