/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


struct CreationPersistor :
	CComObjectRoot,
	CComCoClass<CreationPersistor,&CLSID_ServerCreationPersistor>,
	IDispatchImpl<DIServerCreationPersistor>,
	IDispatchImpl<DIPersistor>,
	IGroupItem,
	IPersistStream
{
	CComPtr<IMoniker> m_mkServer;
	CComPtr<IGroup> m_group;
	CComPtr<IUnknown> m_subject;
	CComPtr<IStream> m_cache; // IPersistStream data of subject

	CreationPersistor();
	~CreationPersistor();
REGISTER_GENERIC(L"ServerCreationPersistor")
BEGIN_COM_MAP(CreationPersistor)
	COM_INTERFACE_ENTRY(DIServerCreationPersistor)
	COM_INTERFACE_ENTRY(DIPersistor)
	COM_INTERFACE_ENTRY(IGroupItem)
	COM_INTERFACE_ENTRY(IPersistStream)
END_COM_MAP()
// DIPersistor
	STDMETHODIMP SetSubject(VARIANT_BOOL realized,IUnknown *val);
	STDMETHODIMP get_Subject(IUnknown **ret);
// DIServerCreationPersistor
	STDMETHODIMP put_ServerMoniker(IUnknown *val);
// IGroupItem
	STDMETHODIMP Connect(IGroup *group);
	STDMETHODIMP Copy(IBindCtx *bctx, IGroup *dest, IUnknown *aggr, REFIID riid, void **ret);
	STDMETHODIMP Realize(IBindCtx *bctx);
	STDMETHODIMP Remove();
// IPersistStream
	STDMETHODIMP GetClassID(CLSID *pClassID);
	STDMETHODIMP IsDirty(void);
	STDMETHODIMP Load(IStream *pStm);
	STDMETHODIMP Save(IStream *pStm,BOOL fClearDirty);
	STDMETHODIMP GetSizeMax(ULARGE_INTEGER *pcbSize);
};
