/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// Group.cpp : Implementation of DLL Exports.


// Note: Proxy/Stub Information
//		To build a separate proxy/stub DLL,
//		run nmake -f Groupps.mk in the project directory.

#include "stdafx.h"

#include "GroupClass.h"
#include "IdentityServer.h"
#include "ItemSet.h"
#include "OrderedItemList.h"
#include "GetSubjectMoniker.h"
#include "OnePointerPersistor.h"
#include "SomePointersPersistor.h"
#include "CreationPersistor.h"

CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
	OBJECT_ENTRY(CLSID_Group, Group)
	OBJECT_ENTRY(CLSID_IdentityServer, IdentityServer)
	OBJECT_ENTRY(CLSID_ItemSet, ItemSet)
	OBJECT_ENTRY(CLSID_OrderedItemList, OrderedItemList)
	OBJECT_ENTRY(CLSID_GetSubjectMoniker,GetSubjectMoniker)
	OBJECT_ENTRY(CLSID_OnePointerPersistor,OnePointerPersistor)
	OBJECT_ENTRY(CLSID_SomePointersPersistor,SomePointersPersistor)
	OBJECT_ENTRY(CLSID_ServerCreationPersistor,CreationPersistor)
END_OBJECT_MAP()

/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point

extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		_Module.Init(ObjectMap, hInstance,&LIBID_Group);
		DisableThreadLibraryCalls(hInstance);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
		_Module.Term();
	return TRUE;    // ok
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
	return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
	HRESULT hr = _Module.GetClassObject(rclsid, riid, ppv);
	return hr;
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
	// registers object, typelib and all interfaces in typelib
	return _Module.RegisterServer(true);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
	return _Module.UnregisterServer(true);
}


