/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


/////////////////////////////////////////////////////////////////////////////
// Group-IGroupItem
//
// holds onto parent for "up"; creates a new empty instance on copy
//
#include "stdafx.h"
#include "GroupClass.h"
STDMETHODIMP Group::Connect(IGroup *group) {
	METHTRACE(Group,Connect);
	m_parent = group;
	if(!group) // disconnect triggers unload to make unload recursive
		RUN(Unload((IMoniker*)0));
	return S_OK;
}
STDMETHODIMP Group::Copy(IBindCtx *bctx, IGroup *dest, IUnknown *aggr, REFIID riid, void **ret) {
	METHTRACE(Group,Copy);
	CComPtr<IGroupItem> g2;
	RUN(CREATE(g2,GetObjectCLSID())); TRACECREATEV(GetObjectCLSID());
	RUN(g2->Connect(dest));
	return g2->QueryInterface(riid,ret);
}
STDMETHODIMP Group::Realize(IBindCtx *bctx) {
	METHTRACE(Group,Realize);
	return S_OK;
}
STDMETHODIMP Group::Remove() {
	METHTRACE(Group,Remove);
	return S_OK;
}
