/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include <map>
typedef unsigned __int64 intID;
typedef map<DWORD, DWORD> mSI; // server to item map
typedef map<intID, mSI *> m64mSI; // identity to SI map map
class IdentityServer :
	public CComCoClass<IdentityServer,&CLSID_IdentityServer>,
	public CComObjectRootEx<CComGlobalsThreadModel>,
	public IGiveIdentity,
	public IKeepSets {
	DWORD m_currID;
	m64mSI m_map;
public:
	DECLARE_CLASSFACTORY_SINGLETON(IdentityServer)

	REGISTER_GENERIC(L"IdentityServer")

BEGIN_COM_MAP(IdentityServer)
	COM_INTERFACE_ENTRY(IGiveIdentity)
	COM_INTERFACE_ENTRY(IKeepSets)
END_COM_MAP()

	IdentityServer();
	~IdentityServer();

// IGiveIdentity
	STDMETHODIMP new_ServerID(DWORD *ret) {
		*ret = ++m_currID;
		return S_OK;
	}
// IKeepSets
	STDMETHODIMP Equals(IDENTITY p, IDENTITY q);
	STDMETHODIMP Find(IDENTITY p, DWORD qServer, DWORD *retQItem);
	STDMETHODIMP Remove(IDENTITY p);
};