/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// dispatch wrapper for group's Item struct
struct ItemInfo : CComObjectRoot,
	IDispatchImpl<DIGroupItemInfo, &IID_DIGroupItemInfo> {
	ITEMINF m_dat;
	void Init(ITEMINF &dat) {
		memset(&m_dat,0,sizeof(ITEMINF));
		if(dat.o)
			(m_dat.o = dat.o)->AddRef();
		if(dat.mk)
			(m_dat.mk = dat.mk)->AddRef();
		m_dat.count = dat.count;
	}
	~ItemInfo() {
		copyITEMINF::destroy(&m_dat);
	}
BEGIN_COM_MAP(ItemInfo)
	COM_INTERFACE_ENTRY(DIGroupItemInfo)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()
// DIGroupItemInfo
	 STDMETHODIMP get_Object(IUnknown **ret);
	 STDMETHODIMP get_Moniker(IUnknown **ret);
	 STDMETHODIMP get_Count(long *ret);
};

typedef CComObject<ItemInfo> itemInfo;