/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


class ItemSet :
	public CComCoClass<ItemSet,&CLSID_ItemSet>,
	public CComObjectRoot,
	public IConnectionPointContainerImpl<ItemSet>,
	public IConnectionPointImpl<ItemSet,&IID_IItemSetEvents>,
	public IItemSet,
	public IDispatchImpl<DIItemSet>,
	public IGroupItem,
	public IPersistStream
{
	mkSet m_set;
	CComPtr<IGroup> m_group;
	bool m_realized;

	HRESULT add(IMoniker *mk, bool addStgRef);
	HRESULT clear(bool releaseStgRef);
public:
	ItemSet();
	~ItemSet();
	REGISTER_GENERIC(L"ItemSet")
BEGIN_COM_MAP(ItemSet)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(IItemSet)
	COM_INTERFACE_ENTRY(DIItemSet)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IGroupItem)
	COM_INTERFACE_ENTRY(IPersist)
	COM_INTERFACE_ENTRY(IPersistStream)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(ItemSet)
	CONNECTION_POINT_ENTRY(IID_IItemSetEvents)
END_CONNECTION_POINT_MAP()

// IItemSet
	STDMETHODIMP get_Count(long *ret);
	STDMETHODIMP Add(IMoniker *mk);
	STDMETHODIMP Remove(IMoniker *mk);
	STDMETHODIMP Check(IMoniker *mk);
	STDMETHODIMP Clear();
	STDMETHODIMP Intersect(IItemSet *is);
	STDMETHODIMP Union(IItemSet *is);
	STDMETHODIMP Assign(IItemSet *is);
	STDMETHODIMP Enum(IEnumMoniker **ret);
// DIItemSet
	STDMETHODIMP Add(IUnknown *mk);
	STDMETHODIMP Remove(IUnknown *mk);
	STDMETHODIMP Check(IUnknown *mk,VARIANT_BOOL *ret);
	STDMETHODIMP get_Items(IDispatch **ret);
// IGroupItem
	STDMETHODIMP Connect(IGroup *group);
	STDMETHODIMP Copy(IBindCtx *bctx, IGroup *dest, IUnknown *aggr, REFIID riid, void **ret);
	STDMETHODIMP Realize(IBindCtx *bctx);
	STDMETHODIMP Remove();
// IPersistStream
	STDMETHODIMP GetClassID(CLSID *pClassID);
	STDMETHODIMP IsDirty(void);
	STDMETHODIMP Load(IStream *pStm);
	STDMETHODIMP Save(IStream *pStm,BOOL fClearDirty);
	STDMETHODIMP GetSizeMax(ULARGE_INTEGER *pcbSize);
};
