/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


typedef IDispatchImpl<DIHoldOnePointer> DIHOP;
class ATL_NO_VTABLE OnePointerPersistor :
	public CComCoClass<OnePointerPersistor,&CLSID_OnePointerPersistor>,
	public CComObjectRoot,
	public IDispatchImpl<DIPersistor>,
	public IHoldOnePointer,
	public DIHOP,
	public IGroupItem,
	public IPersistStream
{
	CComPtr<IGroup> m_group;
	CComPtr<IUnknown> m_subject;
	bool m_realized;
	CComPtr<IMoniker> m_moniker;

public:
	OnePointerPersistor();
	~OnePointerPersistor();
	REGISTER_GENERIC(L"OnePointerPersistor")

BEGIN_COM_MAP(OnePointerPersistor)
	COM_INTERFACE_ENTRY(DIPersistor)
	COM_INTERFACE_ENTRY(IHoldOnePointer)
	COM_INTERFACE_ENTRY(DIHoldOnePointer)
	COM_INTERFACE_ENTRY2(IDispatch,DIHOP)
	COM_INTERFACE_ENTRY(IGroupItem)
	COM_INTERFACE_ENTRY(IPersist)
	COM_INTERFACE_ENTRY(IPersistStream)
END_COM_MAP()
// DIPersistor
	STDMETHODIMP SetSubject(VARIANT_BOOL realized,IUnknown *val);
	STDMETHODIMP get_Subject(IUnknown **ret);
// IHoldOnePointer
	STDMETHODIMP put_Moniker(IMoniker *mk);
	STDMETHODIMP get_Moniker(IMoniker **ret);
// DIHoldOnePointer
	STDMETHODIMP put_Moniker(IUnknown *mk);
	STDMETHODIMP get_Moniker(IUnknown **mk);
//IGroupItem
	STDMETHODIMP Connect(IGroup *group);
	STDMETHODIMP Copy(IBindCtx *bctx, IGroup *dest, IUnknown *aggr, REFIID riid, void **ret);
	STDMETHODIMP Realize(IBindCtx *bctx);
	STDMETHODIMP Remove();
// IPersistStream
	STDMETHODIMP GetClassID(CLSID *pClassID);
	STDMETHODIMP IsDirty(void);
	STDMETHODIMP Load(IStream *pStm);
	STDMETHODIMP Save(IStream *pStm,BOOL fClearDirty);
	STDMETHODIMP GetSizeMax(ULARGE_INTEGER *pcbSize);
};