/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


typedef map<long,IMoniker*> ordmon;
class OrderedItemList :
	public CComCoClass<OrderedItemList,&CLSID_OrderedItemList>,
	public CComObjectRoot,
	public IOrderedItemList,
	public IDispatchImpl<DIOrderedItemList>,
	public IGroupItem,
	public IPersistStream
{
	CComPtr<IGroup> m_group;
	bool m_realized;
	ordmon m_ordmon;
	HRESULT setMoniker(long order, IMoniker *val, bool addStgRef);
public:
	OrderedItemList();
	~OrderedItemList();
	REGISTER_GENERIC(L"OrderedItemList")
BEGIN_COM_MAP(OrderedItemList)
	COM_INTERFACE_ENTRY(IOrderedItemList)
	COM_INTERFACE_ENTRY(DIOrderedItemList)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IGroupItem)
	COM_INTERFACE_ENTRY(IPersist)
	COM_INTERFACE_ENTRY(IPersistStream)
END_COM_MAP()

// IOrderedItemList
	STDMETHODIMP GetMoniker(long order, IMoniker **ret);
	STDMETHODIMP SetMoniker(long order, IMoniker *val);
	STDMETHODIMP Enum(long start, VARIANT_BOOL ascending, IEnumMoniker **ret);
// DIOrderedItemList
	STDMETHODIMP get_Item(long order, IUnknown **ret);
	STDMETHODIMP put_Item(long order, IUnknown *val);
	STDMETHODIMP get_AllItems(long start, VARIANT_BOOL ascending, IDispatch **ret);
// IGroupItem
	STDMETHODIMP Connect(IGroup *group);
	STDMETHODIMP Copy(IBindCtx *bctx, IGroup *dest, IUnknown *aggr, REFIID riid, void **ret);
	STDMETHODIMP Realize(IBindCtx *bctx);
	STDMETHODIMP Remove();
// IPersistStream
	STDMETHODIMP GetClassID(CLSID *pClassID);
	STDMETHODIMP IsDirty(void);
	STDMETHODIMP Load(IStream *pStm);
	STDMETHODIMP Save(IStream *pStm,BOOL fClearDirty);
	STDMETHODIMP GetSizeMax(ULARGE_INTEGER *pcbSize);
};
