/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


typedef IDispatchImpl<DIHoldSomePointers> DIHSP;

class SomePointersPersistor :
	public CComObjectRoot,
	public CComCoClass<SomePointersPersistor,&CLSID_SomePointersPersistor>,
	public IDispatchImpl<DIPersistor>,
	public IHoldSomePointers,
	public DIHSP,
	public IGroupItem,
	public IPersistStream
{
	CComPtr<IGroup> m_group;
	typedef vector<IMoniker*> vm;
	vm m_pointers;
	CComPtr<IUnknown> m_subject;
	bool m_realized;

	HRESULT clear(bool releaseStgRef);
public:
	SomePointersPersistor();
	~SomePointersPersistor();
	REGISTER_GENERIC(L"SomePointersPersistor")
BEGIN_COM_MAP(SomePointersPersistor)
	COM_INTERFACE_ENTRY(DIPersistor)
	COM_INTERFACE_ENTRY(IHoldSomePointers)
	COM_INTERFACE_ENTRY(DIHoldSomePointers)
	COM_INTERFACE_ENTRY2(IDispatch,DIHSP)
	COM_INTERFACE_ENTRY(IGroupItem)
	COM_INTERFACE_ENTRY(IPersist)
	COM_INTERFACE_ENTRY(IPersistStream)
END_COM_MAP()
// IPersistor
	STDMETHODIMP SetSubject(VARIANT_BOOL realized,IUnknown *site);
	STDMETHODIMP get_Subject(IUnknown **ret);
// IHoldSomePointers
	STDMETHODIMP Push(IMoniker *mk);
	STDMETHODIMP Replace(int index, IMoniker *mk); // (zero-based index - ?)
	STDMETHODIMP Clear();
	STDMETHODIMP Enum(IEnumMoniker **ret);
// DIHoldSomePointers
	STDMETHODIMP PushOne(IUnknown *val);
	STDMETHODIMP Push(SAFEARRAY *args);
	STDMETHODIMP get_Params(IDispatch **ret);
// IGroupItem
	STDMETHODIMP Connect(IGroup *group);
	STDMETHODIMP Copy(IBindCtx *bctx, IGroup *dest, IUnknown *aggr, REFIID riid, void **ret);
	STDMETHODIMP Realize(IBindCtx *bctx);
	STDMETHODIMP Remove();
// IPersistStream
	STDMETHODIMP GetClassID(CLSID *pClassID);
	STDMETHODIMP IsDirty(void);
	STDMETHODIMP Load(IStream *pStm);
	STDMETHODIMP Save(IStream *pStm,BOOL fClearDirty);
	STDMETHODIMP GetSizeMax(ULARGE_INTEGER *pcbSize);
};
