/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// AdviseSinkCS.cpp : Implementation of IAdviseSink for
// Montage sites

#include "stdafx.h"
#include "Container.h"

// autosizing.  note that it's not an option but conveniently only works
// when the layer is transformed, e.g. within document but not in toolbars.
// (should be an option, as everywhere Montage handles the hardest case
// but maybe that's not what everyone wants!)
void Site::checkSizeChange() {
    METHTRACE(Site,checkSizeChange);
	if(!m_pLayer->m_amTransformed)
		return;
	if(CComQIPtr<IOleObject> oo = m_pControl) {
		SIZEL ext;
		RUN(oo->GetExtent(DVASPECT_CONTENT,&ext));
		if(ext!=siz(m_virtRect)) {
			MCC_POS_INFO mpi;
			mpi.postype = MCC_POS_CANVASSIZE;
			mpi.sl = ext;
			LOOK(fireSiteEvent(this,fireMove(&mpi)));
		}
	}
}
void Site::postCheckSizeMessage() {
	if(m_cont->m_hWnd)
		PostMessage(m_cont->m_hWnd,MONTAGE_CHECK_SITE_SIZE,0,reinterpret_cast<LPARAM>((site*)this));
}
void Site::OnDataChange(FORMATETC *pFormatetc,STGMEDIUM *pStgmed) {
	IMETHTRACE(Site,IAdviseSink,OnDataChange);
	if(m_state>MCCS_DELETED) {
		m_cont->InvalidateSite((site*)this);
		if(m_state>MCCS_HIDDEN)
            RUN(m_cont->dirty());
		postCheckSizeMessage();
	}
}

void Site::OnViewChange(DWORD dwAspect,LONG lindex) {
	IMETHTRACE(Site,IAdviseSink,OnViewChange);
	if(m_state>MCCS_DELETED) {
		m_cont->InvalidateSite((site*)this);
		if(m_state>MCCS_HIDDEN)
            RUN(m_cont->dirty());
	}
}

void Site::OnRename(IMoniker *pmk) {
	IMETHTRACE(Site,IAdviseSink,OnRename);
}

void Site::OnSave(void) {
	IMETHTRACE(Site,IAdviseSink,OnSave);
}

void Site::OnClose(void) {
	IMETHTRACE(Site,IAdviseSink,OnClose);
}
