/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "../brutePrice/brutePrice.h"

// engines refs boxes and sets their eng members to 0 when it dies.
struct BrutePriceEngine;
struct ATL_NO_VTABLE BoxFace :
	CComObjectRoot,
	IMoveRect,
	IConnectionPointContainerImpl<BoxFace>,
	IConnectionPointImpl<BoxFace,&IID_IMoveRect>
{
	BrutePriceEngine *eng;
	int n; // index in BoxCost
	void tell();

	BoxFace();
	~BoxFace();

BEGIN_COM_MAP(BoxFace)
	COM_INTERFACE_ENTRY(IMoveRect)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(BoxFace)
	CONNECTION_POINT_ENTRY(IID_IMoveRect)
END_CONNECTION_POINT_MAP()
// IMoveRect
	STDMETHODIMP Move(LPCRECT pos);
};
struct face : CComObject<BoxFace> {
	face(BrutePriceEngine *engine, int num) {
		eng = engine;
		n = num;
	}
};
struct ATL_NO_VTABLE BrutePriceEngine :
	public CComCoClass<BrutePriceEngine,&CLSID_MCCBrutePriceEngine>,
	public CComObjectRoot,
	public IRectEngine,
	public IMontageInclusion,
	public IPersist
{
	typedef vector<face *> vface;
	vface m_boxFaces;
	BPBoard *m_board;
	bool m_flexibleBoundary;

	BrutePriceEngine();
	~BrutePriceEngine();

	void run(int changed); // takes index of changed object so it knows to notify that too

	REGISTER_GENERIC(L"BrutePriceEngine")

BEGIN_COM_MAP(BrutePriceEngine)
	COM_INTERFACE_ENTRY(IRectEngine)
	COM_INTERFACE_ENTRY(IMontageInclusion)
	COM_INTERFACE_ENTRY(IPersist)
END_COM_MAP()
// IRectEngine
	STDMETHODIMP new_Delegate(IMoveRect **ret);
	STDMETHODIMP get_Outer(IMoveRect **ret);
	STDMETHODIMP get_Inner(IMoveRect **ret);
	STDMETHODIMP put_OuterFlexible(VARIANT_BOOL val);
	STDMETHODIMP get_OuterFlexible(VARIANT_BOOL *ret);
// IMontageInclusion
	STDMETHODIMP ContainsRect(LPCRECT lpcr);
// IPersist
	STDMETHODIMP GetClassID(CLSID *ret);
};
