/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#ifndef __CHEAPBUTTON_H_
#define __CHEAPBUTTON_H_

/////////////////////////////////////////////////////////////////////////////
// CheapButton
struct ATL_NO_VTABLE CheapButton :
	CComObjectRoot,
	IMCCButton,
	CComControl<CheapButton>,
	IPersistStreamInitImpl<CheapButton>,
	IOleControlImpl<CheapButton>,
	IOleObjectImpl<CheapButton>,
	IOleInPlaceActiveObjectImpl<CheapButton>,
	IViewObjectExImpl<CheapButton>,
	IOleInPlaceObjectWindowlessImpl<CheapButton>,
	CComCoClass<CheapButton, &CLSID_MCCButton>,
	IConnectionPointContainerImpl<CheapButton>,
	IConnectionPointImpl<CheapButton,&IID_IMCCButtonEvents>
{
	HWND m_button;
	CComBSTR m_text; // only when inactive
    DWORD m_wstyle;

	CheapButton();
	~CheapButton();

	REGISTER_GENERIC(L"CheapButton")

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CheapButton)
	COM_INTERFACE_ENTRY(IMCCButton)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(CheapButton)
	CONNECTION_POINT_ENTRY(IID_IMCCButtonEvents)
END_CONNECTION_POINT_MAP()

BEGIN_PROP_MAP(CheapButton)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_MSG_MAP(CheapButton)
	CHAIN_MSG_MAP(CComControl<CheapButton>)
	COMMAND_CODE_HANDLER(BN_CLICKED,OnClick);
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()

// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	LRESULT OnClick(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);

	HRESULT OnDrawAdvanced(ATL_DRAWINFO& di)
	{
		return S_OK;
	}

	// disable UI activity that comes with focus
	HRESULT DoVerbUIActivate(LPCRECT lprcPosRect, HWND hwndParent) {
		return DoVerbInPlaceActivate(lprcPosRect,hwndParent);
	}
	// create combo
	HWND CreateControlWindow(HWND parent, RECT &pos);
	// here's where it gets deleted
	STDMETHODIMP InPlaceDeactivate();
	// move combo too
	STDMETHOD(SetObjectRects)(LPCRECT prcPos,LPCRECT prcClip);

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IMCCButton
    STDMETHODIMP put_WStyle(DWORD val);
	STDMETHODIMP get_Text(BSTR *ret);
	STDMETHODIMP put_Text(BSTR val);
    STDMETHODIMP get_State(int *ret);
};

#endif //__CHEAPBUTTON_H_
