/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#ifndef __CHEAPCOMBO_H_
#define __CHEAPCOMBO_H_

#include <set>

/////////////////////////////////////////////////////////////////////////////
// CheapCombo
struct ATL_NO_VTABLE CheapCombo :
	CComObjectRoot,
	IMCCComboBox,
	CComControl<CheapCombo>,
	IPersistStreamInitImpl<CheapCombo>,
	IOleControlImpl<CheapCombo>,
	IOleObjectImpl<CheapCombo>,
	IOleInPlaceActiveObjectImpl<CheapCombo>,
	IViewObjectExImpl<CheapCombo>,
	IOleInPlaceObjectWindowlessImpl<CheapCombo>,
	CComCoClass<CheapCombo, &CLSID_MCCComboBox>,
	IConnectionPointContainerImpl<CheapCombo>,
	IConnectionPointImpl<CheapCombo,&IID_IMCCComboBoxEvents>
{
	HWND m_combo;
	vector<wstring> m_offline;
	wstring m_offsel;
	DWORD m_wstyle;

	CheapCombo();
	~CheapCombo();

	REGISTER_GENERIC(L"CheapCombo")

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CheapCombo)
	COM_INTERFACE_ENTRY(IMCCComboBox)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(CheapCombo)
	CONNECTION_POINT_ENTRY(IID_IMCCComboBoxEvents)
END_CONNECTION_POINT_MAP()

BEGIN_PROP_MAP(CheapCombo)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_MSG_MAP(CheapCombo)
    COMMAND_CODE_HANDLER(CBN_KILLFOCUS,OnKillFocus)
	COMMAND_CODE_HANDLER(CBN_SELENDOK,OnSelect);
	CHAIN_MSG_MAP(CComControl<CheapCombo>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()

// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	LRESULT OnSelect(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnKillFocus(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);

	HRESULT OnDrawAdvanced(ATL_DRAWINFO& di)
	{
		return S_OK;
	}

	// disable UI activity that comes with focus
	HRESULT DoVerbUIActivate(LPCRECT lprcPosRect, HWND hwndParent) {
		return DoVerbInPlaceActivate(lprcPosRect,hwndParent);
	}
	// create combo
	HWND CreateControlWindow(HWND parent, RECT &pos);
	// here's where it gets deleted
	STDMETHODIMP InPlaceDeactivate();
	// move combo too
	STDMETHOD(SetObjectRects)(LPCRECT prcPos,LPCRECT prcClip);

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IMCCComboBox
	STDMETHODIMP put_WStyle(DWORD val);
	STDMETHODIMP Get(BSTR *ret);
	STDMETHODIMP Clear();
	STDMETHODIMP Add(BSTR val);
	STDMETHODIMP Choose(BSTR val);
	STDMETHODIMP Remove(BSTR val);
};

#endif //__CHEAPCOMBO_H_
