/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#ifndef __CHEAPEDIT_H_
#define __CHEAPEDIT_H_

/////////////////////////////////////////////////////////////////////////////
// CheapEdit
struct ATL_NO_VTABLE CheapEdit :
	CComObjectRoot,
	IMCCEdit,
	CComControl<CheapEdit>,
	IPersistStreamInitImpl<CheapEdit>,
	IOleControlImpl<CheapEdit>,
	IOleObjectImpl<CheapEdit>,
	IOleInPlaceActiveObjectImpl<CheapEdit>,
	IViewObjectExImpl<CheapEdit>,
	IOleInPlaceObjectWindowlessImpl<CheapEdit>,
	CComCoClass<CheapEdit, &CLSID_MCCEdit>,
	IConnectionPointContainerImpl<CheapEdit>,
    IConnectionPointImpl<CheapEdit,&IID_IMCCEditEvents>
{
	HWND m_edit;
	DWORD m_wstyle;
    CComBSTR m_text;

	CheapEdit();
	~CheapEdit();

	REGISTER_GENERIC(L"CheapEdit")

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CheapEdit)
	COM_INTERFACE_ENTRY(IMCCEdit)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(CheapEdit)
    CONNECTION_POINT_ENTRY(IID_IMCCEditEvents)
END_CONNECTION_POINT_MAP()

BEGIN_PROP_MAP(CheapEdit)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_MSG_MAP(CheapEdit)
    COMMAND_CODE_HANDLER(EN_KILLFOCUS,OnKillFocus)
	CHAIN_MSG_MAP(CComControl<CheapEdit>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()

// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

    LRESULT OnKillFocus(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);

	HRESULT OnDrawAdvanced(ATL_DRAWINFO& di)
	{
		return S_OK;
	}

	// disable UI activity that comes with focus
	HRESULT DoVerbUIActivate(LPCRECT lprcPosRect, HWND hwndParent) {
		return DoVerbInPlaceActivate(lprcPosRect,hwndParent);
	}
	// create edit
	HWND CreateControlWindow(HWND parent, RECT &pos);
	// here's where it gets deleted
	STDMETHODIMP InPlaceDeactivate();
	// resize
	STDMETHOD(SetObjectRects)(LPCRECT prcPos,LPCRECT prcClip);



// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IMCCEdit
	STDMETHODIMP get_Text(BSTR *ret);
	STDMETHODIMP put_Text(BSTR val);
	STDMETHODIMP put_WStyle(DWORD val);
};

#endif //__CHEAPEDIT_H_
