/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#ifndef __CHEAPSCROLL_H_
#define __CHEAPSCROLL_H_

struct Sinf : SCROLLINFO {
	Sinf(UINT mask) {
		cbSize = sizeof(SCROLLINFO);
		fMask = mask|SIF_DISABLENOSCROLL;
	}
};

/////////////////////////////////////////////////////////////////////////////
// CheapScroll
struct ATL_NO_VTABLE CheapScroll :
	CComObjectRoot,
	IDispatchImpl<DIMCCScrollbar, &IID_DIMCCScrollbar, &LIBID_Montage>,
	CComControl<CheapScroll>,
	IPersistStreamInitImpl<CheapScroll>,
	IOleControlImpl<CheapScroll>,
	IOleObjectImpl<CheapScroll>,
	IOleInPlaceActiveObjectImpl<CheapScroll>,
	IViewObjectExImpl<CheapScroll>,
	IOleInPlaceObjectWindowlessImpl<CheapScroll>,
	CComCoClass<CheapScroll, &CLSID_MCCScrollbar>,
	IConnectionPointContainerImpl<CheapScroll>,
	IConnectionPointImpl<CheapScroll,&IID_IMCCScrollbarEvents>
{
	HWND m_scrollbar;
	bool m_vert;
	Sinf m_cache;

	CheapScroll();
	~CheapScroll();

	REGISTER_GENERIC(L"CheapScroll")

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CheapScroll)
	COM_INTERFACE_ENTRY(DIMCCScrollbar)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(CheapScroll)
	CONNECTION_POINT_ENTRY(IID_IMCCScrollbarEvents)
END_CONNECTION_POINT_MAP()

BEGIN_PROP_MAP(CheapScroll)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_MSG_MAP(CheapScroll)
	CHAIN_MSG_MAP(CComControl<CheapScroll>)
	DEFAULT_REFLECTION_HANDLER()
	MESSAGE_HANDLER(WM_HSCROLL,OnScroll)
	MESSAGE_HANDLER(WM_VSCROLL,OnScroll)
END_MSG_MAP()

	LRESULT OnScroll(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	HRESULT OnDrawAdvanced(ATL_DRAWINFO& di)
	{
		return S_OK;
	}

	// disable UI activity that comes with focus
	HRESULT DoVerbUIActivate(LPCRECT lprcPosRect, HWND hwndParent) {
		return DoVerbInPlaceActivate(lprcPosRect,hwndParent);
	}
	// create scrollbar
	HWND CreateControlWindow(HWND parent, RECT &pos);
	// here's where it gets deleted
	STDMETHODIMP InPlaceDeactivate();
	// move scrollbar too
	STDMETHOD(SetObjectRects)(LPCRECT prcPos,LPCRECT prcClip);

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// ICheapScroll
	STDMETHODIMP get_Vert(VARIANT_BOOL *ret);
	STDMETHODIMP put_Vert(VARIANT_BOOL val);
	STDMETHODIMP get_Pos(int *ret);
	STDMETHODIMP put_Pos(int val);
	STDMETHODIMP GetRange(int *retMin, int *retMax);
	STDMETHODIMP SetRange(int min, int max);
	STDMETHODIMP get_Thumb(int *ret);
	STDMETHODIMP put_Thumb(int val);
};

#endif //__CHEAPSCROLL_H_
