/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


struct ColorBox :
	CComCoClass<ColorBox,&CLSID_MCCColorBox>,
	CComObjectRoot,
	CComControl<ColorBox>,
	CStockPropImpl<ColorBox,DIMCCColorBox,&IID_DIMCCColorBox,&LIBID_Montage>,
	IViewObjectExImpl<ColorBox>,
	IOleInPlaceObjectWindowlessImpl<ColorBox>,
	IOleObjectImpl<ColorBox>,
	IMCCSiteEvents,
	IMCCSelectionDraw,
	INeedOnePointer,
	IPersistStreamInitImpl<ColorBox>
{
	CComPtr<IMCCSite> m_buddy;
	DWORD m_mnm,m_mnmWithWalnuts;

	long m_nBorderWidth;
	OLE_COLOR m_clrFillColor;

	ColorBox();
	~ColorBox();

	REGISTER_GENERIC(L"ColorBox")
BEGIN_COM_MAP(ColorBox)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY(IMCCSiteEvents)
	COM_INTERFACE_ENTRY(IMCCSelectionDraw)
	COM_INTERFACE_ENTRY(INeedOnePointer)
	COM_INTERFACE_ENTRY(DIMCCColorBox)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IID(IID_IPersistStream,IPersistStreamInit)
END_COM_MAP()

BEGIN_PROP_MAP(ColorBox)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
END_PROP_MAP()

	HRESULT OnDrawAdvanced(ATL_DRAWINFO& di);
// overridden IOleObjectImpl
	STDMETHODIMP SetClientSite(IOleClientSite *val);
// INeedOnePointer
	STDMETHODIMP TakePointer(IUnknown *u,IMoniker *m);
// IMCCSiteEvents
	STDMETHODIMP Moving(LPCRECT winRect);
	STDMETHODIMP Shifting(long oldState, long newState);
	STDMETHODIMP Layering(IMCCLayer *newLayer);
	STDMETHODIMP ZChanged();
	STDMETHODIMP Wakeup();
// IMCCSelectionDraw
	STDMETHODIMP Show();
	STDMETHODIMP Hide();
};