/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


struct ContainerRef : CComObjectRoot,
	IDispatchImpl<DIMontageContainerRef>
{
	IUnknown *m_mc;
	ContainerRef() {
		CONSTRUCTORTRACE(ContainerRef);
	}
	~ContainerRef() {
		DESTRUCTORTRACE(ContainerRef);
	}
BEGIN_COM_MAP(ContainerRef)
	COM_INTERFACE_ENTRY(DIMontageContainerRef)
END_COM_MAP()
// DIMontageContainerRef
	STDMETHODIMP get_Montage(IUnknown **ret) {
		if(m_mc)
			(*ret = m_mc)->AddRef();
		else
			*ret = 0;
		return S_OK;
	}
};

