/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


struct ControlMode :
	public CComObjectRoot,
	public CComCoClass<ControlMode,&CLSID_MCCControlMode>,
	public IDispatchImpl<DIMCCControlMode>,
	public IMCCMode,
	public INeedSomePointers,
	public IObjectWithSite,
	public IMontageContainerEvents,
	public IPersistStreamInit
{
	CComPtr<IUnknown> m_site;
	bool m_sinking;
	long m_state; // to remember between Init and SetSite
public:
	ControlMode();
	~ControlMode();
	REGISTER_GENERIC(L"ControlMode")
BEGIN_COM_MAP(ControlMode)
	COM_INTERFACE_ENTRY(DIMCCControlMode)
	COM_INTERFACE_ENTRY(IMCCMode)
	COM_INTERFACE_ENTRY(INeedSomePointers)
	COM_INTERFACE_ENTRY(IObjectWithSite)
	COM_INTERFACE_ENTRY(IMontageContainerEvents)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
END_COM_MAP()

// DIMCCControlMode
	STDMETHODIMP Initialize(DIMCCModeDelegate *del);
	STDMETHODIMP put_Site(DIMCCSite *val);
// DIMCCMode
	STDMETHODIMP Activate(VARIANT_BOOL once);
	STDMETHODIMP Deactivate();
// INeedSomePointers
	STDMETHODIMP TakePointers(IEnumUnknown *os,IEnumMoniker *ms);
// IObjectWithSite
	STDMETHODIMP SetSite(IUnknown *pUnkSite);
	STDMETHODIMP GetSite(REFIID riid, void **ppvSite);
// IMontageContainerEvents
	STDMETHODIMP Shutdown();
	STDMETHODIMP Resize(SIZE s);
	STDMETHODIMP NewExtent(SIZEL);
	STDMETHODIMP Viewing(HDC hdc, LPCRECTL lpcrOut, LPCRECTL lpcrCanv);
	STDMETHODIMP NewTransform(IMCCTransform *);
	STDMETHODIMP GroupOp(BOOL);
	STDMETHODIMP SiteDeleted(IMCCSite*);
	STDMETHODIMP LayerDeleted(IMCCLayer*);
	STDMETHODIMP Shifting(long oldState,long newState);
	STDMETHODIMP ShowArea(LPCRECTL r) { return S_FALSE; }
    STDMETHODIMP FocusChanged() { return S_FALSE; }
// IPersistStreamInit
	STDMETHODIMP GetClassID(CLSID *pClassID);
	STDMETHODIMP IsDirty(void);
	STDMETHODIMP Load(IStream *pStm);
	STDMETHODIMP Save(IStream *pStm,BOOL fClearDirty);
	STDMETHODIMP GetSizeMax(ULARGE_INTEGER *pcbSize);
	STDMETHODIMP InitNew(void);
};
