/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


class DataObjectReader :
	public CComObjectRoot,
	public CComCoClass<DataObjectReader,&CLSID_MCCDataObjectReader>,
	//public ICEMTransferEvents,
	public IMCCDataObjectReader,
	public IMCCDataObjectUnpacker,
	//public INeedSomePointers,
	public IPersist
{
	typedef map<CLIPFORMAT,IMCCDataObjectUnpacker*> clipmap;
	clipmap m_oneFormats, m_manyFormats;

	HRESULT tryOneFormat(IDataObject *data, FORMATETC *fetc, LPOLESTR baseName, IItemSet *isetPaste, IMCCSitePersistor **ret);
	HRESULT tryManyFormat(IDataObject *data, FORMATETC *fetc, IItemSet *isetPaste, IEnumUnknown **ret);
public:
	DataObjectReader();
	~DataObjectReader();
	REGISTER_GENERIC(L"DataObjectReader")
BEGIN_COM_MAP(DataObjectReader)
	//COM_INTERFACE_ENTRY(ICEMTransferEvents)
	COM_INTERFACE_ENTRY(IMCCDataObjectReader)
	COM_INTERFACE_ENTRY(IMCCDataObjectUnpacker)
	//COM_INTERFACE_ENTRY(INeedSomePointers)
	COM_INTERFACE_ENTRY(IPersist)
END_COM_MAP()
// ICEMTransferEvents
	//STDMETHODIMP Insert(IDataObject *data, MCC_POS_INFO *cpi);
	// Query handled by IMCCDataObjectUnpacker::same
	// (these are basically the same interface)
// IMCCDataObjectReader
	//STDMETHODIMP Initialize(IMontageContainer *mc, IContainerEditMode *cem);
	STDMETHODIMP RegisterUnpacker(CLIPFORMAT cf, VARIANT_BOOL many, IMCCDataObjectUnpacker *unpacker);
	STDMETHODIMP UnregisterUnpacker(VARIANT_BOOL many, CLIPFORMAT cf);
// IMCCDataObjectUnpacker
	STDMETHODIMP UnpackOne(IDataObject *data, FORMATETC *fetc, LPOLESTR baseName, IItemSet *isetPaste, IMCCSitePersistor **ret);
	STDMETHODIMP UnpackMany(IDataObject *data, FORMATETC *fetc, IItemSet *isetPaste, IEnumUnknown **ret);
	STDMETHODIMP Query(IDataObject *data);
// INeedSomePointers
	//STDMETHODIMP TakePointers(IEnumUnknown *eu,IEnumMoniker *ms);
// IPersist
	STDMETHODIMP GetClassID(CLSID *ret) {
		*ret = GetObjectCLSID();
		return S_OK;
	}
};
