/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


class DefaultMCCSelectable :
	public CComCoClass<DefaultMCCSelectable,&CLSID_DefaultMCCSelectable>,
	public CComObjectRoot,
	public IDispatchImpl<DIDefaultMCCSelectable>,
	public IDefaultSink,
	public IMCCSelectable,
	public INeedOnePointer,
	public IPersist
{
	CComQIPtr<IMCCSite> m_subject;
	bool m_realized, m_singleton;

public:
	DefaultMCCSelectable();
	~DefaultMCCSelectable();
	REGISTER_GENERIC(L"DefaultMCCSelectable")
BEGIN_COM_MAP(DefaultMCCSelectable)
	COM_INTERFACE_ENTRY(DIDefaultMCCSelectable)
	COM_INTERFACE_ENTRY(IDefaultSink)
	COM_INTERFACE_ENTRY(IMCCSelectable)
	COM_INTERFACE_ENTRY(INeedOnePointer)
	COM_INTERFACE_ENTRY(IPersist)
END_COM_MAP()

// IDefaultMCCSelectable
	STDMETHODIMP Initialize(DIMontageContainer *mc);
	STDMETHODIMP get_Singleton(VARIANT_BOOL *ret);
	STDMETHODIMP put_Singleton( VARIANT_BOOL val);
// IDefaultSink
	STDMETHODIMP StartSink(IUnknown *firedOn);
// IMCCSelectable
	STDMETHODIMP Add(IItemSet *selection);
	STDMETHODIMP Remove(IItemSet *selection);
	STDMETHODIMP Toggle(IItemSet *selection);
	STDMETHODIMP Check(IItemSet *selection);
// INeedOnePointer
	STDMETHODIMP TakePointer(IUnknown *o,IMoniker *m);
// IPersist
	STDMETHODIMP GetClassID(CLSID *pClassID);
};