/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


class DefaultMCCSelectionDraw :
	public CComObjectRoot,
	public CComCoClass<DefaultMCCSelectionDraw,&CLSID_DefaultMCCSelectionDraw>,
	public IDispatchImpl<DIDefaultMCCSelectionDraw>,
	public IMCCSelectionDraw,
	public IDefaultSink,
	public INeedOnePointer,
	public IPersistStream
{
	CLSID m_grapClass;
	CComPtr<IMCCSite> m_subject;
	CComPtr<IMCCLayer> m_grapplel;
public:
	DefaultMCCSelectionDraw();
	~DefaultMCCSelectionDraw();
	REGISTER_GENERIC(L"DefaultMCCSelectionDraw")
BEGIN_COM_MAP(DefaultMCCSelectionDraw)
	COM_INTERFACE_ENTRY(DIDefaultMCCSelectionDraw)
	COM_INTERFACE_ENTRY(IMCCSelectionDraw)
	COM_INTERFACE_ENTRY(IDefaultSink)
	COM_INTERFACE_ENTRY(INeedOnePointer)
	COM_INTERFACE_ENTRY(IPersistStream)
END_COM_MAP()
// DIDefaultMCCSelectionDraw
	STDMETHODIMP Initialize(DIMCCLayer *grappleLayer);
	STDMETHODIMP put_GrappleClass(BSTR val);
// IMCCSelectionDraw
	STDMETHODIMP Show();
	STDMETHODIMP Hide();
// IDefaultSink
	STDMETHODIMP StartSink(IUnknown *u) {
		u->QueryInterface(riidret(&m_subject));
		return S_OK;
	}
// INeedOnePointer
	STDMETHODIMP TakePointer(IUnknown *p,IMoniker *m);
// IPersistStream
	STDMETHODIMP GetClassID(CLSID *ret);
	STDMETHODIMP IsDirty(void);
	STDMETHODIMP Load(IStream *pStm);
	STDMETHODIMP Save(IStream *pStm,BOOL fClearDirty);
	STDMETHODIMP GetSizeMax(ULARGE_INTEGER *pcbSize);
};