/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#ifndef __DEFAULTTRANSFORM_H_
#define __DEFAULTTRANSFORM_H_

#include "resource.h"       // main symbols

// a lightweight transform that uses GetDeviceCaps info to translate.  It ignores the extent
// of the container and the values of any site rects.

// hmm, it's not really default.  But it's used for the tool panel!

/////////////////////////////////////////////////////////////////////////////
// DefaultTransform
class ATL_NO_VTABLE DefaultTransform :
	public CComObjectRoot,
	public CComCoClass<DefaultTransform, &CLSID_MCCDefaultTransform>,
	public IMCCTransform,
	public IPersist
{
public:
	DefaultTransform();
	~DefaultTransform();

	REGISTER_GENERIC(L"DefaultTransform")

BEGIN_COM_MAP(DefaultTransform)
	COM_INTERFACE_ENTRY(IMCCTransform)
	COM_INTERFACE_ENTRY(IPersist)
END_COM_MAP()

// IMCCTransform
	STDMETHODIMP put_TransformedArea(RECT *val);
	STDMETHODIMP get_TransformedArea(RECT *val);
	STDMETHODIMP put_Extent(SIZEL *val);
	STDMETHODIMP get_Extent(SIZEL *val);
	STDMETHODIMP Viewing(LPCRECTL lpcrOut, LPCRECTL lpcrCanv);
	STDMETHODIMP get_IsViewing(VARIANT_BOOL *ret);
	STDMETHODIMP C2WS(SIZEL siz, PSIZE psiz);
	STDMETHODIMP C2VS(SIZEL siz, PSIZE psiz);
	STDMETHODIMP W2CS(SIZE siz, PSIZEL psiz);
	STDMETHODIMP C2WP(POINTL pt, PPOINT ppt);
	STDMETHODIMP C2VP(POINTL pt, PPOINT ppt);
	STDMETHODIMP W2CP(POINT pt, PPOINTL ppt);
	STDMETHODIMP C2WR(LPCRECTL pcr, PRECT prc);
	STDMETHODIMP C2VR(LPCRECTL pcr, PRECT prc);
	STDMETHODIMP W2CR(LPCRECT pcr, PRECTL prc);
	STDMETHODIMP AddRect(LPCRECTL r);
	STDMETHODIMP RemoveRect(LPCRECTL r);
// IPersist
	STDMETHODIMP GetClassID(CLSID *pcls);
};

#endif //__DEFAULTTRANSFORM_H_
