/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "stdafx.h"
#include "Container.h"

// site must have layer pointer
#define LAYER ((Site*)this)->m_pLayer
STDMETHODIMP dispnub::GetTypeInfoCount(UINT *pctinfo) {
	IMETHTRACE(Site,IDispatch,GetTypeInfoCount);
	if(m_ambiance)
		return m_ambiance->GetTypeInfoCount(pctinfo);
	else if(LAYER && LAYER->m_defaultStyle)
		return LAYER->m_defaultStyle->GetTypeInfoCount(pctinfo);
	else
		ERR(E_FAIL);
}
STDMETHODIMP dispnub::GetTypeInfo(UINT iTInfo,LCID lcid,ITypeInfo **ppTInfo) {
	IMETHTRACE(Site,IDispatch,GetTypeInfo);
	if(m_ambiance)
		return m_ambiance->GetTypeInfo(iTInfo,lcid,ppTInfo);
	else if(LAYER && LAYER->m_defaultStyle)
		return LAYER->m_defaultStyle->GetTypeInfo(iTInfo,lcid,ppTInfo);
	else
		ERR(E_FAIL);
}
STDMETHODIMP dispnub::GetIDsOfNames(REFIID riid,LPOLESTR *rgszNames,UINT cNames,LCID lcid,
						 DISPID *rgDispId) {
	IMETHTRACE(Site,IDispatch,GetIDsOfNames);
	if(m_ambiance)
		return m_ambiance->GetIDsOfNames(riid,rgszNames,cNames,lcid,rgDispId);
	else if(LAYER && LAYER->m_defaultStyle)
		return LAYER->m_defaultStyle->GetIDsOfNames(riid,rgszNames,cNames,lcid,rgDispId);
	else
		ERR(E_FAIL);
}
STDMETHODIMP dispnub::Invoke(DISPID dispIdMember,REFIID riid,LCID lcid,WORD wFlags,DISPPARAMS *pDispParams,
				  VARIANT *pVarResult,EXCEPINFO *pExcepInfo,UINT *puArgErr) {
	IMETHTRACE(Site,IDispatch,Invoke);
	if(m_ambiance)
		return m_ambiance->Invoke(dispIdMember,riid,lcid,wFlags,pDispParams,pVarResult,pExcepInfo,puArgErr);
	else if(LAYER && LAYER->m_defaultStyle)
		return LAYER->m_defaultStyle->Invoke(dispIdMember,riid,lcid,wFlags,pDispParams,pVarResult,pExcepInfo,puArgErr);
	else
		ERR(E_FAIL);
}
