/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "stdafx.h"
#include "DropSource.h"
// IMCCDropSource
STDMETHODIMP DropSource::StartDrag(DWORD button) {
	METHTRACE(DropSource,StartDrag);
	m_button = button;
	return S_OK;
}
// IDropSource
STDMETHODIMP DropSource::QueryContinueDrag(BOOL fEscapePressed,DWORD grfKeyState) {
	METHTRACE(DropSource,QueryContinueDrag);
	// if escape pressed, cancel
	if(fEscapePressed)
		return DRAGDROP_S_CANCEL;
	// if a new button is pressed, cancel
	if(grfKeyState&(m_button^(MK_LBUTTON|MK_MBUTTON|MK_RBUTTON)))
		return DRAGDROP_S_CANCEL;
	// if the original button was released, drop
	if(!(grfKeyState&m_button))
		return DRAGDROP_S_DROP;
	// otherwise continue...
	return S_OK;
}
STDMETHODIMP DropSource::GiveFeedback(DWORD dwEffect) {
	METHTRACE(DropSource,GiveFeedback);
	return DRAGDROP_S_USEDEFAULTCURSORS;
}
