/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


class EmbedUnpacker :
	public CComObjectRoot,
	public CComCoClass<EmbedUnpacker,&CLSID_MCCEmbedUnpacker>,
	public IMCCDataObjectUnpacker,
	public IMCCEmbedUnpacker,
	public IDispatchImpl<DIMCCEmbedUnpacker>,
	public INeedSomePointers,
	public IPersist
{
	CComPtr<IMCCLayer> m_layer;
	CComPtr<IMoniker> m_mkCacheInit, m_mkRunInit;
public:
	EmbedUnpacker();
	~EmbedUnpacker();
	REGISTER_GENERIC(L"EmbedUnpacker")
BEGIN_COM_MAP(EmbedUnpacker)
	COM_INTERFACE_ENTRY(IMCCDataObjectUnpacker)
	COM_INTERFACE_ENTRY(IMCCEmbedUnpacker)
	COM_INTERFACE_ENTRY(DIMCCEmbedUnpacker)
	COM_INTERFACE_ENTRY(INeedSomePointers)
	COM_INTERFACE_ENTRY(IPersist)
END_COM_MAP()
// IMCCDataObjectUnpacker
	STDMETHODIMP UnpackOne(IDataObject *data, FORMATETC *fetc, LPOLESTR baseName, IItemSet *iset, IMCCSitePersistor **ret);
	STDMETHODIMP UnpackMany(IDataObject *data, FORMATETC *fetc, IItemSet *iset, IEnumUnknown **ret);
	STDMETHODIMP Query(IDataObject *data);
// IMCCEmbedUnpacker
	STDMETHODIMP Initialize(IMCCDataObjectReader *reader, IMCCLayer *layer);
// DIMCCEmbedUnpacker
	STDMETHODIMP Initialize(IUnknown *reader, IUnknown *layer);
// INeedSomePointers
	STDMETHODIMP TakePointers(IEnumUnknown *os,IEnumMoniker *ms);
// IPersist
	STDMETHODIMP GetClassID(CLSID *ret) {
		*ret = GetObjectCLSID();
		return S_OK;
	}
};
