/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


struct FilePort :
	CComObjectRoot,
	CComCoClass<FilePort,&CLSID_MCCFilePort>,
	IMCCFilePort,
	IMCCFileFormat,
	IPersistStream
{
	REGISTER_GENERIC(L"FilePort")

	typedef vector<wstring> descVec;
	descVec m_impDescs, m_expDescs;
	typedef map<wstring, CComPtr<IMCCFileFormat>, lessWstring> extMap;
	wstring m_nativeIn,m_nativeOut;
	extMap m_import,m_export;
	CComPtr<IMCCFileFormat> m_create;
	extMap &getMap(enum MFP_PORTTYPE type) {
		switch(type) {
		case MFP_IMPORT: return m_import;
		case MFP_EXPORT: return m_export;
		default: return *(extMap*)0;
		}
	}

	FilePort();
	~FilePort();

BEGIN_COM_MAP(FilePort)
	COM_INTERFACE_ENTRY(IMCCFilePort)
	COM_INTERFACE_ENTRY(IMCCFileFormat)
	COM_INTERFACE_ENTRY(IPersist)
	COM_INTERFACE_ENTRY(IPersistStream)
END_COM_MAP()

	typedef HRESULT (__stdcall IMCCFileFormat::*ffFun)(LPCOLESTR);

// IMCCFilePort
	STDMETHODIMP RegisterFileFormat(enum MFP_PORTTYPE type, LPCOLESTR desc, IMCCFileFormat *handler);
	STDMETHODIMP RegisterNativeFileFormat(enum MFP_PORTTYPE type,LPOLESTR desc);
	STDMETHODIMP UnregisterFileFormat(enum MFP_PORTTYPE type, LPCOLESTR desc);
	STDMETHODIMP EnumDescriptions(enum MFP_PORTTYPE type, IEnumString **ret);
// IMCCFileFormat
	STDMETHODIMP Import(LPCOLESTR filename);
	STDMETHODIMP Export(LPCOLESTR filename);
// IPersistStream
	STDMETHODIMP GetClassID(CLSID *ret);
	STDMETHODIMP IsDirty(void);
	STDMETHODIMP Load(IStream *pStm);
	STDMETHODIMP Save(IStream *pStm,BOOL fClearDirty);
	STDMETHODIMP GetSizeMax(ULARGE_INTEGER *pcbSize);
};