/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


struct FireHelper : IDispatch
{
	IID m_iid;
	CComPtr<IConnectionPoint> m_point;
	// would have liked to use CComTypeInfoHolder but those have to be static.
	CComPtr<ITypeInfo> m_typeInfo;
// straight IDispatch
	STDMETHODIMP GetIDsOfNames(
			REFIID,
			OLECHAR FAR* FAR*  rgszNames,
			unsigned int  cNames,
			LCID,
			DISPID FAR*  rgDispId) {
		if(!m_typeInfo)
			ERR(E_UNEXPECTED);
		return m_typeInfo->GetIDsOfNames(rgszNames,cNames,rgDispId);
	}
	STDMETHODIMP GetTypeInfo(
			unsigned int,
			LCID,
			ITypeInfo FAR* FAR*  ppTInfo) {
		if(!m_typeInfo)
			ERR(E_UNEXPECTED);
		(*ppTInfo = m_typeInfo)->AddRef();
		return S_OK;
	}
	STDMETHODIMP GetTypeInfoCount(unsigned int FAR*  pctinfo) {
		*pctinfo = 1;
		return S_OK;
	}
	STDMETHODIMP Invoke(
			DISPID  dispIdMember,
			REFIID  riid,
			LCID  lcid,
			WORD  wFlags,
			DISPPARAMS FAR*  pDispParams,
			VARIANT FAR*  pVarResult,
			EXCEPINFO FAR*  pExcepInfo,
			unsigned int FAR*  puArgErr);
};
struct Firer : CComObjectRoot,
	CComCoClass<Firer,&CLSID_MCCEventFirer>,
	IDispatchImpl<DIMCCEventFirer>,
	FireHelper
{
	REGISTER_GENERIC(L"EventFirer")

BEGIN_COM_MAP(Firer)
	COM_INTERFACE_ENTRY(DIMCCEventFirer)
	COM_INTERFACE_ENTRY2(IDispatch,FireHelper)
END_COM_MAP()
// DIMCCFirer
	STDMETHODIMP Initialize(BSTR strLibid,short major, short minor, BSTR strIid);
	STDMETHODIMP put_Subject(IUnknown *u);
};
