/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


class Hatchling {
	static LPCSTR lpszClassName;
	static bool bRegged;
	static LRESULT CALLBACK WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);

	class GrabHandle {
		int size;
		RECT rcCntr;
	public:
		int n;
		RECT rc;
		GrabHandle(const RECT &rcCntr, int size) : rcCntr(rcCntr), size(size) {
			rc.left = rcCntr.left; rc.top = rcCntr.top;
			rc.right = rcCntr.left+size; rc.bottom = rcCntr.top + size;
			n = 0;
		}
		bool next();
	};
	int which_un(POINT pt) {
		RECT fullRect = rect();
		GrabHandle gh(fullRect,m_size);
		do
			if(PtInRect(&gh.rc,pt))
				break;
		while(gh.next());
		return gh.n;
	}
	// no refcounting because we're just agent for CC
	Container *m_montage;
	POINT m_ptDown;
	int m_currgrab;
	bool m_bCapture;
	bool m_bGrabbers;
	HWND m_hWnd;
public:
	HWND Wnd() { return m_hWnd; }
	RECT rect() {
		RECT ret;
		GetClientRect(m_hWnd,&ret);
		return ret;
	}
	void fit(const RECT& pos,const RECT& clip);
	int m_size;
	Hatchling(Container *montage, HWND hParentWnd,bool bGrabbers,int size, bool show);
	~Hatchling();
};
