/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "stdafx.h"
#include "Container.h"

STDMETHODIMP Container::SetBrowseContext(IHlinkBrowseContext * pihlbc) {
	METHTRACE(Container,SetBrowseContext);
	m_browseContext = pihlbc;
	return S_OK;
}
STDMETHODIMP Container::GetBrowseContext(IHlinkBrowseContext ** ppihlbc) {
	METHTRACE(Container,GetBrowseContext);
	m_browseContext.CopyTo(ppihlbc);
	return S_OK;
}
STDMETHODIMP Container::Navigate(DWORD grfHLNF,LPCWSTR pwzJumpLocation) {
	METHTRACE(Container,Navigate);
	return S_OK;
}
STDMETHODIMP Container::GetMoniker(LPCWSTR pwzLocation,DWORD dwAssign,IMoniker ** ppimkLocation) {
	METHTRACE(Container,GetMoniker);
	ERR(E_NOTIMPL);
}
STDMETHODIMP Container::GetFriendlyName(LPCWSTR pwzLocation,LPWSTR * ppwzFriendlyName) {
	METHTRACE(Container,GetFriendlyName);
	const WCHAR *yo = L"Chum(p)";
	*ppwzFriendlyName = (WCHAR*)CoTaskMemAlloc(wcslen(yo)*2+2);
	wcscpy(*ppwzFriendlyName,yo);
	return S_OK;
}