/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "stdafx.h"
#include "Montage.h"
#include "Indicator.h"

/////////////////////////////////////////////////////////////////////////////
// Indicator
Indicator::Indicator()
{
	CONSTRUCTORTRACE(Indicator);
	m_font = CreateFont(12,0,0,0,FW_THIN,false,false,false,DEFAULT_CHARSET,
		OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,FF_ROMAN,
		"Times New Roman");
}
Indicator::~Indicator() {
	DESTRUCTORTRACE(Indicator);
	DeleteObject(m_font);
}


HRESULT Indicator::OnDraw(ATL_DRAWINFO& di) {
	USES_CONVERSION;
	RECT& rc = *(RECT*)di.prcBounds;
	if(m_text.Length()) {
		HFONT old = (HFONT)SelectObject(di.hdcDraw,m_font);
		DrawText(di.hdcDraw,OLE2T(m_text),m_text.Length(),&rc,DT_WORDBREAK);
		SelectObject(di.hdcDraw,old);
	}
	return S_OK;
}
