/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#ifndef __INDICATOR_H_
#define __INDICATOR_H_

#include "resource.h"       // main symbols
#include <atlctl.h>


/////////////////////////////////////////////////////////////////////////////
// Indicator
class ATL_NO_VTABLE Indicator :
	public CComObjectRoot,
	public IDispatchImpl<IIndicator, &IID_IIndicator, &LIBID_Montage>,
	public CComControl<Indicator>,
	public IPersistStreamInitImpl<Indicator>,
	public IOleControlImpl<Indicator>,
	public IOleObjectImpl<Indicator>,
	public IOleInPlaceActiveObjectImpl<Indicator>,
	public IViewObjectExImpl<Indicator>,
	public IOleInPlaceObjectWindowlessImpl<Indicator>,
	public CComCoClass<Indicator, &CLSID_Indicator>
{
	CComBSTR m_text;
	HFONT m_font;
public:
	REGISTER_GENERIC(L"Indicator")
	Indicator();
	~Indicator();
DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(Indicator)
	COM_INTERFACE_ENTRY(IIndicator)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
END_COM_MAP()

BEGIN_PROP_MAP(Indicator)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_MSG_MAP(Indicator)
	CHAIN_MSG_MAP(CComControl<Indicator>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



// IViewObjectEx
	DECLARE_VIEW_STATUS(0)

// IIndicator
	STDMETHODIMP put_Text(BSTR val) {
        METHTRACE(Indicator,put_Text);
		m_text = val;
		RUN(FireViewChange());
		return S_OK;
	}

	HRESULT OnDraw(ATL_DRAWINFO& di);
};

#endif //__INDICATOR_H_
