/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


class ATL_NO_VTABLE InitList :
	public CComCoClass<InitList,&CLSID_MCCInitList>,
	public CComObjectRoot,
	public IInitializeOther,
	public IGroupItem
{
protected:
	CComPtr<IUnknown> m_list;
	CComPtr<IGroup> m_group;
public:
	InitList();
	~InitList();
	REGISTER_GENERIC(L"InitList")
	DECLARE_PROTECT_FINAL_CONSTRUCT( )

BEGIN_COM_MAP(InitList)
	COM_INTERFACE_ENTRY(IInitializeOther)
	COM_INTERFACE_ENTRY(IGroupItem)
	COM_INTERFACE_ENTRY_AGGREGATE_BLIND(m_list.p)
END_COM_MAP()

	HRESULT FinalConstruct() {
		return CREATEA(m_list,CLSID_OrderedItemList,(IInitializeOther*)this);
	}
	HRESULT FinalRelease() {
		m_list.Release();
		return S_OK;
	}
// IInitializeOther
	STDMETHODIMP InitializeOther(IUnknown *other);
// IGroupItem
	STDMETHODIMP Connect(IGroup *group);
	STDMETHODIMP Copy(IBindCtx *bctx, IGroup *dest, IUnknown *aggr, REFIID riid, void **ret);
	STDMETHODIMP Realize(IBindCtx *bctx);
	STDMETHODIMP Remove();
};