/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


class ItemSetActivator :
	public CComObjectRoot,
	public CComCoClass<ItemSetActivator,&CLSID_MCCItemSetActivator>,
	public IMCCItemSetActivator,
	public IDispatchImpl<DIMCCItemSetActivator>,
	public IItemSetEvents,
	public INeedSomePointers,
	public IPersist
{
	CComPtr<IMoniker> m_mkGroup;
	CComPtr<IItemSet> m_selection;
	bool m_amStarted;
	DWORD m_hydrox;
	CComPtr<IMCCLayer> m_mainl,m_activel;

	HRESULT bind(IMoniker *mk,IMCCSite **ret);
	HRESULT activate(IMoniker *mk);
	HRESULT deactivate(IMoniker *mk);
public:
	ItemSetActivator();
	~ItemSetActivator();
	REGISTER_GENERIC(L"ItemSetActivator")
BEGIN_COM_MAP(ItemSetActivator)
	COM_INTERFACE_ENTRY(IMCCItemSetActivator)
	COM_INTERFACE_ENTRY(DIMCCItemSetActivator)
	COM_INTERFACE_ENTRY(IItemSetEvents)
	COM_INTERFACE_ENTRY(INeedSomePointers)
	COM_INTERFACE_ENTRY(IPersist)
END_COM_MAP()
// IMCCItemSetActivator
	STDMETHODIMP Initialize(IItemSet *selection,IMCCLayer *mainl, IMCCLayer *activel);
	STDMETHODIMP Activate(IMCCSite *s);
	STDMETHODIMP Deactivate(IMCCSite *s);
	STDMETHODIMP Start();
	STDMETHODIMP Stop();
	STDMETHODIMP NoUI();
// DIMCCItemSetActivator
	STDMETHODIMP Initialize(DIItemSet *selection,DIMCCLayer *mainl, DIMCCLayer *activel);
// IItemSetEvents
	STDMETHODIMP Added(IMoniker *mk);
	STDMETHODIMP Removed(IMoniker *mk);
// INeedSomePointers
	STDMETHODIMP TakePointers(IEnumUnknown *os,IEnumMoniker *ms);
// IPersist
	STDMETHODIMP GetClassID(CLSID *ret) {
		*ret = GetObjectCLSID();
		return S_OK;
	}
};
