/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


class ItemSetDrawer :
	public CComObjectRoot,
	public CComCoClass<ItemSetDrawer,&CLSID_MCCItemSetDrawer>,
	public IItemSetEvents,
	public IMCCItemSetDrawer,
	public IDispatchImpl<DIMCCItemSetDrawer>,
	public INeedSomePointers,
	public IPersistStream
{
	friend struct SelectedOwner;
	CComPtr<IMoniker> m_mkGroup; // all I glean from mc.  weird.
	HRESULT bind(IMoniker *mk, IMCCSite **ret);
	bool m_amDrawing;
	CComPtr<IItemSet> m_set;
public:
	ItemSetDrawer();
	~ItemSetDrawer();
	REGISTER_GENERIC(L"ItemSetDrawer")
BEGIN_COM_MAP(ItemSetDrawer)
	COM_INTERFACE_ENTRY(IItemSetEvents)
	COM_INTERFACE_ENTRY(IMCCItemSetDrawer)
	COM_INTERFACE_ENTRY(DIMCCItemSetDrawer)
	COM_INTERFACE_ENTRY(INeedSomePointers)
	COM_INTERFACE_ENTRY(IPersist)
	COM_INTERFACE_ENTRY(IPersistStream)
END_COM_MAP()
// IMCCItemSetDrawer
	STDMETHODIMP Initialize(IMontageContainer *mc, IItemSet *set);
	STDMETHODIMP Start();
	STDMETHODIMP Stop();
// DIMCCItemSetDrawer
	STDMETHODIMP Initialize(DIMontageContainer *mc, DIItemSet *iset);
// INeedSomePointers
	STDMETHODIMP TakePointers(IEnumUnknown *os,IEnumMoniker *ms);
// IItemSetEvents
	STDMETHODIMP Added(IMoniker *mk);
	STDMETHODIMP Removed(IMoniker *mk);
// IPersistStream
	STDMETHODIMP GetClassID(CLSID *ret);
	STDMETHODIMP IsDirty(void);
	STDMETHODIMP Load(IStream *pStm);
	STDMETHODIMP Save(IStream *pStm,BOOL fClearDirty);
	STDMETHODIMP GetSizeMax(ULARGE_INTEGER *pcbSize);
};