/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// no particular reason this isn't ATL.  just cuz.
struct Layer :
	public IMCCLayer,
	public IDispatchImpl<DIMCCLayer>,
	public IPropertyNotifySink
{
	ULONG m_ct;
	CComPtr<IUnknown> m_points;
	Container *m_cont;
	CComPtr<IMoniker> m_mkPersistor, m_mkOrder;
	sitelist m_sites; // front is front
	CComPtr<IDispatch> m_defaultStyle;
	bool m_amTransformed;
	DWORD m_sugarWafer;

	Layer(Container *pCont);
	~Layer();
	HRESULT construct();
// IUnknown
	STDMETHODIMP_(ULONG) AddRef();
	STDMETHODIMP_(ULONG) Release();
	STDMETHODIMP QueryInterface(REFIID riid,void **ppRet);
// IMCCLayer
	STDMETHODIMP GetContainer(REFIID riid, void **ret);
	STDMETHODIMP get_RelMoniker(IMoniker **ret);
	STDMETHODIMP put_RelMoniker(IMoniker *val);
	STDMETHODIMP get_OrderMk(IMoniker **ret);
	STDMETHODIMP put_OrderMk(IMoniker *val);
	STDMETHODIMP get_IsTransformed(VARIANT_BOOL *ret);
	STDMETHODIMP put_IsTransformed(VARIANT_BOOL val);
	STDMETHODIMP get_DefaultAmbiance(IDispatch **style);
	STDMETHODIMP put_DefaultAmbiance(IDispatch *style);
	STDMETHODIMP get_Z(long *ret);
	STDMETHODIMP PutBefore(IMCCLayer *other);
	STDMETHODIMP PutBehind(IMCCLayer *other);
	STDMETHODIMP Delete();
	STDMETHODIMP FindControl(POINT pt, IMCCSite **ppSite);
	STDMETHODIMP FindControls(LPCRECT lpcr, IEnumMCCSites **ret);
	STDMETHODIMP EnumSites(IEnumMCCSites **ret);
// DIMCCLayer
	STDMETHODIMP get_Container(DIMontageContainer **ret);
	STDMETHODIMP get_RelMoniker(IUnknown **ret);
	STDMETHODIMP put_RelMoniker(IUnknown *val);
	STDMETHODIMP get_OrderMk(IUnknown **ret);
	STDMETHODIMP put_OrderMk(IUnknown *val);
	STDMETHODIMP PutBefore(DIMCCLayer *other);
	STDMETHODIMP PutBehind(DIMCCLayer *other);
	STDMETHODIMP FindControl(long x, long y, DIMCCSite **ret);
	STDMETHODIMP FindControls(long left,long top, long right, long bottom, IDispatch **ret);
	STDMETHODIMP Sites(IDispatch **ret);
// IPropertyNotifySink
	STDMETHODIMP OnChanged(DISPID id);
	STDMETHODIMP OnRequestEdit(DISPID id);
};
inline HRESULT createLayer(Container *mc, Layer **ret) {
	HRESULT hr;
	*ret = new Layer(mc);
	if(FAILED(hr = (*ret)->construct())) {
		delete *ret;
		*ret = 0;
		return hr;
	}
	return S_OK;
}
typedef list<Layer*> layerlist;
