/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


class ATL_NO_VTABLE LayerPersistor :
	public CComCoClass<LayerPersistor,&CLSID_MCCLayerPersistor>,
	public CComObjectRoot,
	public IDispatchImpl<DIPersistor>,
	public IMCCLayerPersistor,
	public IDispatchImpl<DIMCCLayerPersistor>,
	public IGroupItem,
	public IPersistStream
{
	CComPtr<IGroup> m_group;
	CComPtr<IMoniker> m_mkSelf,m_mkMontage,m_mkLayerOrdering,m_mkSiteOrdering,m_mkAmbience;
	CComQIPtr<IMCCLayer> m_subject;

	// cached for object
	VARIANT_BOOL m_isTransformed;
	bool m_inserted;
	long m_Z;
public:
	LayerPersistor();
	~LayerPersistor();
	REGISTER_GENERIC(L"LayerOrder")
BEGIN_COM_MAP(LayerPersistor)
	COM_INTERFACE_ENTRY(DIPersistor)
	COM_INTERFACE_ENTRY(IMCCLayerPersistor)
	COM_INTERFACE_ENTRY(DIMCCLayerPersistor)
	COM_INTERFACE_ENTRY(IGroupItem)
	COM_INTERFACE_ENTRY(IPersist)
	COM_INTERFACE_ENTRY(IPersistStream)
END_COM_MAP()

// IPersistor
	STDMETHODIMP SetSubject(VARIANT_BOOL realized,IUnknown *pUnkSite);
	STDMETHODIMP get_Subject(IUnknown **ret);
// IMCCLayerPersistor
	STDMETHODIMP Initialize(IMoniker *mkMontage, IMoniker *mkLayerOrdering,
		IMoniker *mkSiteOrdering, IMoniker *mkDefaultAmbience);
	STDMETHODIMP put_SelfMk(IMoniker *val);
// DIMCCLayerPersistor
	STDMETHODIMP Initialize(IUnknown *mkMontage,
		IUnknown *mkLayerOrdering, IUnknown *mkSiteOrdering,
		IUnknown *mkDefaultAmbience);
	STDMETHODIMP put_SelfMk(IUnknown *val);
//IGroupItem
	STDMETHODIMP Connect(IGroup *group);
	STDMETHODIMP Copy(IBindCtx *bctx, IGroup *dest, IUnknown *aggr, REFIID riid, void **ret);
	STDMETHODIMP Realize(IBindCtx *bctx);
	STDMETHODIMP Remove();
// IPersistStream
	STDMETHODIMP GetClassID(CLSID *pClassID);
	STDMETHODIMP IsDirty(void);
	STDMETHODIMP Load(IStream *pStm);
	STDMETHODIMP Save(IStream *pStm,BOOL fClearDirty);
	STDMETHODIMP GetSizeMax(ULARGE_INTEGER *pcbSize);
};
