/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "MontageConfig.h"
#include "ensureNativeFormat.h"
struct MontageManual : MontageConfig<MontageManual,&CLSID_MontageManualLayout,
	MontageCreator<&CLSID_MontageControlContainer,&CLSID_MCCBootStandard>,IDR_MontageApp> {
BEGIN_REGMAP()
	REGMAP_GUID(L"CLSID",CLSID_MontageManualLayout)
	REGMAP_GUID(L"TypeLib",LIBID_Montage)
	REGMAP_STRING(L"DocName",L"Montage Canvas")
	REGMAP_STRING(L"AppName",L"Montage")
	REGMAP_STRING(L"Short",L"Canvas")
	REGMAP_STRING(L"ProgID",L"Montage.Manual.1")
	REGMAP_STRING(L"VersIndProgID",L"Montage.Manual")
	REGMAP_FUN(L"ProgDir",progdirString)
	REGMAP_STRING(L"DefaultExt",L".mon,Montage Canvas (.mon)")
	REGMAP_STRING(L"Extra",
	L"HKCR { '.mon' = s 'Montage.Manual'  { val 'Content Type' = s 'application/montage' } "
			L"NoRemove MIME { NoRemove Database { NoRemove 'Content Type' { application/montage { val Extension = s '.mon' } } } } }")
END_REGMAP()
	static HRESULT moreReg() {
		return ensureNativeFormat(L"mon");
	}
};
