/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "ModeSwitcher.h"

class ATL_NO_VTABLE ModeDelegate :
	public CComObjectRoot,
	public IDispatchImpl<DIMCCModeDelegate>,
	public IPersistStream,
	public IConnectionPointImpl<ModeDelegate,&IID_IMCCMode>,
	public IConnectionPointContainerImpl<ModeDelegate>
{
	friend class ModeSwitcher;
	typedef ModeSwitcher::delOrder delOrder;
	typedef IConnectionPointImpl<ModeDelegate,&IID_IMCCMode> CP;
	ModeSwitcher *m_switcher;
	CComBSTR m_name;
	long m_order;
	bool m_shown;

	HRESULT releaseSinks();
	HRESULT insert();
	HRESULT remove();
public:
	ModeDelegate();
	~ModeDelegate();

BEGIN_COM_MAP(ModeDelegate)
	COM_INTERFACE_ENTRY(DIMCCModeDelegate)
	COM_INTERFACE_ENTRY(IPersist)
	COM_INTERFACE_ENTRY(IPersistStream)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
END_COM_MAP()
BEGIN_CONNECTION_POINT_MAP(ModeDelegate)
	CONNECTION_POINT_ENTRY(IID_IMCCMode)
END_CONNECTION_POINT_MAP()
// DIMCCModeDelegate
	STDMETHODIMP get_Name(BSTR *ret);
	STDMETHODIMP put_Name(BSTR val);
	STDMETHODIMP get_Order(long *ret);
	STDMETHODIMP put_Order(long val);
	STDMETHODIMP get_State(long *ret);
	STDMETHODIMP Show();
	STDMETHODIMP Hide();
	STDMETHODIMP Delete();
	STDMETHODIMP Activate(VARIANT_BOOL once);
	STDMETHODIMP Done();
// IPersistStream
	STDMETHODIMP GetClassID(CLSID *pClassID);
	STDMETHODIMP IsDirty(void);
	STDMETHODIMP Load(IStream *pStm);
	STDMETHODIMP Save(IStream *pStm,BOOL fClearDirty);
	STDMETHODIMP GetSizeMax(ULARGE_INTEGER *pcbSize);
};
