/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#ifndef MODESWITCHER_H
#define MODESWITCHER_H

#include <objidl.h>
#include "FactoryActivator.h"
class ModeDelegate;
class ATL_NO_VTABLE ModeSwitcher :
	public CComObjectRoot,
	public CComCoClass<ModeSwitcher,&CLSID_MCCModeSwitcher>,
	public IMCCModeSwitcher,
	public IDispatchImpl<DIMCCModeSwitcher>,
	public IConnectionPointContainerImpl<ModeSwitcher>,
	public IConnectionPointImpl<ModeSwitcher,&IID_IMCCModeSwitcherEvents>,
	public IClassFactoryImpl<ModeSwitcher,&CLSID_MCCModeDelegate>,
	public IClassActivatorImpl<ModeSwitcher,&CLSID_MCCModeDelegate>,
	public IPersist
{
	friend class ModeDelegate;
	enum {switcher_none,switcher_active,switcher_onetime} m_state;
	typedef multimap<int,ModeDelegate*> delOrder;
	delOrder m_delegates;
	DIMCCModeDelegate *m_active, *m_once;

	void reorderEvent();
	void activateEvent(DIMCCModeDelegate *mode, BOOL once);
public:
	ModeSwitcher();
	~ModeSwitcher();

DECLARE_PROTECT_FINAL_CONSTRUCT()

	REGISTER_GENERIC(L"ModeSwitcher")
BEGIN_COM_MAP(ModeSwitcher)
	COM_INTERFACE_ENTRY(IMCCModeSwitcher)
	COM_INTERFACE_ENTRY(DIMCCModeSwitcher)
	COM_INTERFACE_ENTRY(IClassActivator)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(IPersist)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(ModeSwitcher)
	CONNECTION_POINT_ENTRY(IID_IMCCModeSwitcherEvents)
END_CONNECTION_POINT_MAP()

// IMCCModeSwitcher
	STDMETHODIMP new_Delegate(DIMCCModeDelegate **ret);
	STDMETHODIMP get_ActiveMode(VARIANT_BOOL once, DIMCCModeDelegate **ret);
	STDMETHODIMP EnumDelegates(IEnumMCCModeDelegates **ret);
// for IClassFactoryImpl
	HRESULT CI4Factory(const CLSID&clsid,IUnknown *aggr,REFIID riid,void **ret);
// DIMCCModeSwitcher
	STDMETHODIMP NewDelegate(DIMCCModeDelegate **ret);
	STDMETHODIMP get_Delegates(IDispatch **ret);
	STDMETHODIMP get_DelegateClassMoniker(IUnknown **ret);
// IPersist
	STDMETHODIMP GetClassID(CLSID *pClassID);
};
#endif MODESWITCHER_H
