/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


class ATL_NO_VTABLE MontagePersistor :
	public CComCoClass<MontagePersistor, &CLSID_MontagePersistor>,
	public CComObjectRoot,
	public IMontagePersistor,
	public IDispatchImpl<DIMontagePersistor>,
	public IDispatchImpl<DIPersistor>,
	public IGroupItem,
	public IPersistStreamInit
{
	CComPtr<IGroup> m_group;
	CComQIPtr<IMontageContainer> m_subject;
	bool m_realized; // for "realize this" behavior
	CLSID m_classID;
	VARIANT_BOOL m_useSubjectExtent;
	SIZEL m_extent,m_minExtent;
	CComPtr<IMoniker> m_mkSelf, m_mkTransform,m_mkPanel,m_mkFilePort;
	CComPtr<IItemSet> m_keepSet;
	// holding stuff from Load to Realize
	struct _mpcache {
		CComPtr<IStream> stuff;
		RECT extra,reserved;
		CLSID clsid;
		VARIANT_BOOL autoSize;
		long zoom;
		RECTL margin;
		VARIANT_BOOL alwaysMargin;
	} m_cache;
public:
	MontagePersistor();
	~MontagePersistor();
	REGISTER_GENERIC(L"MontagePersistor")

BEGIN_COM_MAP(MontagePersistor)
	COM_INTERFACE_ENTRY(IMontagePersistor)
	COM_INTERFACE_ENTRY(DIMontagePersistor)
	COM_INTERFACE_ENTRY(DIPersistor)
	COM_INTERFACE_ENTRY(IGroupItem)
	COM_INTERFACE_ENTRY(IPersist)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
END_COM_MAP()

// IMontagePersistor
	STDMETHODIMP put_SelfMoniker(IMoniker *val);
	STDMETHODIMP get_SelfMoniker(IMoniker **ret);
	STDMETHODIMP put_Class(REFCLSID rcls);
	STDMETHODIMP put_UseSubjectExtent(VARIANT_BOOL val);
	STDMETHODIMP put_InitialExtent(SIZEL val);
	STDMETHODIMP get_TransformMk(IMoniker **ret);
	STDMETHODIMP put_TransformMk(IMoniker *val);
	STDMETHODIMP get_ToolPanelMk(IMoniker **ret);
	STDMETHODIMP put_ToolPanelMk(IMoniker *val);
	STDMETHODIMP get_FilePortMk(IMoniker **ret);
	STDMETHODIMP put_FilePortMk(IMoniker *val);
	STDMETHODIMP get_KeepSet(IItemSet **ret);
	STDMETHODIMP put_KeepSet(IItemSet *val);
	STDMETHODIMP ForgetSubject();
// DIMontagePersistor
	STDMETHODIMP put_SelfMoniker(IUnknown *val);
	STDMETHODIMP put_Class(BSTR rcls);
	STDMETHODIMP put_InitialExtent(long cx, long cy);
	STDMETHODIMP get_TransformMk(IUnknown **ret);
	STDMETHODIMP put_TransformMk(IUnknown *val);
	STDMETHODIMP get_ToolPanelMk(IUnknown **ret);
	STDMETHODIMP put_ToolPanelMk(IUnknown *val);
	STDMETHODIMP get_KeepSet(DIItemSet **ret);
	STDMETHODIMP put_KeepSet(DIItemSet *val);
// IPersistor
	STDMETHODIMP SetSubject(VARIANT_BOOL realized,IUnknown *val);
	STDMETHODIMP get_Subject(IUnknown **ret);
//IGroupItem
	STDMETHODIMP Connect(IGroup *group);
	STDMETHODIMP Copy(IBindCtx *bctx, IGroup *dest, IUnknown *aggr, REFIID riid, void **ret);
	STDMETHODIMP Realize(IBindCtx *bctx);
	STDMETHODIMP Remove();
// IPersistStreamInit
	STDMETHODIMP GetClassID(CLSID *pClassID);
	STDMETHODIMP IsDirty(void);
	STDMETHODIMP Load(IStream *pStm);
	STDMETHODIMP Save(IStream *pStm,BOOL fClearDirty);
	STDMETHODIMP GetSizeMax(ULARGE_INTEGER *pcbSize);
	STDMETHODIMP InitNew();
};