/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// OleClientSiteCS.cpp : Implementation of IOleClientSite for
// the simple control site I'm doin' up.

#include "stdafx.h"
#include "Container.h"

STDMETHODIMP Site::SaveObject(void) {
	IMETHTRACE(Site,IOleClientSite,SaveObject);
	return S_OK;
}
STDMETHODIMP Site::GetMoniker(
     DWORD dwAssign,
     DWORD dwWhichMoniker,
     IMoniker **ppmk) {
	IMETHTRACE(Site,IOleClientSite,GetMoniker);
	ERR(E_NOTIMPL);
}
STDMETHODIMP Site::GetContainer(
     IOleContainer **ppContainer) {
	IMETHTRACE(Site,IOleClientSite,GetContainer);
	(*ppContainer = m_cont)->AddRef();
	return S_OK;
}
STDMETHODIMP Site::ShowObject(void) {
	IMETHTRACE(Site,IOleClientSite,ShowObject);
	RECTL plusSome = m_virtRect;  // try to make .5cm around object is visible
	FlateRect(plusSome,500,500);
	RUN(fireEvent(m_cont->GetUnknown(),fireOneParam<IMontageContainerEvents,LPCRECTL>(&IMontageContainerEvents::ShowArea,&plusSome)));
	return S_OK;
}
STDMETHODIMP Site::OnShowWindow(BOOL fShow) {
	IMETHTRACE(Site,IOleClientSite,OnShowWindow);
	if(fShow&&m_state==MCCS_SHOWN) {
		m_state = m_intent = MCCS_OPEN;
		stateEvent(MCCS_SHOWN,MCCS_OPEN);
	}
	else if(!fShow && m_state==MCCS_OPEN) {
		m_state = m_intent = MCCS_SHOWN;
		stateEvent(MCCS_OPEN,MCCS_SHOWN);
	}
	return S_OK;
}
STDMETHODIMP Site::RequestNewObjectLayout(void) {
	IMETHTRACE(Site,IOleClientSite,RequestNewObjectLayout);
#define IM_SCARED
#ifdef IM_SCARED
	ERR(E_NOTIMPL);
#else
	postCheckSizeMessage();
	return S_OK;
#endif
}
