/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// Implementation of IOleItemContainer for Container
#include "stdafx.h"
#include "Container.h"

//(IParseDisplayName)
STDMETHODIMP Container::ParseDisplayName(
	/* [unique][in] */ IBindCtx __RPC_FAR *pbc,
	/* [in] */ LPOLESTR pszDisplayName,
	/* [out] */ ULONG __RPC_FAR *pchEaten,
	/* [out] */ IMoniker __RPC_FAR *__RPC_FAR *ppmkOut) {
	IMETHTRACE(Container,IOleContainer,ParseDisplayName);
	if(!m_group)
		ERR(E_PENDING);
	return CComQIPtr<IOleItemContainer>(m_group)->ParseDisplayName(pbc,pszDisplayName,pchEaten,ppmkOut);
}

//(IOleContainer)
STDMETHODIMP Container::EnumObjects(
	/* [in] */ DWORD grfFlags,
	/* [out] */ IEnumUnknown __RPC_FAR *__RPC_FAR *ppenum) {
	IMETHTRACE(Container,IOleContainer,EnumObjects);
	if(!m_group)
		ERR(E_PENDING);
	return CComQIPtr<IOleItemContainer>(m_group)->EnumObjects(grfFlags,ppenum);
}

STDMETHODIMP Container::LockContainer(BOOL fLock) {
	IMETHTRACE(Container,IOleContainer,LockContainer);
	return CoLockObjectExternal((IOleContainer*)this,fLock,false);
}
//(IOleItemContainer)
STDMETHODIMP Container::GetObject(LPOLESTR	name,DWORD speed,IBindCtx *bctx,REFIID riid,void **ret) {
	METHTRACE(Container,GetObject);
	if(!m_group)
		ERR(E_PENDING);
	return CComQIPtr<IOleItemContainer>(m_group)->GetObject(name,speed,bctx,riid,ret);
}
STDMETHODIMP Container::GetObjectStorage(LPOLESTR name, IBindCtx *bctx,REFIID riid,void **ret) {
	METHTRACE(Container,GetObjectStorage);
	if(!m_group)
		ERR(E_PENDING);
	return CComQIPtr<IOleItemContainer>(m_group)->GetObjectStorage(name,bctx,riid,ret);
}
STDMETHODIMP Container::IsRunning(LPOLESTR name) {
	METHTRACE(Container,GetObjectStorage);
	if(!m_group)
		ERR(E_PENDING);
	return CComQIPtr<IOleItemContainer>(m_group)->IsRunning(name);
}
