/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


struct Pane :
	CComCoClass<Pane,&CLSID_MCCPane>,
	CComObjectRoot,
	IMCCPane,
    IMontageContainerEvents
{
    bool m_isVert;
    RECT m_rect;
    int m_expander;
    struct PaneInfo {
        IMCCPane *pane;
        int size, xtra;
    };
    vector<PaneInfo> m_panes;
    CComPtr<IMCCSite> m_content;
    int m_spacing;
	RECT m_border;
    CComPtr<DIMontageContainerRef> m_refm;
    DWORD m_eikooc;

    Pane();
    HRESULT recalc();

REGISTER_GENERIC(L"Pane")
BEGIN_COM_MAP(Pane)
    COM_INTERFACE_ENTRY(IMCCPane)
    COM_INTERFACE_ENTRY(IMontageContainerEvents)
END_COM_MAP()

// IMCCPane
	STDMETHODIMP put_Rect(RECT *val);
	STDMETHODIMP get_Rect(RECT *ret);
	STDMETHODIMP put_IsVert(VARIANT_BOOL val);
	STDMETHODIMP get_IsVert(VARIANT_BOOL *ret);
	STDMETHODIMP put_PaneSpacing(int val);
	STDMETHODIMP get_PaneSpacing(int *ret);
	STDMETHODIMP AddPane(int pos,IMCCPane *val);
	STDMETHODIMP RemovePane(int pos);
	STDMETHODIMP get_PaneCount(int *ret);
	STDMETHODIMP get_Pane(int pos,IMCCPane **ret);
	STDMETHODIMP put_PaneSize(int pos,int val);
	STDMETHODIMP get_PaneSize(int pos,int *ret);
    STDMETHODIMP put_PaneXtra(int pos,int val);
    STDMETHODIMP get_PaneXtra(int pos,int *ret);
	STDMETHODIMP put_Border(RECT val);
	STDMETHODIMP get_Border(RECT *ret);
    STDMETHODIMP put_Expander(int val);
    STDMETHODIMP get_Expander(int *ret);
	STDMETHODIMP put_Content(IMCCSite *val);
    STDMETHODIMP get_Content(IMCCSite **ret);
    STDMETHODIMP get_Montage(IMontageContainer **ret);
    STDMETHODIMP put_Montage(IMontageContainer *val);
    STDMETHODIMP DoZ(IMCCSite *back);

// IMontageContainerEvents
	STDMETHODIMP Shutdown();
	STDMETHODIMP Resize(SIZE s);
	STDMETHODIMP NewExtent(SIZEL);
	STDMETHODIMP Viewing(HDC hdc, LPCRECTL lpcrOut, LPCRECTL lpcrCanv);
	STDMETHODIMP NewTransform(IMCCTransform *);
	STDMETHODIMP GroupOp(BOOL);
	STDMETHODIMP SiteDeleted(IMCCSite*);
	STDMETHODIMP LayerDeleted(IMCCLayer*);
	STDMETHODIMP Shifting(long oldState,long newState);
	STDMETHODIMP ShowArea(LPCRECTL r);
    STDMETHODIMP FocusChanged() { return S_FALSE; }
};