/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


struct PaneTitle :
	CComCoClass<PaneTitle,&CLSID_MCCPaneTitle>,
	CComObjectRoot,
	CComControl<PaneTitle>,
	IViewObjectExImpl<PaneTitle>,
	IOleInPlaceObjectWindowlessImpl<PaneTitle>,
	IOleObjectImpl<PaneTitle>,
	IMCCPaneTitle,
	IMCCSiteEvents

{
	CComPtr<IMCCSite> m_content;
	CComBSTR m_text;
	int m_borderSize,m_titleHeight;
	bool m_active;
	OLE_COLOR m_activeBorderColor,m_inactiveBorderColor,m_activeTitleColor,m_inactiveTitleColor,
		m_activeTextColor,m_inactiveTextColor,m_activeBackgroundColor,m_inactiveBackgroundColor;
	CComPtr<IFont> m_font;
    DWORD m_itsIt;


	PaneTitle();
	REGISTER_GENERIC(L"PaneTitle")

BEGIN_COM_MAP(PaneTitle)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY(IMCCPaneTitle)
    COM_INTERFACE_ENTRY(IMCCSiteEvents)
END_COM_MAP()

BEGIN_MSG_MAP(PaneTitle)
	MESSAGE_HANDLER(WM_LBUTTONDOWN, OnLButtonDown)
END_MSG_MAP()
	HRESULT OnDrawAdvanced(ATL_DRAWINFO& di);
	LRESULT OnLButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

    STDMETHODIMP QueryHitPoint(DWORD dwAspect, LPCRECT pRectBounds,POINT ptlLoc,LONG lCloseHint,DWORD *pHitResult) {
        RUN(IViewObjectExImpl<PaneTitle>::QueryHitPoint(dwAspect,pRectBounds,ptlLoc,lCloseHint,pHitResult));
        return S_OK;
    }

// IMCCPaneTitle
	STDMETHODIMP get_Text(BSTR *ret);
	STDMETHODIMP put_Text(BSTR val);
	STDMETHODIMP get_TitleHeight(int *ret);
	STDMETHODIMP put_TitleHeight(int val);
	STDMETHODIMP get_BorderSize(int *ret);
	STDMETHODIMP put_BorderSize(int val);
	STDMETHODIMP get_InactiveBorderColor(OLE_COLOR *ret);
	STDMETHODIMP put_InactiveBorderColor(OLE_COLOR val);
	STDMETHODIMP get_ActiveBorderColor(OLE_COLOR *ret);
	STDMETHODIMP put_ActiveBorderColor(OLE_COLOR val);
	STDMETHODIMP get_InactiveTitleColor(OLE_COLOR *ret);
	STDMETHODIMP put_InactiveTitleColor(OLE_COLOR val);
	STDMETHODIMP get_ActiveTitleColor(OLE_COLOR *ret);
	STDMETHODIMP put_ActiveTitleColor(OLE_COLOR val);
	STDMETHODIMP get_InactiveTextColor(OLE_COLOR *ret);
	STDMETHODIMP put_InactiveTextColor(OLE_COLOR val);
	STDMETHODIMP get_ActiveTextColor(OLE_COLOR *ret);
	STDMETHODIMP put_ActiveTextColor(OLE_COLOR val);
	STDMETHODIMP get_InactiveBackgroundColor(OLE_COLOR *ret);
	STDMETHODIMP put_InactiveBackgroundColor(OLE_COLOR val);
	STDMETHODIMP get_ActiveBackgroundColor(OLE_COLOR *ret);
	STDMETHODIMP put_ActiveBackgroundColor(OLE_COLOR val);
	STDMETHODIMP get_Font(IFont **ret);
	STDMETHODIMP put_Font(IFont *val);
	STDMETHODIMP get_Content(IMCCSite **ret);
	STDMETHODIMP put_Content(IMCCSite *val);
// IMCCSiteEvents
	STDMETHODIMP Moving(LPCRECT winRect);
	STDMETHODIMP Shifting(long oldState, long newState);
	STDMETHODIMP ZChanged();
	STDMETHODIMP Layering(IMCCLayer *newLayer);
};
