/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


class PasteSetUnpacker :
	public CComObjectRoot,
	public CComCoClass<PasteSetUnpacker,&CLSID_MCCPasteSetUnpacker>,
	public IMCCPasteSetUnpacker,
	public IDispatchImpl<DIMCCPasteSetUnpacker>,
	public IMCCDataObjectUnpacker,
	public INeedSomePointers,
	public IPersist
{
    CComPtr<DIMontageContainerRef> m_mref; // semi-circular reference counting
    CComPtr<IMontageContainer> mc()  {
        METHTRACE(PasteSetUnpacker,mc);
        CComPtr<IUnknown> umc;
        RUN(m_mref->get_Montage(&umc));
        return CComQIPtr<IMontageContainer>(umc);
    }
public:
	PasteSetUnpacker();
	~PasteSetUnpacker();
	REGISTER_GENERIC(L"PasteSetUnpacker")
BEGIN_COM_MAP(PasteSetUnpacker)
	COM_INTERFACE_ENTRY(IMCCPasteSetUnpacker)
	COM_INTERFACE_ENTRY(DIMCCPasteSetUnpacker)
	COM_INTERFACE_ENTRY(IMCCDataObjectUnpacker)
	COM_INTERFACE_ENTRY(INeedSomePointers)
	COM_INTERFACE_ENTRY(IPersist)
END_COM_MAP()
// IMCCPasteSetUnpacker
	STDMETHODIMP Initialize(IMontageContainer *mc, IMCCDataObjectReader *reader);
// DIMCCPasteSetUnpacker
	STDMETHODIMP Initialize(IUnknown *mc, IUnknown *reader);
// IMCCDataObjectUnpacker
	STDMETHODIMP UnpackOne(IDataObject *data, FORMATETC *fetc, LPOLESTR baseName, IItemSet *iset, IMCCSitePersistor **ret);
	STDMETHODIMP UnpackMany(IDataObject *data, FORMATETC *fetc, IItemSet *iset, IEnumUnknown **ret);
	STDMETHODIMP Query(IDataObject *data);
// INeedSomePointers
	STDMETHODIMP TakePointers(IEnumUnknown *os,IEnumMoniker *ms);
// IPersist
	STDMETHODIMP GetClassID(CLSID *ret) {
		*ret = GetObjectCLSID();
		return S_OK;
	}
};
