/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#ifndef __PlayControl_H_
#define __PlayControl_H_

#include "resource.h"       // main symbols


/////////////////////////////////////////////////////////////////////////////
// PlayControl
class ATL_NO_VTABLE PlayControl :
	public CComObjectRoot,
	public CComCoClass<PlayControl,&CLSID_MCCPlayControl>,
	public CComControl<PlayControl>,
	public IPersistStreamInitImpl<PlayControl>,
	public IOleControlImpl<PlayControl>,
	public IOleObjectImpl<PlayControl>,
	public IOleInPlaceActiveObjectImpl<PlayControl>,
	public IViewObjectExImpl<PlayControl>,
	public IOleInPlaceObjectWindowlessImpl<PlayControl>,
	public INeedOnePointer,
	public IDispatchImpl<DIMCCPlayControl>
{
	CComPtr<DIMontageContainerRef> m_montage;

public:
	PlayControl();
	~PlayControl();

DECLARE_WND_CLASS("Montage PlayControl")

REGGY_RID(IDR_PlayControl)

BEGIN_COM_MAP(PlayControl)
	COM_INTERFACE_ENTRY(DIMCCPlayControl)
	COM_INTERFACE_ENTRY_IID(IID_IViewObject, IViewObjectEx)
	COM_INTERFACE_ENTRY_IID(IID_IViewObject2, IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY_IID(IID_IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IID(IID_IOleInPlaceObject, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY(INeedOnePointer)
END_COM_MAP()

BEGIN_PROPERTY_MAP(PlayControl)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROPERTY_MAP()


BEGIN_MSG_MAP(PlayControl)
	MESSAGE_HANDLER(WM_PAINT, OnPaint)
	MESSAGE_HANDLER(WM_LBUTTONUP, LButtonUp)
	MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
	MESSAGE_HANDLER(WM_KILLFOCUS, OnKillFocus)
END_MSG_MAP()

	LRESULT LButtonUp(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

// overriden from CComControl, which does not specify WS_CLIPSIBLINGS
	virtual HWND CreateControlWindow(HWND hWndParent, RECT& rcPos) {
		return Create(hWndParent, rcPos, 0, WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS);
	}
// this IOleObjectImpl overload is just a convenient place to put sinking/unsinking
	STDMETHODIMP SetClientSite(IOleClientSite *val);
// IViewObjectEx
	STDMETHODIMP GetViewStatus(DWORD* pdwStatus)
	{
		METHTRACE(IViewObjectExImpl,GetViewStatus);
		*pdwStatus = VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE;
		return S_OK;
	}
// IViewObjectImpl
	HRESULT OnDrawAdvanced(ATL_DRAWINFO& di);
// IOleInPlaceObject
	STDMETHODIMP SetObjectRects(LPCRECT lpcr,LPCRECT);
// INeedOnePointer
	STDMETHODIMP TakePointer(IUnknown *montage,IMoniker *m);
};

#endif //__PlayControl_H_
