/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


struct PlayControls :
	CComCoClass<PlayControls,&CLSID_MCCPlayControls>,
	CComObjectRoot,
	IMCCPlayControls,
	IMCCButtonSetEvents,
	INeedSomePointers,
	IPersist,
    IConnectionPointContainerImpl<PlayControls>,
    IConnectionPointImpl<PlayControls,&IID_IMCCPlayControlsEvents>
{
	CComPtr<IMCCButtonSet> m_bset;
	int m_idPause,m_idPlay,m_idForward;
	DWORD m_chocolateChipCremeWich;
	REGISTER_GENERIC(L"PlayControls")
BEGIN_COM_MAP(PlayControls)
    COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(IMCCPlayControls)
	COM_INTERFACE_ENTRY(IMCCButtonSetEvents)
	COM_INTERFACE_ENTRY(INeedSomePointers)
	COM_INTERFACE_ENTRY(IPersist)
END_COM_MAP()
BEGIN_CONNECTION_POINT_MAP(PlayControls)
    CONNECTION_POINT_ENTRY(IID_IMCCPlayControlsEvents)
END_CONNECTION_POINT_MAP()
// IMCCPlayControls
	STDMETHODIMP Initialize(IMCCButtonSet *bset);
    STDMETHODIMP Trigger(enum MCCPLAY_BUTTONS button);
    STDMETHODIMP put_PlayMode(VARIANT_BOOL whether);
    STDMETHODIMP put_FwdEnabled(VARIANT_BOOL whether);
// IMCCButtonSetEvents
	STDMETHODIMP Changed(int id,DWORD flags);
// INeedSomePointers
	STDMETHODIMP TakePointers(IEnumUnknown *os,IEnumMoniker *ms);
// IPersist
	STDMETHODIMP GetClassID(CLSID *ret);
};