/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "stdafx.h"
#include "PositionInfo.h"

PositionInfo::PositionInfo() {
	METHTRACE(PositionInfo,PositionInfo);
	m_canvasOffset.x = m_canvasOffset.y = m_pixelOffset.x = m_pixelOffset.y = 0;
}
// ICreateContext
STDMETHODIMP PositionInfo::get_CanvasOffset(POINTL *ret) {
	METHTRACE(PositionInfo,get_CanvasOffset);
	*ret = m_canvasOffset;
	return S_OK;
}
STDMETHODIMP PositionInfo::put_CanvasOffset(POINTL val) {
	METHTRACE(PositionInfo,put_CanvasOffset);
	m_canvasOffset = val;
	return S_OK;
}
STDMETHODIMP PositionInfo::get_PixelOffset(POINT *ret) {
	METHTRACE(PositionInfo,get_PixelOffset);
	*ret = m_pixelOffset;
	return S_OK;
}
STDMETHODIMP PositionInfo::put_PixelOffset(POINT val) {
	METHTRACE(PositionInfo,put_PixelOffset);
	m_pixelOffset = val;
	return S_OK;
}
