/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


template<DWORD style,const CLSID *clsid>
struct Scrollbar :
	CComObjectRoot,
	CComCoClass<Scrollbar<style,clsid>,clsid>,
	CComControl<Scrollbar<style,clsid>, CWindowImpl<Scrollbar<style,clsid>,CWindow,CWinTraitsOR<style> > >,
	IDispatchImpl<DIMCCScrollbar, &IID_DIMCCScrollbar, &LIBID_Montage>,
	IPersistStreamInitImpl<Scrollbar<style,clsid> >,
	IOleControlImpl<Scrollbar<style,clsid> >,
	IOleObjectImpl<Scrollbar<style,clsid> >,
	IOleInPlaceActiveObjectImpl<Scrollbar<style,clsid> >,
	IViewObjectExImpl<Scrollbar<style,clsid> >,
	IOleInPlaceObjectWindowlessImpl<Scrollbar<style,clsid> >
{
	typedef Scrollbar<style,clsid> myType;
DECLARE_WND_SUPERCLASS("MCCScrollbar","SCROLLBAR")
BEGIN_COM_MAP(myType)
	COM_INTERFACE_ENTRY(DIMCCScrollbar)
	COM_INTERFACE_ENTRY_IID(IID_IViewObject, IViewObjectEx)
	COM_INTERFACE_ENTRY_IID(IID_IViewObject2, IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY_IID(IID_IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IID(IID_IOleInPlaceObject, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
END_COM_MAP()
BEGIN_PROPERTY_MAP(myType)
END_PROPERTY_MAP()
// DIMCCScrollbar
	STDMETHODIMP get_Page(int *ret);
	STDMETHODIMP put_Page(int val);
	STDMETHODIMP GetRange(int *retMin, int *retMax);
	STDMETHODIMP SetRange(int min, int max);
	STDMETHODIMP get_Pos(int *ret);
	STDMETHODIMP put_Pos(int val);
};
struct VertScrollbar : Scrollbar<SBS_VERT,&CLSID_MCCVertScrollbar>
{
};
struct HorzScrollbar : Scrollbar<SBS_HORZ,&CLSID_MCCHorzScrollbar>
{
};

