/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


class ATL_NO_VTABLE SitePersistor :
	public CComCoClass<SitePersistor,&CLSID_MCCSitePersistor>,
	public CComObjectRoot,
	public IMCCSitePersistor,
	public IDispatchImpl<DIMCCSitePersistor>,
	public IDispatchImpl<DIPersistor>,
	public IGroupItem,
	public IPersistStream
	{
	CComPtr<IGroup> m_group;
	CComQIPtr<IMCCSite> m_subject;
	CComPtr<IMoniker> m_mkMontage,m_mkLayer,m_mkSiteOrdering,
		m_mkControl,m_mkAmbiance, m_mkSelf;
	CComPtr<IOrderedItemList> m_initlist;
	enum MCC_SITE_CLIP_MODE m_holdClipMode;
	CComPtr<IMCCSiteOrdering> m_ordering;

	// this data is loaded on Load() and used up in Realize()
	// but then it can be overridden by put_Data so that something other than the
	// site's data is saved.
	MCCSITEPERSISTORDATA *m_cache;

	HRESULT fillCache(MCCSITEPERSISTORDATA &fill);
	HRESULT getSelfMk(IGroup *dest,IMoniker **ret);
public:
	SitePersistor();
	~SitePersistor();

	REGISTER_GENERIC(L"SitePersistor")
BEGIN_COM_MAP(SitePersistor)
	COM_INTERFACE_ENTRY(IMCCSitePersistor)
	COM_INTERFACE_ENTRY(DIMCCSitePersistor)
	COM_INTERFACE_ENTRY(DIPersistor)
	COM_INTERFACE_ENTRY(IGroupItem)
	COM_INTERFACE_ENTRY(IPersist)
	COM_INTERFACE_ENTRY(IPersistStream)
END_COM_MAP()

//IMCCSitePersistor
	STDMETHODIMP Initialize(IMoniker *mkMontage,IMoniker *mkLayer,IMoniker *mkSiteOrdering,
		IMoniker *mkControl,IMoniker *mkAmbience,IOrderedItemList *ilist);
	STDMETHODIMP get_InitList(IOrderedItemList **ret);
	STDMETHODIMP put_RelMoniker(IMoniker *mk);
	STDMETHODIMP get_RelMoniker(IMoniker **ret);
	STDMETHODIMP put_Ordering(IMCCSiteOrdering *so);
	STDMETHODIMP get_Data(MCCSITEPERSISTORDATA *ret);
	STDMETHODIMP put_Data(MCCSITEPERSISTORDATA *val);
// DIMCCSitePersistor
	STDMETHODIMP Initialize(IUnknown *mkMontage,
		IUnknown *mkLayer,
		IUnknown *mkSiteOrdering,
		IUnknown *mkControl,
		IUnknown *mkAmbiance,
		DIOrderedItemList *initlist);
	STDMETHODIMP get_InitList(DIOrderedItemList **ret);
	STDMETHODIMP put_RelMoniker(IUnknown *mk);
	STDMETHODIMP get_RelMoniker(IUnknown **ret);
	STDMETHODIMP get_ControlMk(IMoniker **ret);
// DIPersistor
	STDMETHODIMP SetSubject(VARIANT_BOOL realized,IUnknown *pUnkSite);
	STDMETHODIMP get_Subject(IUnknown **ret);
// IGroupItem
	STDMETHODIMP Connect(IGroup *group);
	STDMETHODIMP Copy(IBindCtx *bctx, IGroup *dest, IUnknown *aggr, REFIID riid, void **ret);
	STDMETHODIMP Realize(IBindCtx *bctx);
	STDMETHODIMP Remove();
// IPersistStream
	STDMETHODIMP GetClassID(CLSID *pClassID);
	STDMETHODIMP IsDirty(void);
	STDMETHODIMP Load(IStream *pStm);
	STDMETHODIMP Save(IStream *pStm,BOOL fClearDirty);
	STDMETHODIMP GetSizeMax(ULARGE_INTEGER *pcbSize);
};