/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


struct SiteSet :
	CComObjectRoot,
	CComCoClass<SiteSet,&CLSID_MCCSiteSet>,
	IDispatchImpl<DIMCCSiteSet>,
	IMontageContainerEvents,
	IGroupItem, // these two "contain" ItemSet equivs.
	IPersistStream
{
	DWORD m_hermit;
	CComPtr<IGroup> m_group;
	CComPtr<IMoniker> m_mkMontage;
	CComPtr<IUnknown> m_aggrSet;
	REGISTER_GENERIC(L"SiteSet")
	SiteSet();
	~SiteSet();
BEGIN_COM_MAP(SiteSet)
	COM_INTERFACE_ENTRY(DIMCCSiteSet)
	COM_INTERFACE_ENTRY(IMontageContainerEvents)
	COM_INTERFACE_ENTRY(IGroupItem)
	COM_INTERFACE_ENTRY(IPersistStream)
	COM_INTERFACE_ENTRY_AGGREGATE_BLIND(m_aggrSet.p)
END_COM_MAP();
	DECLARE_PROTECT_FINAL_CONSTRUCT( )
	HRESULT FinalConstruct() {
		return CREATEA(m_aggrSet,CLSID_ItemSet,GetUnknown());
	}
	HRESULT FinalRelease() {
		m_aggrSet.Release();
		return S_OK;
	}
// DIMCCSiteSet
	STDMETHODIMP Initialize(IUnknown *mkMC);
// IMontageContainerEvents
	STDMETHODIMP Shutdown();
	STDMETHODIMP Resize(SIZE size);
	STDMETHODIMP NewExtent(SIZEL ext);
	STDMETHODIMP Viewing(HDC hdc, LPCRECTL lpcrOut, LPCRECTL lpcrCanv);
	STDMETHODIMP NewTransform(IMCCTransform *);
	STDMETHODIMP ScaleChanged();
	STDMETHODIMP GroupOp(BOOL start);
	STDMETHODIMP SiteDeleted(IMCCSite *val);
	STDMETHODIMP LayerDeleted(IMCCLayer *val);
	STDMETHODIMP Shifting(long oldState,long newState);
	STDMETHODIMP ShowArea(LPCRECTL r) { return S_FALSE; }
    STDMETHODIMP FocusChanged() { return S_FALSE; }
// IGroupItem
	STDMETHODIMP Connect(IGroup *group);
	STDMETHODIMP Copy(IBindCtx *bctx, IGroup *dest, IUnknown *aggr, REFIID riid, void **ret);
	STDMETHODIMP Realize(IBindCtx *bctx);
	STDMETHODIMP Remove();
// IPersistStream
	STDMETHODIMP GetClassID(CLSID *pClassID);
	STDMETHODIMP IsDirty(void);
	STDMETHODIMP Load(IStream *pStm);
	STDMETHODIMP Save(IStream *pStm,BOOL fClearDirty);
	STDMETHODIMP GetSizeMax(ULARGE_INTEGER *pcbSize);
};