/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// defines class bounder, which keeps track of canvas bounds:
#include "bounds.h"

class ATL_NO_VTABLE SizeToFitTransform :
	public CComCoClass<SizeToFitTransform,&CLSID_MCCSizeToFitTransform>,
	public CComObjectRoot,
	public IMCCTransform,
	public IObjectWithSite,
	public IPersist
{
	CComPtr<DIMontageContainerRef> m_mcRef;
	bounder m_bounds; // the canvas bounds manager
	RECT m_wrect; // rect which we're assigned in container (TransformedArea)
	bool m_viewing,m_canving; // if m_vrect valid, if m_vcrect
	RECT m_vrect; // Viewing rect
	SIZEL m_extent; // amount we're supposed to show (what we do show if not crunched)
	RECTL m_crect,m_cvrect; // bound of all sites on canvas, temporary bound for Viewing
	CComPtr<IMontageContainer> mc() {
		CComPtr<IUnknown> umc;
		m_mcRef->get_Montage(&umc);
		return CComQIPtr<IMontageContainer>(umc);
	}
	HRESULT placeall();
	HRESULT recalc(bool forcePlace=false);
public:
	SizeToFitTransform();
	~SizeToFitTransform();
	REGISTER_GENERIC(L"SizeToFitTransform")
BEGIN_COM_MAP(SizeToFitTransform)
	COM_INTERFACE_ENTRY(IObjectWithSite)
	COM_INTERFACE_ENTRY(IPersist)
	COM_INTERFACE_ENTRY(IMCCTransform)
END_COM_MAP()
// IObjectWithSite
	STDMETHODIMP SetSite(IUnknown *pUnkSite);
	STDMETHODIMP GetSite(REFIID riid, void **ppvSite);
// IMCCTransform
	STDMETHODIMP put_TransformedArea(RECT *val);
	STDMETHODIMP get_TransformedArea(RECT *ret);
	STDMETHODIMP put_Extent(SIZEL *val);
	STDMETHODIMP get_Extent(SIZEL *val);
	STDMETHODIMP C2WS(SIZEL siz, PSIZE psiz);
	STDMETHODIMP C2VS(SIZEL siz, PSIZE psiz);
	STDMETHODIMP W2CS(SIZE siz, PSIZEL psiz);
	STDMETHODIMP C2WP(POINTL pt, PPOINT ppt);
	STDMETHODIMP C2VP(POINTL pt, PPOINT ppt);
	STDMETHODIMP W2CP(POINT pt, PPOINTL ppt);
	STDMETHODIMP C2WR(LPCRECTL pcr, PRECT prc);
	STDMETHODIMP C2VR(LPCRECTL pcr, PRECT prc);
	STDMETHODIMP W2CR(LPCRECT pcr, PRECTL prc);
	STDMETHODIMP Viewing(LPCRECTL lpcrOut, LPCRECTL lpcrCanv);
	STDMETHODIMP get_IsViewing(VARIANT_BOOL *ret);
	STDMETHODIMP AddRect(LPCRECTL r);
	STDMETHODIMP RemoveRect(LPCRECTL r);
// IPersist
	STDMETHODIMP GetClassID(CLSID *pcls);
};
