/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#ifndef __TOOLBACK_H_
#define __TOOLBACK_H_

#include "resource.h"       // main symbols


/////////////////////////////////////////////////////////////////////////////
// ToolBack
class ATL_NO_VTABLE ToolBack :
	public CComObjectRoot,
	public CComCoClass<ToolBack,&CLSID_MCCToolBack>,
	public CComControl<ToolBack>,
	public IMCCToolBack,
	public IPersistStreamInitImpl<ToolBack>,
	public IOleControlImpl<ToolBack>,
	public IOleObjectImpl<ToolBack>,
	public IOleInPlaceActiveObjectImpl<ToolBack>,
	public IViewObjectExImpl<ToolBack>,
	public IOleInPlaceObjectWindowlessImpl<ToolBack>,
	public IDropTarget,
	public INeedOnePointer
{
	DWORD m_side;
	long m_min,m_max;

	// drop-related
	bool m_gooddrop;
	CComQIPtr<IMCCDataObjectUnpacker> m_reader;
public:
	ToolBack();
	~ToolBack();

DECLARE_WND_CLASS("Montage ToolBack")

REGGY_RID(IDR_TOOLBACK)

BEGIN_COM_MAP(ToolBack)
	COM_INTERFACE_ENTRY(IMCCToolBack)
	COM_INTERFACE_ENTRY_IID(IID_IViewObject, IViewObjectEx)
	COM_INTERFACE_ENTRY_IID(IID_IViewObject2, IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY_IID(IID_IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY_IID(IID_IOleInPlaceObject, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY(IDropTarget)
	COM_INTERFACE_ENTRY(INeedOnePointer)
END_COM_MAP()

BEGIN_PROPERTY_MAP(ToolBack)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROPERTY_MAP()


BEGIN_MSG_MAP(ToolBack)
	MESSAGE_HANDLER(WM_SETFOCUS, OnSetFocus)
	MESSAGE_HANDLER(WM_KILLFOCUS, OnKillFocus)
	MESSAGE_HANDLER(WM_DESTROY,OnDestroy)
	CHAIN_MSG_MAP(CComControl<ToolBack>)
END_MSG_MAP()

	LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled) {
		RevokeDragDrop(m_hWnd);
		bHandled = false;
		return 0;
	}

// overriden from CComControl, which does not specify WS_CLIPSIBLINGS
// also registers drop target
	virtual HWND CreateControlWindow(HWND hWndParent, RECT& rcPos) {
		HWND ret = Create(hWndParent, rcPos, 0, WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS);
		RegisterDragDrop(ret,this);
		return ret;
	}
// IViewObjectEx
	STDMETHODIMP GetViewStatus(DWORD* pdwStatus)
	{
		METHTRACE(IViewObjectExImpl,GetViewStatus);
		*pdwStatus = VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE;
		return S_OK;
	}
// IViewObjectImpl
	HRESULT OnDrawAdvanced(ATL_DRAWINFO& di);
// IToolBack (empty)
// IDropTarget
    STDMETHODIMP DragEnter(IDataObject *pDataObj,DWORD grfKeyState,POINTL pt,
        DWORD *pdwEffect);
    STDMETHODIMP DragOver(DWORD grfKeyState,POINTL pt,DWORD *pdwEffect);
    STDMETHODIMP DragLeave();
    STDMETHODIMP Drop(IDataObject *pDataObj,DWORD grfKeyState,POINTL pt,
        DWORD *pdwEffect);
// INeedOnePointer
	STDMETHODIMP TakePointer(IUnknown *u,IMoniker *m);
};

#endif //__TOOLBACK_H_
