/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#ifndef __TOOLBAROWNER_H_
#define __TOOLBAROWNER_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// MCCToolbarOwner
class ATL_NO_VTABLE ToolbarOwner :
	public CComObjectRoot,
	public CComCoClass<ToolbarOwner, &CLSID_MCCToolbarOwner>,
	public IObjectWithSite,
	public INeedOnePointer,
	public IMCCSiteOwner,
	public IMCCSiteEvents,
	public IPersist
{
	CComPtr<IUnknown> m_site;
	CComPtr<IMoveRect> m_proxy;
	DWORD m_doubleStuff;

public:
	ToolbarOwner();
	~ToolbarOwner();

	REGISTER_GENERIC(L"ToolbarOwner")

BEGIN_COM_MAP(ToolbarOwner)
	COM_INTERFACE_ENTRY(IObjectWithSite)
	COM_INTERFACE_ENTRY(INeedOnePointer)
	COM_INTERFACE_ENTRY(IMCCSiteOwner)
	COM_INTERFACE_ENTRY(IMCCSiteEvents)
	COM_INTERFACE_ENTRY_COMPOSED(IMoveRect,XMoveRect)
	COM_INTERFACE_ENTRY(IPersist)
END_COM_MAP()

// IObjectWithSite
	STDMETHODIMP SetSite(IUnknown *site);
	STDMETHODIMP GetSite(REFIID riid, void **ret);
// INeedOnePointer
	STDMETHODIMP TakePointer(IUnknown *toolEngine,IMoniker *m);
// IMCCSiteOwner
	STDMETHODIMP Move(MCC_POS_INFO *pos);
	STDMETHODIMP PutBefore(IMCCSite *other);
	STDMETHODIMP PutBehind(IMCCSite *other);
	STDMETHODIMP Intend(long val);
// IMCCSiteEvents
	STDMETHODIMP Moving(LPCRECT winRect);
	STDMETHODIMP Shifting(long oldState, long newState);
	STDMETHODIMP Layering(IMCCLayer *newLayer);
	STDMETHODIMP ZChanged();
	STDMETHODIMP Wakeup();
// IMoveRect (composed b/c it overlaps IMCCSiteOwner; thanks to Chris Stills)
BEGIN_COMPOSED_CLASS(ToolbarOwner,IMoveRect,XMoveRect)
	STDMETHODIMP Move(LPCRECT lpcr);
END_COMPOSED_CLASS(XMoveRect)
// IPersist
    STDMETHODIMP GetClassID(CLSID *pClassID);
};

#endif //__TOOLBAROWNER_H_
