/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// there's some duplication in that both the map and the points hold the IID.
// vaguely inefficient (4 words).
// suppose the AllPointsContainer should be a set with a special predicate. etc.
// you know how it is.  and here I am wasting more time thinking about it but still doing nothing!
class ATL_NO_VTABLE ConnectionPoint :
	public CComObjectRoot,
	public IConnectionPoint
{
	friend class AllPointsContainer;
protected:
	IConnectionPointContainer *m_cont; // no refcount because it owns me
	IID m_iid;
	DWORD m_currID;
	typedef map<DWORD,IUnknown*> cxnmap;
	cxnmap m_connections;
public:
	ConnectionPoint();
	~ConnectionPoint();
BEGIN_COM_MAP(ConnectionPoint)
	COM_INTERFACE_ENTRY(IConnectionPoint)
END_COM_MAP()
// IConnectionPoint
	STDMETHODIMP GetConnectionInterface(IID * pIID) {
		*pIID = m_iid;
		return S_OK;
	}
	STDMETHODIMP GetConnectionPointContainer(IConnectionPointContainer ** ppCPC) {
		(*ppCPC = m_cont)->AddRef();
		return S_OK;
	}
	STDMETHODIMP Advise(IUnknown * pUnkSink,DWORD * pdwCookie);
	STDMETHODIMP Unadvise(DWORD dwCookie);
	STDMETHODIMP EnumConnections(IEnumConnections ** ppEnum);
};
struct CP :
	public CComObject<ConnectionPoint> {
	CP(REFIID riid,IConnectionPointContainer *cpc) {
		m_iid = riid;
		m_cont = cpc;
	}
};
struct lessIID {
	typedef struct _intIID {
		__int64 top,bottom;
		bool operator <(const struct _intIID &o) {
			if(top < o.top)
				return true;
			else if(o.top < top)
				return false;
			else
				return bottom < o.bottom;
		}
	} intIID;
	bool operator()(REFIID i1,REFIID i2) const {
		return *(intIID*)&i1 < *(intIID*)&i2;
	}
};
typedef map<IID,IConnectionPoint*,lessIID> cpmap;
class ATL_NO_VTABLE AllPointsContainer :
	public CComCoClass<AllPointsContainer,&CLSID_MCCAllPointsContainer>,
	public CComObjectRoot,
	public IMCCAllPointsContainer
{
	cpmap m_points;
public:
	AllPointsContainer();
	~AllPointsContainer();
	REGISTER_GENERIC(L"AllPointsContainer")
BEGIN_COM_MAP(AllPointsContainer)
	COM_INTERFACE_ENTRY(IMCCAllPointsContainer)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
END_COM_MAP()
// IConnectionPointContainer
	STDMETHODIMP EnumConnectionPoints(IEnumConnectionPoints ** ppEnum);
	STDMETHODIMP FindConnectionPoint(REFIID riid,IConnectionPoint ** ppCP);
// IMCCAllPointsContainer
	STDMETHODIMP EnsurePoint(REFIID riid,IConnectionPoint **ret);
};