/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


struct bootPalette :
	public CComCoClass<bootPalette,&CLSID_MCCBootPalette>,
	public CComObjectRoot,
	public IInitializeOther
{
	REGISTER_GENERIC(L"BootPalette")
	bootPalette() {
		CONSTRUCTORTRACE(bootPalette);
	}
	~bootPalette() {
		DESTRUCTORTRACE(bootPalette);
	}
BEGIN_CATEGORY_MAP(bootPalette)
	IMPLEMENTED_CATEGORY(CATID_MCCStarter)
END_CATEGORY_MAP()
BEGIN_COM_MAP(bootPalette)
	COM_INTERFACE_ENTRY(IInitializeOther)
END_COM_MAP()

// IInitializeOther
	STDMETHODIMP InitializeOther(IUnknown *other);
};
class ATL_NO_VTABLE bootPanel :
	public CComCoClass<bootPanel,&CLSID_MCCBootPanel>,
	public CComObjectRoot,
	public IInitializeOther
{
public:
	REGISTER_GENERIC(L"BootPanel")
	bootPanel() {
		CONSTRUCTORTRACE(bootPanel);
	}
	~bootPanel() {
		DESTRUCTORTRACE(bootPanel);
	}
BEGIN_CATEGORY_MAP(bootPanel)
	IMPLEMENTED_CATEGORY(CATID_MCCStarter)
END_CATEGORY_MAP()
BEGIN_COM_MAP(bootPanel)
	COM_INTERFACE_ENTRY(IInitializeOther)
END_COM_MAP()
// IInitializeOther
	STDMETHODIMP InitializeOther(IUnknown *other);
};
class ATL_NO_VTABLE bootRegularPanel :
	public CComCoClass<bootRegularPanel,&CLSID_MCCBootRegularPanel>,
	public CComObjectRoot,
	public IInitializeOther
{
public:
	REGISTER_GENERIC(L"BootRegularPanel")
	bootRegularPanel() {
		CONSTRUCTORTRACE(bootRegularPanel);
	}
	~bootRegularPanel() {
		DESTRUCTORTRACE(bootRegularPanel);
	}
BEGIN_CATEGORY_MAP(bootRegularPanel)
	IMPLEMENTED_CATEGORY(CATID_MCCStarter)
END_CATEGORY_MAP()
BEGIN_COM_MAP(bootRegularPanel)
	COM_INTERFACE_ENTRY(IInitializeOther)
END_COM_MAP()
// IInitializeOther
	STDMETHODIMP InitializeOther(IUnknown *other);
};
struct bootDocument :
	public CComCoClass<bootDocument,&CLSID_MCCBootDocument>,
	public CComObjectRoot,
	public IInitializeOther
{
	REGISTER_GENERIC(L"BootDocument")
	bootDocument() {
		CONSTRUCTORTRACE(bootDocument);
	}
	~bootDocument() {
		DESTRUCTORTRACE(bootDocument);
	}
BEGIN_CATEGORY_MAP(bootDocument)
	IMPLEMENTED_CATEGORY(CATID_MCCStarter)
END_CATEGORY_MAP()
BEGIN_COM_MAP(bootDocument)
	COM_INTERFACE_ENTRY(IInitializeOther)
END_COM_MAP()
// IInitializeOther
	STDMETHODIMP InitializeOther(IUnknown *other);
};
struct bootDocToolbars :
	public CComCoClass<bootDocToolbars,&CLSID_MCCBootDocToolbars>,
	public CComObjectRoot,
	public IInitializeOther
{
	REGISTER_GENERIC(L"BootDocToolbars")
	bootDocToolbars() {
		CONSTRUCTORTRACE(bootDocToolbars);
	}
	~bootDocToolbars() {
		DESTRUCTORTRACE(bootDocToolbars);
	}
BEGIN_CATEGORY_MAP(bootDocToolbars)
	IMPLEMENTED_CATEGORY(CATID_MCCStarter)
END_CATEGORY_MAP()
BEGIN_COM_MAP(bootDocToolbars)
	COM_INTERFACE_ENTRY(IInitializeOther)
END_COM_MAP()
// IInitializeOther
	STDMETHODIMP InitializeOther(IUnknown *other);
};
struct bootModeSupport :
	public CComCoClass<bootModeSupport,&CLSID_MCCBootModeSupport>,
	public CComObjectRoot,
	public IInitializeOther
{
	REGISTER_GENERIC(L"BootModeSupport")
	bootModeSupport() {
		CONSTRUCTORTRACE(bootModeSupport);
	}
	~bootModeSupport() {
		DESTRUCTORTRACE(bootModeSupport);
	}
BEGIN_CATEGORY_MAP(bootModeSupport)
	IMPLEMENTED_CATEGORY(CATID_MCCStarter)
END_CATEGORY_MAP()
BEGIN_COM_MAP(bootModeSupport)
	COM_INTERFACE_ENTRY(IInitializeOther)
END_COM_MAP()
// IInitializeOther
	STDMETHODIMP InitializeOther(IUnknown *other);
};
struct bootViewMode :
	public CComCoClass<bootViewMode,&CLSID_MCCBootViewMode>,
	public CComObjectRoot,
	public IInitializeOther
{
	REGISTER_GENERIC(L"BootViewMode")
	bootViewMode() {
		CONSTRUCTORTRACE(bootViewMode);
	}
	~bootViewMode() {
		DESTRUCTORTRACE(bootViewMode);
	}
BEGIN_CATEGORY_MAP(bootViewMode)
	IMPLEMENTED_CATEGORY(CATID_MCCStarter)
END_CATEGORY_MAP()
BEGIN_COM_MAP(bootViewMode)
	COM_INTERFACE_ENTRY(IInitializeOther)
END_COM_MAP()
// IInitializeOther
	STDMETHODIMP InitializeOther(IUnknown *other);
};
struct bootEditMode :
	public CComCoClass<bootEditMode,&CLSID_MCCBootEditMode>,
	public CComObjectRoot,
	public IInitializeOther
{
	REGISTER_GENERIC(L"BootEditMode")
	bootEditMode() {
		CONSTRUCTORTRACE(bootEditMode);
	}
	~bootEditMode() {
		DESTRUCTORTRACE(bootEditMode);
	}
BEGIN_CATEGORY_MAP(bootEditMode)
	IMPLEMENTED_CATEGORY(CATID_MCCStarter)
END_CATEGORY_MAP()
BEGIN_COM_MAP(bootEditMode)
	COM_INTERFACE_ENTRY(IInitializeOther)
END_COM_MAP()
// IInitializeOther
	STDMETHODIMP InitializeOther(IUnknown *other);
};
struct bootStandard :
	public CComCoClass<bootStandard,&CLSID_MCCBootStandard>,
	public CComObjectRoot,
	public IInitializeOther
{
	REGISTER_GENERIC(L"BootStandard")
	bootStandard() {
		CONSTRUCTORTRACE(bootStandard);
	}
	~bootStandard() {
		DESTRUCTORTRACE(bootStandard);
	}
BEGIN_CATEGORY_MAP(bootStandard)
	IMPLEMENTED_CATEGORY(CATID_MCCStarter)
END_CATEGORY_MAP()
BEGIN_COM_MAP(bootStandard)
	COM_INTERFACE_ENTRY(IInitializeOther)
END_COM_MAP()
// IInitializeOther
	STDMETHODIMP InitializeOther(IUnknown *other);
};
