/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "stdafx.h"
#include "boot.h"
#include "MBasics.h"

#include "ambiance.h"
#include "defaultFont.h"

// add toolbar support to a basic montage doc

STDMETHODIMP bootDocToolbars::InitializeOther(IUnknown *other) {
	METHTRACE(bootDocToolbars,InitializeOther);
	MBasics mb;
	RUN(mb.init(other));

	// toolbars
	// create & add group
	CComPtr<IGroup> toolGroup;
	RUN(CREATE(toolGroup,CLSID_Group));
	CComPtr<IMoniker> mkToolGroup;
	RUN(mb.add(L"Toolbars",toolGroup,dont_keep,&mkToolGroup,true));
	// create, add to toolGroup, and initialize persistor for the montage instance.
	CComPtr<IMontagePersistor> toolPer;
	CComPtr<IMoniker> mkToolPer;
	RUN(CREATE(toolPer,CLSID_MontagePersistor));
	RUN(toolGroup->Paste(mb.bctx,GP_SrcIsObj,toolPer,ItemMoniker(L"Montage Persistor"),IID_NULL,0,&mkToolPer));
	RUN(CComQIPtr<IPersistStreamInit>(toolPer)->InitNew());
	RUN(toolPer->put_Class(CLSID_MCCToolPanel));
	RUN(toolPer->put_SelfMoniker(mkToolPer));
	// create composite moniker mainGroup->toolGroup->toolPer->subject and place in main persistor
	CComPtr<IMoniker> mkToolsWithin,mkTools;
	RUN(mkToolPer->ComposeWith(mb.goSubject,false,&mkToolsWithin));
	RUN(mkToolGroup->ComposeWith(mkToolsWithin,false,&mkTools));
	RUN(mb.p->put_ToolPanelMk(mkTools));
	// realize the toolPer to create the toolpanel montage instance
	RUN(CComQIPtr<IGroupItem>(toolPer)->Realize(mb.bctx));
	// call initOther explicitly
	CComPtr<IInitializeOther> bp;
	RUN(CREATE(bp,CLSID_MCCBootPanel));
	RUN(bp->InitializeOther(toolPer));
	CComPtr<IUnknown> uToolz;
	RUN(CComQIPtr<DIPersistor>(toolPer)->get_Subject(&uToolz));
	CComPtr<IMCCToolPanel> toolz;
	RUN(uToolz.QueryInterface(&toolz));
	RUN(mb.c->put_ToolPanel(toolz));

	return S_OK;
}