/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "stdafx.h"
#include "boot.h"
#include "MBasics.h"

#include "ambiance.h"
#include "defaultFont.h"

// boots a basic Montage document ("Manual Layout")

STDMETHODIMP bootStandard::InitializeOther(IUnknown *other) {
	METHTRACE(bootStandard,bootStandard);
	MBasics mb;
	RUN(mb.init(other));

	CComPtr<IInitializeOther> boot;
	RUN(boot.CoCreateInstance(CLSID_MCCBootDocument));
	RUN(boot->InitializeOther(other));
	boot.Release();
	RUN(boot.CoCreateInstance(CLSID_MCCBootModeSupport));
	RUN(boot->InitializeOther(other));
	boot.Release();
	RUN(boot.CoCreateInstance(CLSID_MCCBootViewMode));
	RUN(boot->InitializeOther(other));
	boot.Release();
	RUN(boot.CoCreateInstance(CLSID_MCCBootEditMode));
	RUN(boot->InitializeOther(other));
	boot.Release();
	RUN(boot.CoCreateInstance(CLSID_MCCBootDocToolbars));
	RUN(boot->InitializeOther(other));
	boot.Release();
	// now give standard toolbars to panel
	CComPtr<IMontagePersistor> panelPer;
	RUN(mb.bind(ComposeMk(ItemMoniker(L"Toolbars"),ItemMoniker(L"Montage Persistor")),&panelPer));
	RUN(boot.CoCreateInstance(CLSID_MCCBootRegularPanel));
	RUN(boot->InitializeOther(panelPer));

	// register a Save As filetype
	CComPtr<IMCCFileFormat> fport;
	RUN(mb.c->get_FilePort(&fport));
	RUN(CComQIPtr<IMCCFilePort>(fport)->RegisterNativeFileFormat(MFP_IMPORT,L"mon:Montage Container Canvas"));
	RUN(CComQIPtr<IMCCFilePort>(fport)->RegisterNativeFileFormat(MFP_EXPORT,L"mon:Montage Container Canvas"));
	return S_OK;
}