/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "stdafx.h"
#include "ole_init.h"

RunInit::RunInit() {
	CONSTRUCTORTRACE(RunInit);
}
RunInit::~RunInit() {
	DESTRUCTORTRACE(RunInit);
}
HRESULT RunInit::InitializeOther(IUnknown *other) {
	METHTRACE(RunInit,InitializeOther);
	HRESULT hr;
	CComQIPtr<IMCCSite> s;
	QISET(s = other);
	CComPtr<IRunnableObject> run;
	hr = s->GetControl(riidret(&run));
	if(run)
		RUN(run->Run(0));
	return S_OK;
}
CacheInit::CacheInit() {
	CONSTRUCTORTRACE(CacheInit);
}
CacheInit::~CacheInit() {
	DESTRUCTORTRACE(CacheInit);
}
HRESULT CacheInit::InitializeOther(IUnknown *other) {
	METHTRACE(CacheInit,InitializeOther);
	HRESULT hr;
	CComQIPtr<IMCCSite> s;
	QISET(s = other);
	CComPtr<IOleCache> cache;
	hr = s->GetControl(riidret(&cache));
	if(cache) {
		FORMATETC fetc;
		fetc.cfFormat = 0; // view caching: cache decides.
		fetc.ptd = 0;
		fetc.dwAspect = DVASPECT_CONTENT;
		fetc.lindex = -1;
		fetc.tymed = TYMED_ISTORAGE;
		DWORD temp;
		RUN(cache->Cache(&fetc,ADVF_PRIMEFIRST,&temp));
	}
	return S_OK;
}
