/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


/* useful #defines:
	_ATL_DEBUG_QI
	TRACE_CALLED
	TRACE_ERRORS
	TRACE_STRUCTORS
*/

// don't warn about conversion to bool (stupid warning! Of course I want to cast to bool!)
#pragma warning (disable:4800)

// ugh: IClassActivator not defined unless..
#define _WIN32_WINNT 0x0400

// atl
#define ATL_TRACE_CATEGORY atlTraceQI
#include <atlbase.h>
//You may derive a class from CComModule and use it if you want to override
//something, but do not change the name of _Module
extern CComModule _Module;

#include <atlcom.h>
#include <atlwin.h>
#include <atlctl.h>
#include <dispex.h>
// categories, doc objects, etc.
#include <inetsdk.h>

#include "MTracePlus.h"
#include "methtrace.h"

// stl
#include <vector>
#include <list>
#include <deque>
#include <algorithm>
#include <functional>
#include <map>
#include <set>
#include <hash_map>
#include <hash_set>
using namespace std;
using namespace stdext;

// idl
#include "..\Group\Group.h"
#include "Montage.h"

#include "resource.h"

// utils
#define _ATL_DEBUG_REFCOUNT
#include "atl_debug_refcount.h"
#include "break.h"
#include "check.h"
#include "qi.h"
#include "run.h"
#include "tracecreate.h"
#include "err.h"
#include "large.h"
#include "dispmap.h"
#include "rect.h"
#define REGGY_LIBID LIBID_Montage
#include "reggy_rid.h"
#include "registerGeneric.h"
#include "APCAdvise.h"
#include "atlcompose.h"
#include "FixedOlePersist.h"
#include "getSinks.h"
#include "fireEvent.h"
#include "fireSiteEvent.h"
#include "fireFunctors.h"
#include "fireOwnerFunctors.h"
#include "countStream.h"
#include "FoolishCreatePointerMoniker.h"
#include "make_pair_first_const.h" // argh.
#include "Monikers.h"
#include "assign.h"
#include "ClipFormats.h"
#include "groupOp.h"
#include "DCObject.h"
#include "getObjectCLSID.h"
#include "lessWstring.h"

// stl-com links
#include "hashMoniker.h"
#include "enum_iterator.h"
#include "formatetc_iterator.h"
