/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


struct Style :
	public CComCoClass<Style, &CLSID_MCCStyle>,
	public CComObjectRoot,
	public INeedOnePointer,
	public IMCCStyle,
	public IDispatchImpl<DIMCCStyle>,
	public IDispatchEx,
	public IPersistStream,
	public IConnectionPointContainerImpl<Style>,
	public IConnectionPointImpl<Style,&IID_IPropertyNotifySink>
{
	CComPtr<IDispatchEx> m_defer;
	dispmap m_dispmap; // strings are actually BSTRs owned by valmap below
	typedef struct {
		bool deleted;
		CComBSTR name; // copy of pointer that's in other map, for GetMemberName
		CComVariant val;
	} value;
	typedef map<DISPID,value> valmap;
	valmap m_data;
	DISPID m_newID;

	REGISTER_GENERIC(L"Style")
	Style();
	~Style();
BEGIN_COM_MAP(Style)
	COM_INTERFACE_ENTRY(INeedOnePointer)
	COM_INTERFACE_ENTRY(IMCCStyle)
	COM_INTERFACE_ENTRY(DIMCCStyle)
	COM_INTERFACE_ENTRY2(IDispatch,IDispatchEx)
	COM_INTERFACE_ENTRY(IDispatchEx)
	COM_INTERFACE_ENTRY(IPersist)
	COM_INTERFACE_ENTRY(IPersistStream)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
END_COM_MAP()
BEGIN_CONNECTION_POINT_MAP(Style)
	CONNECTION_POINT_ENTRY(IID_IPropertyNotifySink)
END_CONNECTION_POINT_MAP()
// INeedOnePointer
	STDMETHODIMP TakePointer(IUnknown *o,IMoniker *m);
// IMCCStyle
	STDMETHODIMP get_Defer(IDispatchEx **ret);
	STDMETHODIMP put_Defer(IDispatchEx *val);
// DIMCCStyle
	STDMETHODIMP get_Defer(IDispatch **ret);
	STDMETHODIMP put_Defer(IDispatch *val);
// IDispatch
	STDMETHODIMP GetTypeInfoCount(UINT * pctinfo);
	STDMETHODIMP GetTypeInfo(UINT iTInfo,LCID lcid,ITypeInfo ** ppTInfo);
	STDMETHODIMP GetIDsOfNames(REFIID riid,LPOLESTR * rgszNames,UINT cNames,
		LCID lcid,DISPID * rgDispId);
	STDMETHODIMP Invoke(DISPID dispIdMember,REFIID riid,LCID lcid,WORD wFlags,
		DISPPARAMS * pDispParams,VARIANT * pVarResult,EXCEPINFO * pExcepInfo,UINT * puArgErr);
// -Ex
	STDMETHODIMP GetDispID(BSTR bstrName,DWORD grfdex,DISPID *pid);
	STDMETHODIMP InvokeEx(DISPID id,LCID lcid,WORD wFlags,DISPPARAMS *pdp,VARIANT *pvarRes,
		EXCEPINFO *pei,IServiceProvider *pspCaller);
	STDMETHODIMP DeleteMemberByName(BSTR bstr, DWORD grfdex);
	STDMETHODIMP DeleteMemberByDispID(DISPID id);
	STDMETHODIMP GetMemberProperties(DISPID id,DWORD grfdexFetch,DWORD *pgrfdex);
	STDMETHODIMP GetMemberName(DISPID id,BSTR *pbstrName);
	STDMETHODIMP GetNextDispID(DWORD grfdex,DISPID id,DISPID *pid);
	STDMETHODIMP GetNameSpaceParent(IUnknown **ppunk);
// IPersistStream
	STDMETHODIMP GetClassID(CLSID *pClassID);
	STDMETHODIMP IsDirty(void);
	STDMETHODIMP Load(IStream *pStm);
	STDMETHODIMP Save(IStream *pStm,BOOL fClearDirty);
	STDMETHODIMP GetSizeMax(ULARGE_INTEGER *pcbSize);
};