/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// like AtlAdvise but uses AllPointsContainer to *ensure* the point
// (AtlUnadvise works fine for disconnecting)
inline HRESULT APCAdvise(IUnknown *apc,IUnknown *sink,const IID&riid,LPDWORD pDough) {
    FUNTRACE(APCAdvise);
	CComQIPtr<IMCCAllPointsContainer> apc2;
	QISET(apc2 = apc);
	CComPtr<IConnectionPoint> cp;
	SRUN(apc2->EnsurePoint(riid,&cp));
	return cp->Advise(sink,pDough);
}
