/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// I couldn't get list to work.  buggin'!
#include <vector>

// make sure you set your resource.h to these numbers too.
#ifndef IDD_ChooseEng
#define IDD_ChooseEng 909
#define IDC_EngList 201
#endif

struct classinfo {
	char *lpszName;
	CLSID clsid;
	classinfo() { lpszName = NULL; }
};
inline bool operator ==(const classinfo,const classinfo) { return true; }
inline bool operator <(const classinfo,const classinfo) { return true; }

struct ChooseFromCatDlg : CDialogImpl<ChooseFromCatDlg> {
	enum {IDD = IDD_ChooseEng};
	std::vector<classinfo> m_engines;
	CATID m_catid;

	ChooseFromCatDlg(CATID catid);
	~ChooseFromCatDlg();

	int DoModal(HWND hWndParent = ::GetActiveWindow()) {
		switch(m_engines.size()) {
		case 0: return -1; // nothing to choose!
		case 1: return 0;  // as if user selected only item
		default: return CDialogImpl<ChooseFromCatDlg>::DoModal(hWndParent);
		}
	}
	BEGIN_MSG_MAP(ChooseFromCatDlg)
		MESSAGE_HANDLER(WM_INITDIALOG,Initialize)
		COMMAND_HANDLER(IDOK,BN_CLICKED,Okay)
		COMMAND_HANDLER(IDC_EngList,LBN_SELCHANGE,Select)
		COMMAND_HANDLER(IDC_EngList,LBN_DBLCLK,Snappy)
		COMMAND_HANDLER(IDCANCEL,BN_CLICKED,Cancel)
	END_MSG_MAP()

	// override these to deal with extra controls
	virtual LRESULT Initialize(UINT,WPARAM,LPARAM,BOOL&);
	virtual void FinishUp() {}

	LRESULT Okay(WORD,WORD,HWND,BOOL&);
	LRESULT Select(WORD,WORD,HWND,BOOL&);
	LRESULT Snappy(WORD,WORD,HWND,BOOL&);
	LRESULT Cancel(WORD,WORD,HWND,BOOL&) {
		EndDialog(-1);
		return true;
	}
};