/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#ifndef ClipFormats_h
#define ClipFormats_h

struct ClipFormats {
	int cc,embedded,embedsource,objectdescriptor;
	ClipFormats();
	~ClipFormats();
};

extern ClipFormats g_clipformats;

struct FormatEtc : FORMATETC {
	FormatEtc(int cf) {
		cfFormat = cf;
		ptd = 0;
		dwAspect = DVASPECT_CONTENT;
		lindex = -1;
		if(cf==g_clipformats.cc ||
			cf==g_clipformats.embedded ||
			cf==g_clipformats.embedsource)
			tymed = TYMED_ISTORAGE;
		else if(cf==g_clipformats.objectdescriptor)
			tymed = TYMED_HGLOBAL;
		else switch(cf) {
		case CF_METAFILEPICT:
			tymed = TYMED_MFPICT;
			break;
		case CF_ENHMETAFILE:
			tymed = TYMED_ENHMF;
			break;
		case CF_TEXT:
			tymed = TYMED_HGLOBAL;
			break;
        case CF_BITMAP:
            tymed = TYMED_GDI;
            break;
		default:
			CHECK(0);
			break;
		}
	}
};
// to avoid obvious bugs (strangely enough a valid pointer always ends up in pUnkForRelease,
// causing crazy bugs!)
struct StgMedium : STGMEDIUM {
	StgMedium() {
		memset(this,0,sizeof StgMedium);
	}
};
inline void ccformat(FORMATETC *dest) {
	dest->cfFormat = g_clipformats.cc;
    dest->ptd = 0;
    dest->dwAspect = DVASPECT_CONTENT;
    dest->lindex = -1;
    dest->tymed = TYMED_ISTORAGE;
}
// unrelated except that it's used in the same situations
inline HRESULT getsizepoint(IDataObject *data,SIZEL *retSize,POINTL *retPoint) {
    FUNTRACE(getsizepoint);
	FormatEtc fetz(g_clipformats.objectdescriptor);
	StgMedium stgm;
	SRUNRET(data->GetData(&fetz,&stgm));
	if(stgm.tymed != TYMED_HGLOBAL)
		SERR(E_UNEXPECTED);
	OBJECTDESCRIPTOR *pod = (OBJECTDESCRIPTOR *)GlobalLock(stgm.hGlobal);
	if(retSize)
		*retSize = pod->sizel;
	if(retPoint)
		*(POINT *)retPoint = *(POINT *)&pod->pointl;
	GlobalUnlock(stgm.hGlobal);
	ReleaseStgMedium(&stgm);
	return S_OK;
}
#endif // ClipFormats_h