/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "stdafx.h"
#include "Collection.h"

Collection::Collection() : m_count(0),m_data(0) {
	CONSTRUCTORTRACE(Collection);
}
Collection::~Collection() {
	DESTRUCTORTRACE(Collection);
	for(int i = 0;i<m_count;++i)
		VariantClear(m_data+i);
}
STDMETHODIMP Collection::get_Item(long index, VARIANT *ret) {
	if(index>m_count) {
		ret->vt = VT_EMPTY;
		return S_OK;
	}
	VariantCopy(ret,m_data+index-1); // index is 1-relative
	return S_OK;
}
STDMETHODIMP Collection::get_Count(long *ret) {
	*ret = m_count;
	return S_OK;
}
typedef CComObject<CComEnum<IEnumVARIANT,&IID_IEnumVARIANT,VARIANT,_Copy<VARIANT> > > eVariant;
STDMETHODIMP Collection::get__NewEnum(IUnknown **ret) {
	eVariant *ev = new eVariant;
	ev->Init(m_data,m_data+m_count,this,AtlFlagNoCopy);
	(*ret = ev)->AddRef();
	return S_OK;
}
