/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


struct Collection : CComObjectRoot,
	IDispatchImpl<DICollection>
{
	long m_count;
	VARIANT *m_data;
BEGIN_COM_MAP(Collection)
	COM_INTERFACE_ENTRY(DICollection)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()
	Collection();
	~Collection();
	void Init(long count, VARIANT *data) {
		m_count = count;
		m_data = data;
	}
	STDMETHODIMP get_Item(long index, VARIANT *ret);
	STDMETHODIMP get_Count(long *ret);
	STDMETHODIMP get__NewEnum(IUnknown **ret);
};
struct collection : CComObject<Collection> {
	collection(pair<long,VARIANT*> dp) {
		Init(dp.first,dp.second);
	}
	collection(long count, VARIANT *dat) {
		Init(count,dat);
	}
};

// I wanted to make Init above templated to take a collection but compiler
// sketched out on me - are templated members still spotty?
template<class Coll, class Conv>
pair<long, VARIANT*> make_colldata_conv(Coll &c, Conv f) {
	CComVariant *data = new CComVariant[c.size()];
	int n = 0;
	for(Coll::iterator i = c.begin();i!=c.end(); ++i,++n)
		data[n] = f(*i);
	return make_pair((long)c.size(),(VARIANT*)data);
}
template<class T>
struct no_conv {
	T &operator()(T&o) {
		return o;
	}
	T const &operator()(T const &o) const { // too const!
		return o;
	}
};
template<class Coll>
pair<long, VARIANT*> make_colldata(Coll &c) {
	return make_colldata_conv(c,no_conv<Coll::value_type>());
};
template<class Iter>
pair<long, VARIANT*> make_colldata(Iter begin, Iter end) {
	int count = 0;
	for(Iter i = begin;i!=end;++i)
		count++;
	CComVariant *data = new CComVariant[count];
	int n = 0;
	for(i = begin;i!=end; ++i,++n)
		data[n] = *i;
	return make_pair((long)count,(VARIANT*)data);
}
