/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// automate unselect & deletion of gdi objects
// it's only correct for the case where there's only one of each type of object
// but i think it works okay for the multi- case too.
struct DCObject {
	HANDLE h,old;
	HDC hdc;
	DCObject(HDC hdc,HANDLE hand = 0) : hdc(hdc),h(0),old(0) {
		sel(hand);
	}
	~DCObject() {
		del();
	}
	void del() {
		if(h) {
			SelectObject(hdc,old);
			DeleteObject(h);
			h = old = 0;
		}
	}
	void sel(HANDLE hand) {
		if(h = hand)
			old = SelectObject(hdc,h);
	}
	DCObject &operator=(HANDLE hand) {
		if(hand!=h) {
			del();
			sel(hand);
		}
		return *this;
	}
	void use() {
		if(h)
			SelectObject(hdc,h);
	}
	void let_go() {
		if(h&&old) {
			SelectObject(hdc,old);
			h = 0;
		}
	}
};
