/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "stdafx.h"

#include <string>
using namespace std;

#ifdef TRACE_LOG
void _cdecl DGMTrace(LPCTSTR lpszFormat, ...)
{
	static FILE *debugOut = 0;
	static string beforeInst;
	if(!debugOut) {
		HINSTANCE hInst = _Module.GetModuleInstance();
		if(!hInst) {
			// global variables get constructed and can call DGMTrace
			// before DllMain initializes _Module, yuck
			char buf2[1000];
			va_list args;
			va_start(args, lpszFormat);

			vsprintf(buf2, lpszFormat, args);
			va_end(args);
			beforeInst += buf2;
			return;
		}
		char logname[3000];
		CHECK(GetModuleFileName(hInst,logname,3000));
		char *dotp = strrchr(logname,'.');
		_ASSERTE(dotp);
		strcpy(dotp,".log");
		debugOut = fopen(logname,"w");
		setvbuf(debugOut,0,_IONBF,0);
		if(beforeInst.size()) {
			fprintf(debugOut,beforeInst.c_str());
			beforeInst.erase();
		}
	}
	va_list args;
	va_start(args, lpszFormat);

	vfprintf(debugOut, lpszFormat, args);
	va_end(args);
}
#endif
