/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// add yr source dir to include search path
#include "stdafx.h"

#include "DispEnabler.h"

STDMETHODIMP CDispEnabler::GetTypeInfoCount(UINT *pctinfo) {
	METHTRACE(CDispEnabler,GetTypeInfoCount);
	*pctinfo = 1;
	return S_OK;
}
STDMETHODIMP CDispEnabler::GetTypeInfo(
     UINT iTInfo,
     LCID lcid, // ignoring (for now?)
     ITypeInfo **ppTInfo) {
	METHTRACE(CDispEnabler,GetTypeInfo);
	USES_CONVERSION;
	TCHAR szModule[_MAX_PATH+10];

	if(iTInfo!=0)
		ERR(DISP_E_BADINDEX);
	GetModuleFileName(_Module.GetTypeLibInstance(), szModule, _MAX_PATH);
	ITypeLib* pTypeLib;
	LPOLESTR lpszModule = T2OLE(szModule);
	RUNRET(LoadTypeLib(lpszModule, &pTypeLib));
	return pTypeLib->GetTypeInfoOfGuid(iid,ppTInfo);
}
STDMETHODIMP CDispEnabler::GetIDsOfNames(
     REFIID riid,
     LPOLESTR *rgszNames,
     UINT cNames,
     LCID lcid,
     DISPID *rgDispId) {
	METHTRACE(CDispEnabler,GetIDsOfNames);
	/*
	// cheap debug action
	char buf[90];
	for(int i = 0;rgszNames[0][i];i++)
		buf[i] = (char)rgszNames[0][i];
	*/
	ITypeInfo *pTInfo;
	RUNRET(GetTypeInfo(0,lcid,&pTInfo));
	return LOOK(pTInfo->GetIDsOfNames(rgszNames,cNames,rgDispId));
}
