/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


inline HRESULT GetModeContext(IOleClientSite *s,IControlContainer **rContainer,ICCLayer **rMainLayer,IUnknown **rEngine) {
	HRESULT hr;
	CComPtr<IOleContainer> pCont;
	RUN(s->GetContainer(&pCont));
	CComQIPtr<IControlContainer> cont = pCont;
	if(!cont)
		ERR(E_UNEXPECTED);
	if(rContainer)
		(*rContainer = cont)->AddRef();
	CComPtr<ICCApplication> app;
	RUN(cont->get_Application(&app));
	if(!app)
		ERR(E_UNEXPECTED);
	if(rEngine)
		RUN(app->get_LayoutMgr(rEngine));
	if(rMainLayer) {
		CComPtr<IUnknown> punk;
		RUN(app->get_LayerMgr(&punk));
		CComQIPtr<ICCStdLayers> pStdLayers(punk);
		if(pStdLayers)
			{RUN(pStdLayers->get_MainLayer(rMainLayer));}
		else // layer manager is unknown
			ERR(E_UNEXPECTED);
	}
	return S_OK;
}
