/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "stdafx.h"

// right now it seems to work best to draw METAFILEPICTs in upside-down
// HIMETRIC but enhanced metafiles in true HIMETRIC. ?.
HDC startMetafile(DWORD tymed, SIZEL extentHimetric, SIZEL extentRender, RECT *bounds) {
	HDC hdc;
	if(tymed & TYMED_ENHMF) {
		hdc = CreateEnhMetaFile(0,0,bounds,"Montage OLE Container\0Embedding\0");
		_ASSERTE(hdc);
		SCHECK(SetMapMode(hdc,MM_LOMETRIC));
		SCHECK(SetWindowOrgEx(hdc,0,extentRender.cy,0));
		SCHECK(SetWindowExtEx(hdc,extentRender.cx,-extentRender.cy,0));
	}
	else {
		hdc = CreateMetaFile(NULL);
		_ASSERTE(hdc);
		SCHECK(SetMapMode(hdc,MM_ANISOTROPIC));
		SCHECK(SetWindowOrgEx(hdc,0,0,0));
		SCHECK(SetWindowExtEx(hdc,extentRender.cx,extentRender.cy,0));
	}
	return hdc;
}
HRESULT storeMetafile(HDC hdc, DWORD tymed, SIZEL extentHimetric,STGMEDIUM *stgm) {
	if(tymed & TYMED_ENHMF) {
		stgm->tymed = TYMED_ENHMF;
		stgm->hEnhMetaFile = CloseEnhMetaFile(hdc);
		if(!stgm->hEnhMetaFile)
			SERR(E_UNEXPECTED);
		ENHMETAHEADER header;
		GetEnhMetaFileHeader(stgm->hEnhMetaFile,sizeof header,&header);
	}
	else {
		HMETAFILE hmf = CloseMetaFile(hdc);
		if(!hmf)
			SERR(E_UNEXPECTED);
		HGLOBAL hMem=GlobalAlloc(GHND,sizeof(METAFILEPICT));
		if(!hMem) {
			DeleteMetaFile(hmf);
			SERR(STG_E_MEDIUMFULL);
		}
		LPMETAFILEPICT pmfp = LPMETAFILEPICT(GlobalLock(hMem));
		pmfp->hMF = hmf;
		pmfp->mm = MM_HIMETRIC;

		pmfp->xExt = extentHimetric.cx;
		pmfp->yExt = extentHimetric.cy;
		GlobalUnlock(hMem);
		stgm->tymed = tymed;
		stgm->hGlobal = hMem;
	}
	stgm->pUnkForRelease = NULL;
	return S_OK;
}