/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "stdafx.h"
#include "MontageFactory.h"

STDMETHODIMP _MontageFactory::CreateInstance(IUnknown *pUnkOuter,REFIID riid,void **ret) {
	METHTRACE(_MontageFactory,CreateInstance);
	CComPtr<IUnknown> uMC;
	RUN(CREATE(uMC,CLSID_MontageControlContainer));
	CComQIPtr<IMontageContainer> mc = uMC;
	CComPtr<IInitializeOther> io;
	RUN(CREATE(io,m_clsid));
	RUN(mc->put_Bootstrapper(io));
	if(pUnkOuter) { // if aggregate, return the inner unknown the class factory returned (it checked riid==IID_IUnknown)
		*ret = uMC;
		uMC.p = 0; // keep ref
		return S_OK;
	}
	else
		return mc->QueryInterface(riid,ret);
}
STDMETHODIMP _MontageFactory::LockServer(BOOL fLock) {
	METHTRACE(_MontageFactory,LockServer);
	if (fLock)
		_Module.Lock();
	else
		_Module.Unlock();
	return S_OK;
}
LPOLESTR g_szCLSID = L"CLSID",
	g_szTypeLib = L"TypeLib",
	g_szName = L"Name",
	g_szShort = L"Short",
	g_szProgID = L"ProgID",
	g_szVersIndProgID = L"VersIndProgID",
	g_szLocal = L"Local";
HRESULT MontageFactory::Register(UINT resID,bool reg,REFCLSID rclsid,REFGUID rtypeid,LPOLESTR name,
	LPOLESTR shortName,LPOLESTR progID,LPOLESTR versIndProgID) {
	METHTRACE(MontageFactory,Register);
	_ATL_REGMAP_ENTRY map[8];
	OLECHAR szCLSID[40],szTypeLib[40];
	StringFromGUID2(rclsid,szCLSID,40);
	StringFromGUID2(rtypeid,szTypeLib,40);
	map[0].szKey = g_szCLSID;
	map[0].szData = szCLSID;
	map[1].szKey = g_szTypeLib;
	map[1].szData = szTypeLib;
	map[2].szKey = g_szName;
	map[2].szData = name;
	map[3].szKey = g_szShort;
	map[3].szData = shortName;
	map[4].szKey = g_szProgID;
	map[4].szData = progID;
	map[5].szKey = g_szVersIndProgID;
	map[5].szData = versIndProgID;
	HINSTANCE hMod = _Module.GetModuleInstance();
	TCHAR buf[400];
	GetModuleFileName(hMod,buf,sizeof(buf));
	OLECHAR buf2[400];
	ATLA2WHELPER(buf2,buf,strlen(buf));
	int lastBS = wcslen(buf2);
	while(buf2[--lastBS]!='\\');
	wcscpy(buf2+lastBS+1,L"local.exe");
	map[6].szKey = g_szLocal;
	map[6].szData = buf2;
	map[7].szKey = map[7].szData = 0;
	return _Module.UpdateRegistryFromResource(resID, reg, map);
}
