/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// this factory creates instances of montage with some bootstrapper
class _MontageFactory :
	public IClassFactory,
	public CComObjectRoot
{
protected:
	CLSID m_clsid;
public:
BEGIN_COM_MAP(_MontageFactory)
	COM_INTERFACE_ENTRY(IClassFactory)
END_COM_MAP()

// IClassFactory
    STDMETHODIMP CreateInstance(IUnknown *pUnkOuter,REFIID riid,void **ppvObject);
	STDMETHODIMP LockServer(BOOL fLock);
};

struct MontageFactory : CComObject<_MontageFactory> {
	MontageFactory(REFCLSID rcls) {
		m_clsid = rcls;
	}
	static HRESULT Register(UINT resourceID, bool reg,REFCLSID rclsid,REFGUID typelib,LPOLESTR name,
		LPOLESTR shortName,LPOLESTR progID,LPOLESTR versIndProgID);
};
