/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include <windows.h>
// I can't get IsAccelerator to work, so I rewrite
bool NotherIsAccelerator(HACCEL hAccel,INT cAccel,LPMSG lpmsg,WORD *ret) {
	if(!cAccel)
		return false;
	BYTE held = 0;
	bool found = false;
	if(HIBYTE(GetAsyncKeyState(VK_MENU)))
		held |= FALT;
	if(HIBYTE(GetAsyncKeyState(VK_CONTROL)))
		held |= FCONTROL;
	if(HIBYTE(GetAsyncKeyState(VK_SHIFT)))
		held |= FSHIFT;
	const ACCEL *aa = (ACCEL*)GlobalLock(hAccel);
	for(int j = 0;j<cAccel;++j) {
		// only process WM_KEYxx messages for FVIRTKEY,
		// only WM_CHAR for !FVIRTKEY
		if(aa[j].fVirt&FVIRTKEY) {
			if((aa[j].fVirt&(FALT|FCONTROL|FSHIFT))!=held)
				continue;
			if(lpmsg->message==WM_CHAR)
				continue;
		}
		else {
			// it doesn't seem to make sense to combine FCONTROL etc with !FVIRTKEY
			// but maybe it does?
			if(lpmsg->message!=WM_CHAR)
				continue;
		}
		if(aa[j].key!=lpmsg->wParam)
			continue;
		if(ret)
			*ret = aa[j].cmd;
		found = true;
		break;
	}
	GlobalUnlock(hAccel);
	return found;
}