/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// the -1s are b/c midl-generated structs contain array[1]
inline PDGSHAPEDESC allocDGShape(int nPoints) {
	PDGSHAPEDESC ret = (PDGSHAPEDESC)CoTaskMemAlloc(sizeof(DGSHAPEDESC)+(nPoints-1)*sizeof(POINTD));
	_ASSERTE(ret);
	ret->n = nPoints;
	return ret;
}
inline PDGSHAPESDESC allocDGShapes(int nShapes) {
	PDGSHAPESDESC ret = (PDGSHAPESDESC)CoTaskMemAlloc(sizeof(DGSHAPESDESC)+(nShapes-1)*sizeof(PDGSHAPEDESC));
	_ASSERTE(ret);
	ret->n = nShapes;
	return ret;
}
inline void freeDGShape(PDGSHAPEDESC d) {
	CoTaskMemFree(d);
}
inline void freeDGShapes(PDGSHAPESDESC d) {
	for(int i = 0;i!=d->n;++i)
		freeDGShape(d->sps[i]);
	CoTaskMemFree(d);
}