/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


inline HRESULT ambiance(LPOLESTR name,MBasics &mb,IDispatchEx **retAmb, IMoniker **retMk) {
    FUNTRACE(ambiance);

	CComPtr<IDispatchEx> bienMap;
    ItemMoniker mkAmbMap(L"Ambient Map");
    SLOOK(mkAmbMap->BindToObject(mb.bctx,mb.mkG,riidret(&bienMap)));
    if(!bienMap) {
    	SRUN(CREATE(bienMap,CLSID_MCCAmbientMapper));
        mkAmbMap.Release();
    	SRUN(mb.add(L"Ambient Map",bienMap,dont_keep,&mkAmbMap));
    }
    CComPtr<IMoniker> mkAmbiente;
	SRUN(CoCreateInstance(CLSID_MCCStyle,0,CLSCTX_ALL,riidret(retAmb)));
	SRUN(CComQIPtr<IMCCStyle>(*retAmb)->put_Defer(bienMap));

	// persist
	CComPtr<IHoldOnePointer> hopBien;
	SRUN(CREATE(hopBien,CLSID_OnePointerPersistor));
	SRUN(mb.add(name,hopBien,dont_keep,&mkAmbiente));
	SRUN(hopBien->put_Moniker(mkAmbMap));
	SRUN(CComQIPtr<DIPersistor>(hopBien)->SetSubject(true,*retAmb));
	SRUN(mkAmbiente->ComposeWith(mb.goSubject,false,retMk));
	return S_OK;
}

