/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// much to my chagrin, asserts compile out the expression entirely in release builds
// e.g. CHECK(SetMapMode(hdc,MM_HIMETRIC));
#define ScheckTrue(e, exp, file, line) do { if(!e) { stopMTrace(); if(_CrtDbgReport(_CRT_ASSERT,file,line,0,"Assertion failed: %s\n%s, line %d",exp,file,line)==1)\
    BREAK(); startMTrace(); } } while(0)
#define checkTrue(e, exp, file, line) do { if(!e) { stopMTrace(); if(_CrtDbgReport(_CRT_ASSERT,file,line,0,"0x%x assertion failed: %s\n%s, line %d",this,exp,file,line)==1)\
    BREAK(); startMTrace(); } } while(0)
#ifdef _DEBUG
// inline void checkTrue(bool e, char *exp, char *file, int line) {
//void checkTrueReportError(bool e, char *exp, char *file, int line) {
#define ScheckTrueReportError(e, exp, file, line) do {\
	if(!e) {\
        stopMTrace();\
		DWORD error = GetLastError();\
		char buf[300];\
		FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM,0,error,0,buf,300,0);\
		if(_CrtDbgReport(_CRT_ASSERT,file,line,0,"%s\nCall failed: %s\n%s, line %d",buf,exp,file,line)==1)\
            BREAK();\
        startMTrace(); } } while(0)
#define checkTrueReportError(e, exp, file, line) do {\
	if(!e) {\
        stopMTrace();\
		DWORD error = GetLastError();\
		char buf[300];\
		FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM,0,error,0,buf,300,0);\
		if(_CrtDbgReport(_CRT_ASSERT,file,line,0,"%s\n0x%x call failed: %s\n%s, line %d",buf,this,exp,file,line)==1)\
            BREAK();\
        startMTrace(); } } while(0)
#define SCHECK(x) ScheckTrue((x)!=0,#x,__FILE__,__LINE__)
#define CHECK(x) checkTrue((x)!=0,#x,__FILE__,__LINE__)
#define SCHECKR(x) ScheckTrueReportError((x)!=0,#x,__FILE__,__LINE__)
#define CHECKR(x) checkTrueReportError((x)!=0,#x,__FILE__,__LINE__)
#else
#define SCHECK(x) (x)
#define CHECK(x) (x)
#define SCHECKR(x) (x)
#define CHECKR(x) (x)
#endif
