/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// This is all kind of arbitrary...  A way to place something relative to or into another position.
// into is a position specified by the mouse (I presume); subject is the position of an object to be pasted.
// if into is a point and subject a rect, offset subject by that point.
// if into is a rect, just copy to subject.
// if either is blank, use the other.
HRESULT combine_pos(IMCCTransform *t, const MCC_POS_INFO &into, MCC_POS_INFO &subject) {
    FUNTRACE(combine_pos);
	if(subject.postype==MCC_POS_NONE) {
		subject = into;
		return S_OK;
	}
	switch(into.postype) {
	case MCC_POS_CANVASPOINT:
		switch(subject.postype) {
		case MCC_POS_CANVASRECT:
			subject.rcl += into.ptl;
			return S_OK;
		case MCC_POS_WINDOWRECT: {
			POINT pt;
			SRUN(t->C2WP(into.ptl,&pt));
			subject.rc += pt;
			return S_OK;
		}
		default:
			SERR(E_NOTIMPL);
		}
	case MCC_POS_WINDOWPOINT:
		switch(subject.postype) {
		case MCC_POS_CANVASRECT: {
			POINTL ptl; // what is this, pat robertson or something?
			SRUN(t->W2CP(into.pt,&ptl));
			subject.rcl += ptl;
			return S_OK;
		}
		case MCC_POS_WINDOWRECT:
			subject.rc += into.pt;
			return S_OK;
		default:
			SERR(E_NOTIMPL);
		}
	case MCC_POS_WINDOWSIZE:
	case MCC_POS_CANVASSIZE:
	case MCC_POS_WINDOWRECT:
	case MCC_POS_CANVASRECT:
		subject = into;
		return S_OK;
	case MCC_POS_NONE:
		return S_OK;
	default:
		SERR(E_UNEXPECTED);
	}
}
