/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


struct copyDGMLabelInfo {
	static HRESULT copy(DGMLabelInfo* p1, DGMLabelInfo* p2)
	{
		*p1 = *p2;
		if (p1->content)
			p1->content->AddRef();
		if (p1->layout)
			p1->layout->AddRef();
		return S_OK;
	}
	static void init(DGMLabelInfo*p) {
		p->layout = 0;
		p->content = 0;
	}
	static void destroy(DGMLabelInfo* p) {
		if (p->content)
			p->content->Release();
		if (p->layout)
			p->layout->Release();
	}
};
typedef enum_iterator<IEnumDGMLabelInfo,&IID_IEnumDGMLabelInfo,DGMLabelInfo,copyDGMLabelInfo> enumLI;
