/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// I got so tired of rewriting (again!) all the Save stuff for GetMaxSize that
// I wrote this dummy stream.  Just create one with CComObjectStack,
// ask yourself to save to it, and then read m_pos for the amount of bytes that
// would be written.
// Be damn sure your Write or any contained objects' don't use any of
// the more interesting methods, though!
struct ATL_NO_VTABLE countStream :
	public CComObjectRoot,
	public IStream
{
	ULARGE_INTEGER m_pos;

BEGIN_COM_MAP(countStream)
    COM_INTERFACE_ENTRY(IStream)
END_COM_MAP()

	STDMETHODIMP Read(void *pv,ULONG cb,ULONG *pcbRead) {
		ERR(E_NOTIMPL);
	}
	STDMETHODIMP Write(void const *pv,ULONG cb,ULONG *pcbWritten) {
		m_pos.QuadPart += (*pcbWritten = cb);
		return S_OK;
	}
	STDMETHODIMP Seek(LARGE_INTEGER dlibMove,DWORD dwOrigin,ULARGE_INTEGER *plibNewPosition) {
		switch(dwOrigin) {
		case STREAM_SEEK_SET:
			*plibNewPosition = m_pos = *(ULARGE_INTEGER*)&dlibMove;
			return S_OK;
		case STREAM_SEEK_CUR:
			m_pos.QuadPart += dlibMove.QuadPart;
			*plibNewPosition = m_pos;
			return S_OK;
		default:
			ERR(E_NOTIMPL);
		}
	}
	STDMETHODIMP SetSize(ULARGE_INTEGER libNewSize) {
		ERR(E_NOTIMPL);
	}
	STDMETHODIMP CopyTo(IStream *pstm,ULARGE_INTEGER cb,ULARGE_INTEGER *pcbRead,ULARGE_INTEGER *pcbWritten) {
		ERR(E_NOTIMPL);
	}
	STDMETHODIMP Commit(DWORD grfCommitFlags) {
		return S_OK;
	}
	STDMETHODIMP Revert() {
		ERR(E_NOTIMPL);
	}
	STDMETHODIMP LockRegion(ULARGE_INTEGER libOffset,ULARGE_INTEGER cb,DWORD dwLockType) {
		ERR(E_NOTIMPL);
	}
	STDMETHODIMP UnlockRegion(ULARGE_INTEGER libOffset,ULARGE_INTEGER cb,DWORD dwLockType) {
		ERR(E_NOTIMPL);
	}
	STDMETHODIMP Stat(STATSTG *pstatstg,DWORD grfStatFlag) {
		ERR(E_NOTIMPL);
	}
	STDMETHODIMP Clone(IStream **ppstm) {
		ERR(E_NOTIMPL);
	}
};