/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


inline HRESULT createLayer(MBasics &mb,LPOLESTR name,IMCCLayer *frontOf,IMoniker *mkLayerOrdering,
					IDispatchEx *ambiance, IMoniker *mkAmbiance, IMCCLayer **retLayer,IMoniker **retMk) {
    FUNTRACE(createLayer);
	CComPtr<IMCCLayer> layer;
	CComPtr<IMoniker> mkLayer,mkSiteOrdering,mkLayerPersistor;
	SRUN(mb.c->new_Layer(&layer));
	SRUN(layer->PutBefore(frontOf));
	if(ambiance)
		SRUN(layer->put_DefaultAmbiance(ambiance));
	CComPtr<IMCCSiteOrdering> siteOrdering;
	SRUN(siteOrdering.CoCreateInstance(CLSID_MCCSiteOrdering));
	char name2[100];
	USES_CONVERSION;
	// bad Unicode
	wsprintf(name2,"%S Site Ordering",name);
	SRUN(mb.add(A2W(name2),siteOrdering,dont_keep,&mkSiteOrdering));
	CComPtr<IMCCLayerPersistor> layerPersistor;
	SRUN(layerPersistor.CoCreateInstance(CLSID_MCCLayerPersistor));
	wsprintf(name2,"%S Layer",name);
	SRUN(mb.add(A2W(name2),layerPersistor,dont_keep,&mkLayerPersistor));
	SRUN(layerPersistor->Initialize(mb.mkP,mkLayerOrdering,mkSiteOrdering,mkAmbiance));
	SRUN(CComQIPtr<DIPersistor>(layerPersistor)->SetSubject(true,layer));
	SRUN(layer->put_RelMoniker(mkLayerPersistor));
	SRUN(layer->put_OrderMk(mkSiteOrdering));
	if(retMk)
		SRUN(mkLayerPersistor->ComposeWith(mb.goSubject,false,retMk));
	SRUN(layer.CopyTo(retLayer));
	return S_OK;
}

