/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "extList.h"

inline HRESULT ensureNativeFormat(LPOLESTR ext) {
	CRegKey natives;
	SCHECK(!natives.Create(HKEY_CURRENT_USER,"Software\\AT&T\\Montage"));
	DWORD count(100);
	TCHAR exts[100];
	if(!natives.QueryValue("Native Formats",0,exts,&count)) {
		USES_CONVERSION;
		if(isInExtList(T2OLE(exts),ext))
			return S_FALSE;
		int len = (int)strlen(exts);
		sprintf(exts+len,"|%S",ext);
	}
	else
		sprintf(exts,"%S",ext);
	SCHECK(!natives.SetValue("Native Formats",REG_SZ,exts,ULONG(strlen(exts)+1)));
	return S_OK;
}