/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// objects can't be trusted to expose IPersist just because they expose
// IPersistStream/IPersistStorage (argh)
inline HRESULT getObjectCLSID(IUnknown *u, CLSID *ret) {
	if(CComQIPtr<IPersist> p = u)
		return p->GetClassID(ret);
	else if(CComQIPtr<IPersistStorage> ps = u)
		return ps->GetClassID(ret);
	else if(CComQIPtr<IPersistStream> ps2 = u)
		return ps2->GetClassID(ret);
	else if(CComQIPtr<IPersistStreamInit> psi = u)
		return psi->GetClassID(ret);
	SERR(E_FAIL);
}
