/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "stdafx.h"
#include <dispex.h>
#include "../Group/Group.h"
#include "../Montage/Montage.h"

int getPortFormats(IUnknown *obj,bool export, LPOLESTR dest) {
    FUNTRACE(getPortFormats);
	enum MFP_PORTTYPE type = export?MFP_EXPORT:MFP_IMPORT;
	CComQIPtr<IMontageContainer> mc = obj;
	if(!mc)
		return 0;
	LPOLESTR fit = dest;
	CComPtr<IMCCFileFormat> portmat;
	SRUN(mc->get_FilePort(&portmat));
	CComPtr<IMCCFilePort> port;
	SRUN(portmat.QueryInterface(&port));
	CComPtr<IEnumString> es;
	SRUN(port->EnumDescriptions(type,&es));
	// translate fileport syntax to OpenFileName syntax
	for(olestr_iterator i(es);i!=olestr_iterator();++i) {
		LPOLESTR s = *i,
			d = wcschr(s,':');
		_ASSERTE(d);
		d++;
		WCHAR desc[300],*id;
		id = desc+swprintf(desc,L"%s (",d);
		WCHAR wilds[100],*iw = wilds;
		LPOLESTR ext = s,end = s+wcslen(s),sep;
		LPCOLESTR Sep = L"|:";
		while(sep = find_first_of(ext,end,Sep,Sep+2)) {
			if(sep==ext) {// empty
				if(*sep==':')
					break;
				ext++;
				continue;
			}
			if(iw!=wilds)
				*iw++ = *id++ = ';';
			iw += swprintf(iw,L"*.%.*s",sep-ext,ext);
			id += swprintf(id,L".%.*s",sep-ext,ext);
			ext = sep+1;
			if(*sep==':')
				break;
		}
		wcscpy(id,L")");
		wcscpy(fit,desc);
		fit += wcslen(desc)+1;
		wcscpy(fit,wilds);
		fit += wcslen(wilds)+1;
	}
	*fit++ = 0; // double null to end
	return fit-dest;
}
