/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "stdafx.h"
#include "getSites.h"

VS *getSites(IGroup *group,IItemSet *iset, bool realize) {
	FUNTRACE(getSites);
	HRESULT hr;
	CComPtr<IBindCtx> bctx;
	SRUN(CreateBindCtx(0,&bctx));
	CComPtr<IMoniker> mkG;
	SRUN(FoolishCreatePointerMoniker(group,&mkG));
	CComPtr<IEnumMoniker> em;
	SRUN(iset->Enum(&em));
	VS *ret = new VS;
	for(mk_iterator i(em);i!=mk_iterator();++i) {
		CComPtr<DIPersistor> sp; // site persistor
		hr = (*i)->BindToObject(bctx,mkG,riidret(&sp));
		if(hr==E_NOINTERFACE)
			continue;
		SRUN(hr);
		if(realize) {
			CComQIPtr<IGroupItem> item(sp);
			_ASSERTE(item);
			SRUN(item->Realize(bctx));
		}
		CComPtr<IUnknown> uS;
		SRUN(sp->get_Subject(&uS));
		if(!uS) {// esp if !realize
			delete ret;
			return 0;
		}
		IMCCSite *s = 0; // keep ref
		hr = uS.QueryInterface(&s);
		if(hr==E_NOINTERFACE) // set may have non-sites in it (but doesn't)
			continue;
		SRUN(hr);
		ret->push_back(s);
	}
	return ret;
}
