/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


struct hashMonikerTraits {
	static const size_t bucket_size = 4,
		min_buckets = 8;
	size_t operator ()(IMoniker *mk) const {
		DWORD ret;
		SLOOK(mk->Hash(&ret));
		return ret;
	}
	bool operator ()(IMoniker *mk1,IMoniker *mk2) const {
        METHTRACE(hashMonikerTraits,parens);
		// yuck!  wish we could still use IsEqual but they want an ordering!
		BindCtx bctx;
		LPOLESTR n1,n2;
		RUN(mk1->GetDisplayName(bctx,0,&n1));
		RUN(mk2->GetDisplayName(bctx,0,&n2));
		bool result = wcscmp(n1,n2)>0;
		CoTaskMemFree(n1);
		CoTaskMemFree(n2);
		return result;
	}
};
typedef hash_set<IMoniker *,hashMonikerTraits> mkSet;
template<class V>
class mkMap : public hash_map<IMoniker *,V,hashMonikerTraits> {};

