/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "stdafx.h"
#include "MBasics.h"

HRESULT installMode(MBasics &mb,IUnknown *mode,IMoniker *mkMode,
                    IMCCLayer *layer, IMoniker *mkLayer,
                    IMCCModeSwitcher *switcher, IMoniker *mkSwitcher,
                    BSTR shortName,BSTR fullName, bool activate) {
    CComPtr<IMCCSite> site;
	SRUN(mb.c->new_Site(&site));
	SRUN(site->put_Control(mode));
	SRUN(site->put_Layer(layer));
	CComPtr<DIMCCModeDelegate> md;
	SRUN(switcher->new_Delegate(&md));
	SRUN(md->put_Name(shortName));
	SRUN(md->put_Order(200)); // right?
    if(activate)
	    SRUN(md->Activate(false));
	CComPtr<DIMCCControlMode> cm;
	SRUN(CREATE(cm,CLSID_MCCControlMode));
	SRUN(cm->Initialize(md));
	SRUN(CComQIPtr<IObjectWithSite>(cm)->SetSite(site)); // sets up sinks
	SRUN(site->put_Intent(MCCS_COUIACTIVE));

    CComBSTR biggerNames = fullName;
    biggerNames += " Delegate";

	//  make mode & its supporters persistent
	// Delegate's persistor
	CComPtr<DIServerCreationPersistor> scp;
	SRUN(CREATE(scp,CLSID_ServerCreationPersistor));
	CComPtr<IMoniker> mkDelP,mkDel;
	SRUN(mb.add(biggerNames,scp,keep_configuration,&mkDelP));
	SRUN(mkDelP->ComposeWith(mb.goSubject,false,&mkDel));
	CComPtr<IMoniker> delClass;
	SRUN(CreateClassMoniker(CLSID_MCCModeDelegate,&delClass));
	SRUN(scp->put_ServerMoniker(ComposeMk(mkSwitcher,delClass)));
	SRUN(CComQIPtr<DIPersistor>(scp)->SetSubject(true,md));
	scp.Release();

	// ControlMode's persistor
    biggerNames = fullName;
    biggerNames += " ControlMode";
    CComPtr<IHoldSomePointers> hsp;
	SRUN(CREATE(hsp,CLSID_SomePointersPersistor));
	CComPtr<IMoniker> mkControlModeP,mkControlMode;
	SRUN(mb.add(biggerNames,hsp,dont_keep,&mkControlModeP));
	SRUN(mkControlModeP->ComposeWith(mb.goSubject,false,&mkControlMode));
	SRUN(hsp->Push(mkDel));
	SRUN(CComQIPtr<DIPersistor>(hsp)->SetSubject(true,cm));
	hsp.Release();

	// site's
    biggerNames = fullName;
    biggerNames += " Site";
	CComPtr<IMCCSitePersistor> sp;
	SRUN(CREATE(sp,CLSID_MCCSitePersistor));
	CComPtr<IMoniker> mkGDMSite;
	SRUN(mb.add(biggerNames,sp,keep_configuration,&mkGDMSite));
	SRUN(site->put_RelMoniker(mkGDMSite));
	CComPtr<IMoniker> mkOrder;
	SRUN(layer->get_OrderMk(&mkOrder));
	SRUN(sp->Initialize(mb.mkP,mkLayer,mkOrder,mkMode,0,0));
	SRUN(CComQIPtr<DIPersistor>(sp)->SetSubject(true,site));
	CComPtr<IOrderedItemList> oil;
	SRUN(sp->get_InitList(&oil));
	SRUN(oil->SetMoniker(10,mkControlMode)); //10?
    return S_OK;
}