/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// transforms a map iterator into a value iterator by throwing out the keys
template<class Iter, class T>
struct itSecond {
	Iter i;
	itSecond() {}
	itSecond(Iter i) : i(i) {}
	T &operator *() { return (*i).second; }
	itSecond operator ++(int) {
		Iter j = i;
		i++;
		return itSecond<Iter,T>(j);
	}
	itSecond &operator ++() { i++; return *this; }
	bool operator !=(itSecond<Iter,T> other) {
		return i!=other.i;
	}
	bool operator ==(itSecond<Iter,T> other) {
		return i==other.i;
	}
};
