/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// dump traces to file because they are so voluminous they overrun the debugger
#ifdef TRACE_CALLS
struct MTraceMethod {
    int number;
	MTraceMethod() : number(callNumber()) {}
	~MTraceMethod() {
		MTrace(ME)("%x\t%d\t%d\treturn\n",GetCurrentThreadId(),callDepth(false),number);
	}
};
#define MAYBE_TRACE_CALLDEPTH() MTraceMethod trace_meth
#define GET_CALLDEPTH() callDepth(true)
#define MAYBE_TRACE_
#else
#define MAYBE_TRACE_CALLDEPTH() (void)0
#define GET_CALLDEPTH() 0
#endif

#ifdef TRACE_METHODS
#define TRACE_A_CALL(depth,callnum,tis,klass,innerface,mettid,file,line) MTrace(ME)("%x\t%d\t%d\tcall\t%p\t%s\t%s\t%s\t%s\t%d\n",GetCurrentThreadId(),depth,callnum,tis,klass,innerface,mettid,file,line)
#define IMETHTRACE(Class,Interface,Method) MAYBE_TRACE_CALLDEPTH(); TRACE_A_CALL(GET_CALLDEPTH(),trace_meth.number,(Interface*)this,#Class,#Interface,#Method,__FILE__,__LINE__)
#define METHTRACE(Class,Method) MAYBE_TRACE_CALLDEPTH(); TRACE_A_CALL(GET_CALLDEPTH(),trace_meth.number,this,#Class,"none",#Method,__FILE__,__LINE__)
#define FUNTRACE(Function) MAYBE_TRACE_CALLDEPTH(); TRACE_A_CALL(GET_CALLDEPTH(),trace_meth.number,0,"none","none",#Function,__FILE__,__LINE__)
#else // !TRACE_METHODS
#define IMETHTRACE(Class,Interface,Method) (void)0
#define METHTRACE(Class,Method) (void)0
#define FUNTRACE(Function) (void)0
#endif

#ifdef TRACE_STRUCTORS
#define CONSTRUCTORTRACE1(Class) MTrace(ST)("construct\t%p\t%s\n",this,#Class)
#define DESTRUCTORTRACE1(Class) MTrace(ST)("destroy\t%p\t%s\n",this,#Class)
#else // !TRACE_STRUCTORS
#define CONSTRUCTORTRACE1(Class) (void)0
#define DESTRUCTORTRACE1(Class) (void)0
#endif
#ifdef TRACE_CALLS
#define CONSTRUCTORTRACE2(Class) MTraceMethod trace_meth; TRACE_A_CALL(GET_CALLDEPTH(),trace_meth.number,this,#Class,"none",#Class,__FILE__,__LINE__)
#define DESTRUCTORTRACE2(Class) MTraceMethod trace_meth; TRACE_A_CALL(GET_CALLDEPTH(),trace_meth.number,this,#Class,"none","~"#Class,__FILE__,__LINE__)
#else
#define CONSTRUCTORTRACE2(Class) (void)0
#define DESTRUCTORTRACE2(Class) (void)0
#endif

#define CONSTRUCTORTRACE(Class) CONSTRUCTORTRACE1(Class); CONSTRUCTORTRACE2(Class)
#define DESTRUCTORTRACE(Class) DESTRUCTORTRACE1(Class); DESTRUCTORTRACE2(Class)

