/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "getSinkWhichImplements.h"
template<class I>
HRESULT layoutFromSite(IUnknown *parm,I **ret) {
    FUNTRACE(layoutFromSite);
	CComPtr<DIDGMConnector> lgc;
	if(SUCCEEDED(getSinkWhichImplements(parm,IID_IMCCSiteOwner,&lgc))) {
		CComPtr<IUnknown> uE;
		SRUN(lgc->get_LayoutObject(&uE));
		return uE.QueryInterface(ret);
	}
	SERR(E_FAIL);
}
CComPtr<IMCCSite> siteFromNode(IDGDrawnNode *n);
CComPtr<IMCCSite> siteFromEdge(IDGDrawnEdge *e);
CComPtr<IMCCSitePersistor> sitePersistor(IMCCSite *s);
CComPtr<IMoniker> mkConnectorFromSitePersistor(IMCCSitePersistor *sp);
CComPtr<DIPersistor> connectorPersistorFromMkConnector(IMoniker *mkConnector,IMoniker *mkGroup);
CComPtr<IMoniker> mkLayoutFromConnectorPersistor(IUnknown *per);
CComPtr<IMoniker> mkLayoutFromSitePersistor(IMCCSitePersistor *sp,IMontageContainer *mc);
CComPtr<IMoniker> mkLayoutFromSite(IMCCSite *s);