/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


struct oleOrder {
	bool operator ()(LPOLESTR s1, LPOLESTR s2) const {
		return _wcsicmp(s1,s2)<0;
	}
};
struct oleHashTraits {
	static const size_t bucket_size = 4,
		min_buckets = 8;
	// stolen from stl/hashtable.h, widened,de-cased
	size_t operator ()(LPOLESTR s) const {
		unsigned long h = 0;
		for ( ; *s; ++s)
			h = 5*tolower(h) + *s;

		return size_t(h);
	}
	bool operator ()(LPOLESTR s1, LPOLESTR s2) const {
		return _wcsicmp(s1,s2)<0;
	}
};
