/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


inline P operator +(P a,SIZE b) {
	a.X += b.cx;
	a.Y += b.cy;
	return a;
}
inline P operator -(P a,SIZE b) {
	a.X -= b.cx;
	a.Y -= b.cy;
	return a;
}
inline P operator *(P a,int b) {
	a.X *= b;
	a.Y *= b;
	return a;
}
inline P operator /(P a,int b) {
	a.X /= b;
	a.Y /= b;
	return a;
}
inline int dsqr(P a,P b) {
	return (a.X-b.X)*(a.X-b.X) + (a.Y-b.Y)*(a.Y-b.Y);
}
#ifndef P_IS_SIZE
inline P operator +(P a,P b) {
	a.X += b.x;
	a.Y += b.y;
	return a;
}
inline SIZE operator -(P p1,P p2) {
	return size(p1.X-p2.X,p1.Y-p2.Y);
}
#endif