/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#ifndef POINTD_H
#define POINTD_H
#include "rect.h"
inline POINTD pointd(double x, double y) {
	POINTD ret = {x,y};
	return ret;
}
inline POINTD pointd(POINTL p) {
	POINTD ret = {p.x/1000.0,p.y/1000.0};
	return ret;
}
inline POINTL pointl(POINTD p) {
	POINTL ret = {long(p.x*1000.0),long(p.y*1000.0)};
	return ret;
}
inline SIZEL size(POINTD p) {
	POINTL p2 = pointl(p);
	return size(p2.x,p2.y);
}
inline RECTL rectl(RECTD r) {
	POINTL p1 = pointl(pointd(r.left,r.top)), p2 = pointl(pointd(r.right,r.bottom));
	RECTL ret = {p1.x,p1.y,p2.x,p2.y};
	return ret;
}
inline RECTD rectd(double left,double top,double right,double bottom) {
    RECTD ret = {left,top,right,bottom};
    return ret;
}
inline RECTD rectd(RECTL r) {
	POINTD p1 = pointd(pointl(r.left,r.top)),p2 = pointd(pointl(r.right,r.bottom));
	RECTD ret = {p1.x,p1.y,p2.x,p2.y};
	return ret;
}
#endif POINTD_H