/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// Coord and POINTD are the same in binary - the one reason we have POINTD at all
// is that you can't use fancy classes with IDL
inline POINTD pointd(const Coord &c) {
	return pointd(c.x,c.y);
}
inline Coord coord(const POINTD &p) {
	return Coord(p.x,p.y);
}
inline RECTD rectd(const Rect &r) {
	return rectd(r.l,r.t,r.r,r.b);
}
inline Rect rect(const RECTD &r) {
	return Rect(r.left,r.top,r.right,r.bottom);
}
