/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


inline bool operator ==(R r1,R r2) {
	return (r1.left==r2.left)&&(r1.top==r2.top)&&
		(r1.right==r2.right)&&(r1.bottom==r2.bottom);
}
inline bool operator !=(R r1,R r2) {
	return !(r1==r2);
}
inline bool within(R r,R outer) {
	return between(r.left,outer.left,outer.right)&&
		between(r.right,outer.left,outer.right)&&
		between(r.bottom,outer.bottom,outer.top)&&
		between(r.top,outer.bottom,outer.top);
}
inline R operator +(R r1,R r2) {
	R ret = {r1.left+r2.left,r1.top+r2.top,r1.right+r2.right,r1.bottom+r2.bottom};
	return ret;
}
inline R operator -(R r1,R r2) {
	R ret = {r1.left-r2.left,r1.top-r2.top,r1.right-r2.right,r1.bottom-r2.bottom};
	return ret;
}
inline R operator +(R r,SIZE s) {
	r.left += s.cx;
	r.right += s.cx;
	r.top += s.cy;
	r.bottom += s.cy;
	return r;
}
inline R operator -(R r,SIZE s) {
	r.left -= s.cx;
	r.right -= s.cx;
	r.top -= s.cy;
	r.bottom -= s.cy;
	return r;
}
inline R operator +(R r,POINT p) {
	return r+*(SIZE*)&p;
}
inline R operator +(R r,POINTL p) {
	return r+*(SIZE*)&p;
}
inline long wid(R r) {
	return tabs(r.right-r.left);
}
inline long hei(R r) {
	return tabs(r.bottom-r.top);
}
inline SIZEL siz(R r) {
	SIZEL rv;
	rv.cx = wid(r);
	rv.cy = hei(r);
	return rv;
}
inline void ScaleRect(R &r,long xmult,long xdiv,long ymult,long ydiv) {
	(r.left *= xmult) /= xdiv?xdiv:1;
	(r.top *= ymult) /= ydiv?ydiv:1;
	(r.right *= xmult) /= xdiv?xdiv:1;
	(r.bottom *= ymult) /= ydiv?ydiv:1;
}
// InflateRect doesn't deal with cartesian
inline void FlateRect(R &r,int dx,int dy) {
	r.left -= dx;
	r.right += dx;
	if(r.top>r.bottom) {
		r.top += dy;
		r.bottom -= dy;
	}
	else {
		r.bottom += dy;
		r.top -= dy;
	}
}
// union
inline R operator |(R r1,R r2) {
	if(r1.top>r1.bottom||r2.top>r2.bottom) { // cartesian
		R ret = {min(r1.left,r2.left),max(r1.top,r2.top),max(r1.right,r2.right),min(r1.bottom,r2.bottom)};
		return ret;
	}
	else {
		R ret = {min(r1.left,r2.left),min(r1.top,r2.top),max(r1.right,r2.right),max(r1.bottom,r2.bottom)};
		return ret;
	}
}
