/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#ifndef REGGY_LIBID
#error Define REGGY_LIBID to use REGGY_RID
#endif
struct reggy_things {
	LPOLESTR sLib,sCla;
    reggy_things(_ATL_REGMAP_ENTRY *are,REFCLSID cls) {
	    are[0].szKey = L"TypeLib";
        HRESULT hr = StringFromCLSID(REGGY_LIBID,&sLib);
	    _ASSERTE(SUCCEEDED(hr));
	    are[0].szData = sLib;
	    are[1].szKey = L"CLSID";
        hr = StringFromCLSID(cls,&sCla);
	    _ASSERTE(SUCCEEDED(hr));
	    are[1].szData = sCla;
    }
    ~reggy_things() {
	    CoTaskMemFree(sLib);
	    CoTaskMemFree(sCla);
    }
};
inline HRESULT reggy(REFCLSID cls, UINT resourceId, BOOL bRegister) {
	HRESULT hr;
	_ATL_REGMAP_ENTRY are[4];
    reggy_things stf(are,cls);
	are[2].szKey = are[2].szData = 0;
    hr =
	__if_exists(_Module)
	{
    	_Module
	}
	__if_not_exists(_Module)
	{
		(*ATL::_pAtlModule)
	}
        .UpdateRegistryFromResource(resourceId, bRegister,are);
	return hr;
}
#define REGGY_RID(resourceId) static HRESULT WINAPI UpdateRegistry(BOOL bRegister) {\
		return reggy(GetObjectCLSID(),resourceId,bRegister);}
