/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// this is a dumb macro trick.  I think it clarifies COM,
// but it's lousy C++.  The funny thing is, it makes COM
// code look like BASIC... (COM's origin?)

// have to use these without ; in the then-part of an
// if-then-else

/*
#if defined(_DEBUG)
// very strict version for debugging
#include <crtdbg.h>
#define RUN(x) _ASSERTE(SUCCEEDED(hr = (x)));
#define RUNB RUN
#define RUNV RUN
#define RUNL RUN
#define RUNKILL(o,x) RUN(x)
#define RUNKILLN(o,x) RUN(x)
#else
#define RUN_STRICT
#ifdef RUN_STRICT
#include <assert.h>
#define RUN(x) assert(SUCCEEDED(hr = (x)));
#define RUNB RUN
#define RUNV RUN
#define RUNL RUN
#define RUNKILL(o,x) RUN(x)
#define RUNKILLN(o,x) RUN(x)
#else
// exception-style handling for release (not a great system, but effective.)
#define RUN(x) { if(FAILED(hr = x)) return hr; }
#define RUNB(x) { if(FAILED(hr = x)) break; }
#define RUNV(x) { if(FAILED(hr = x)) return; }
#define RUNL(x) { if(FAILED(hr = x)) return 0; }
#define RUNKILL(o,x) if(FAILED(hr = x)) {delete o; return hr;}
#define RUNKILLN(o,x) if(FAILED(hr = x)) {delete o; return 0;}
#endif RUN_STRICT
#endif _DEBUG
*/
#ifndef RUN_H
#define RUN_H
#ifdef _DEBUG
#include <crtdbg.h>
// these defined as macros rather than inline so that debugger doesn't stop on them
// watch hrRun to see what happened
//inline void COMFail(HRESULT hr,char *file,unsigned line) {
#define SCOMFail(hr,file,line) do { STraceErr(hr,file,line); stopMTrace(); if(_CrtDbgReport(_CRT_ASSERT,file,line,0,"COM call failed: 0x%x\n%s, line %d",hrRun,file,line)==1)\
    BREAK(); startMTrace(); } while(0)
#define COMFail(hr,file,line) do { TraceErr(hr,this,file,line); stopMTrace(); if(_CrtDbgReport(_CRT_ASSERT,file,line,0,"call failed: 0x%x\nthis: 0x%x; %s, line %d",hrRun,this,file,line)==1)\
    BREAK(); startMTrace(); } while(0)
#else
//inline void COMFail(HRESULT hr,char *file,unsigned line) {
#define SCOMFail(hr,file,line) do {\
	STraceErr(hr,file,line);\
    stopMTrace();\
    char bufCOMFAIL[300];\
	wsprintf(bufCOMFAIL,"Error: 0x%x\n%s, line %d",hrRun,file,line);\
    ::MessageBox(0,bufCOMFAIL,"COM call failed",MB_OK);\
	BREAK();} while(0)
#define COMFail(hr,file,line) do {\
	TraceErr(hr,this,file,line);\
    stopMTrace();\
    char bufCOMFAIL[300];\
	wsprintf(bufCOMFAIL,"0x%x call failed: 0x%x\n%s, line %d",this,hrRun,file,line);\
    ::MessageBox(0,bufCOMFAIL,"COM call failed",MB_OK);\
	BREAK();} while(0)
#endif
//inline void AssertSucceeded(HRESULT hr,char *file,unsigned line) {
#define SAssertSucceeded(hr,file,line) do { HRESULT hrRun = hr; if(FAILED(hrRun)) SCOMFail(hrRun,file,line); } while(0)
#define AssertSucceeded(hr,file,line) do { HRESULT hrRun = hr; if(FAILED(hrRun)) COMFail(hrRun,file,line); } while(0)
//inline void AssertOK(HRESULT hr,char *file,unsigned line) {
#define SAssertOK(hr,file,line) do { HRESULT hrRun = hr; if(hrRun!=S_OK) SCOMFail(hrRun,file,line); } while(0)
#define AssertOK(hr,file,line) do { HRESULT hrRun = hr; if(hrRun!=S_OK) COMFail(hrRun,file,line); } while(0)
#define Srun_niok(x,file,line) do { HRESULT x2 = x; if(x2!=E_NOTIMPL) SAssertSucceeded(x2,file,line); } while(0)
#define run_niok(x,file,line) do { HRESULT x2 = x; if(x2!=E_NOTIMPL) AssertSucceeded(x2,file,line); } while(0)
// assert if call doesn't succeed
#define SRUN(x) do {SAssertSucceeded(x,__FILE__,__LINE__); } while(0)
#define RUN(x) do {AssertSucceeded(x,__FILE__,__LINE__); } while(0)
// assert if it's not S_OK
#define SRUNO(x) do {SAssertOK(x,__FILE__,__LINE__); } while(0)
#define RUNO(x) do {AssertOK(x,__FILE__,__LINE__); } while(0)
// return error if it occurs (sorta like exception)
#define SRUNRET(x) do {HRESULT hrRun = (x); if(FAILED(hrRun)) {SLOOK(hrRun); return hrRun; } } while(0)
#define RUNRET(x) do {HRESULT hrRun = (x); if(FAILED(hrRun)) {LOOK(hrRun); return hrRun; } } while(0)
#define RUNRET1(x,hr1) do{HRESULT hrRunJ = (x); if(hrRunJ==hr1) {LOOK(hrRunJ); return hrRunJ; } RUN(hrRunJ); } while(0)
#define SRUNGOTO(x,l) do {hr = (x); if(FAILED(hr)) goto l; } while(0)
#define RUNGOTO(x,l) do {hr = (x); if(FAILED(hr)) goto l; } while(0)
// treat E_NOTIMPL as success
#define SRUN_NIOK(x) do {Srun_niok(x,__FILE__,__LINE__); } while(0)
#define RUN_NIOK(x) do {run_niok(x,__FILE__,__LINE__); } while(0)

#endif