/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// so that we know
#if defined(TRACE_CREATE)
inline void TraceCreate(char *classname, char *file,int line) {
	ATLTRACE2("%s(%d): created %s\n",file,line,classname);
}
inline void TraceCreate(const CLSID &clsid, char *file,int line) {
	OLECHAR buf[50];
	StringFromGUID2(clsid,buf,50);
	ATLTRACE2("%s(%d): created %S\n",file,line,buf);
}
#define TRACECREATE(exp) TraceCreate(#exp,__FILE__,__LINE__)
#define TRACECREATEV(exp) TraceCreate(exp,__FILE__,__LINE__)
template<typename CComP>
inline HRESULT createAndTrace(CComP &p,const CLSID &clsid,char *clsname,char *file,int line) {
	HRESULT hr = p.CoCreateInstance(clsid);
	TraceCreate(clsname,file,line);
	return hr;
}
template<typename CComP>
inline HRESULT createAndTraceAggregate(CComP &p,const CLSID &clsid,IUnknown *outer,char *clsname,char *file,int line) {
	HRESULT hr = p.CoCreateInstance(clsid,outer);
	TraceCreate(clsname,file,line);
	return hr;
}
#define CREATE(obj,cls) createAndTrace(obj,cls,#cls,__FILE__,__LINE__)
#define CREATEA(obj,cls,outer) createAndTraceAggregate(obj,cls,outer,#cls,__FILE__,__LINE__)
#else
#define TRACECREATE(exp) exp
#define TRACECREATEV(exp) exp
#define CREATE(obj,cls) obj.CoCreateInstance(cls)
#define CREATEA(obj,cls,outer) obj.CoCreateInstance(cls,outer)
#endif
