/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "stdafx.h"
#include "brutePrice.h"

typedef int (*moveFun)(const RECT &,RECT &);
moveFun moveF[4] = {moveRight,moveDown,moveLeft,moveUp};

bool box_play(BPBoard::iterator o,BPState *s, BPGame *g) {
	bool played = false;
	RECT &pos = o->pos;
	for(BPState::iterator i = lower_bound(s->begin(),s->end(),*o,greater<BPObject>());i!=s->end();++i)
		if(i!=o && i->valid && intersectType(i->pos,pos)!=int_none) {
			int m = o-s->begin(),n = i-s->begin();
			int k; // try moving other
			for(k=0;k<4;++k) {
				BPState *next = new BPState(s);
				next->cost += moveF[k](pos,(*next)[n].pos);
				_ASSERTE(intersectType(pos,(*next)[n].pos)==int_none);
				g->push(next);
				played = true;
			}
			for(k=0;k<4;++k) { // try moving self
				BPState *next = new BPState(s);
				next->cost += moveF[k](i->pos,(*next)[m].pos);
				_ASSERTE(intersectType(i->pos,(*next)[m].pos)==int_none);
				g->push(next);
				played = true;
			}
		}
	return played;
}
