/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include <incrface/DinoMachineHandler.h>
struct ComDinoNode : StringNode<DinoMachine,DinoMachineHandler,CComGlobalsThreadModel>,
    IDinoNode
{
    typedef StringNode<DinoMachine,DinoMachineHandler,CComGlobalsThreadModel> Parent;
BEGIN_COM_MAP(ComDinoNode)
    COM_INTERFACE_ENTRY(IDinoNode)
    COM_INTERFACE_ENTRY_CHAIN(Parent)
END_COM_MAP()
// IDinoNode
    STDMETHODIMP get_Graph(IDGGraph **ret);
};
struct ComDinoEdge : StringEdge<DinoMachine,DinoMachineHandler,CComGlobalsThreadModel>,
    IDinoEdge
{
    typedef StringEdge<DinoMachine,DinoMachineHandler,CComGlobalsThreadModel> Parent;
BEGIN_COM_MAP(ComDinoEdge)
    COM_INTERFACE_ENTRY(IDinoEdge)
    COM_INTERFACE_ENTRY_CHAIN(Parent)
END_COM_MAP()
// IDinoEdge
    STDMETHODIMP Map(IUnknown *src,IEnumUnknown **ret);
};
struct ComDinoMach : StringGraph<DinoMachine,DinoMachineHandler,CComGlobalsThreadModel>,
    CComCoClass<ComDinoMach,&CLSID_DinographMachine>,
    IDinoMachine
{
    typedef StringGraph<DinoMachine,DinoMachineHandler,CComGlobalsThreadModel> Parent;
    REGISTER_GENERIC(L"DinoMachine")
    DECLARE_CLASSFACTORY_SINGLETON(ComDinoMach)

    ComDinoMach() : StringGraph<DinoMachine,DinoMachineHandler,CComGlobalsThreadModel>(&g_dinoMachine) {}

    DString dinotype() {
        return "dinomachine";
    }
    ComDinoNode *createNode() {
        return new CComObject<ComDinoNode>;
    }
    ComDinoEdge *createEdge() {
        return new CComObject<ComDinoEdge>;
    }
BEGIN_COM_MAP(ComDinoMach)
    COM_INTERFACE_ENTRY(IDinoMachine)
    COM_INTERFACE_ENTRY_CHAIN(Parent)
END_COM_MAP()
};