/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// translate between C and IDL double coords
inline POINTD DG2Win(Coord il) {
	POINTD ret = {il.x,il.y};
	return ret;
}
inline Coord Win2DG(POINTD w) {
	return Coord(w.x,w.y);
}
inline RECTD DG2Win(Rect r) {
	RECTD ret;
	Coord *src = (Coord*)&r;
	POINTD *dst = (POINTD*)&ret;
	dst[0] = DG2Win(src[0]);
	dst[1] = DG2Win(src[1]);
	return ret;
}
inline Rect Win2DG(RECTD r) {
	Rect ret;
	POINTD *src = (POINTD*)&r;
	Coord *dst = (Coord*)&ret;
	dst[0] = Win2DG(src[0]);
	dst[1] = Win2DG(src[1]);
	return ret;
}
