/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "pipeProcess.h"

struct IncrClient :
	IDGIncrClient,
	CComObjectRootEx<CComGlobalsThreadModel>,
	CComCoClass<IncrClient,&CLSID_DGIncrClient>,
	IConnectionPointContainerImpl<IncrClient>,
	IConnectionPointImpl<IncrClient,&IID_IDGIncrClientEvents>,
	IPersistImpl<IncrClient>
{
	PipedProcess m_piped;
	FILE *m_log,*m_instream,*m_outstream;

	static void readingThread(void*f0);

	DECLARE_CLASSFACTORY_SINGLETON(IncrClient)
	REGISTER_GENERIC(L"IncrClient")

	IncrClient();
	~IncrClient();

	void startThreads();
	void stopThreads();
	void parse();

BEGIN_COM_MAP(IncrClient)
	COM_INTERFACE_ENTRY(IDGIncrClient)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(IPersist)
END_COM_MAP()
BEGIN_CONNECTION_POINT_MAP(IncrClient)
	CONNECTION_POINT_ENTRY(IID_IDGIncrClientEvents)
END_CONNECTION_POINT_MAP()

	STDMETHODIMP StartServer(LPCOLESTR cmd,int nargs,LPCOLESTR *args);
	STDMETHODIMP FakeIt(LPCOLESTR incrfile,LPCOLESTR viewName);
	STDMETHODIMP Write(const void *text,int n);
	STDMETHODIMP Stop();
	STDMETHODIMP ProcessResponse();

};