/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include <string>
#include <map>
using namespace std;

#define MAX_LAYOUT_CHOICES 9

struct LayoutChoices :
    CComObjectRootEx<CComGlobalsThreadModel>,
    CComCoClass<LayoutChoices,&CLSID_DGLayoutChoices>,
    IDGStringAttributes
{
	DECLARE_CLASSFACTORY_SINGLETON(LayoutChoices)
    REGISTER_GENERIC(L"LayoutChoices")
BEGIN_COM_MAP(LayoutChoices)
    COM_INTERFACE_ENTRY(IDGStringAttributes)
END_COM_MAP()

    map<string,string> m_choices;
    string m_default;
    LayoutChoices();
    ~LayoutChoices();

// IDGStringAttributes
    STDMETHODIMP get_Name(BSTR *ret);
    STDMETHODIMP put_Name(BSTR val);
    STDMETHODIMP GetAttr(BSTR name, BSTR *ret);
    STDMETHODIMP SetAttr(BSTR name, BSTR value);
    STDMETHODIMP EnumAttrs(IEnumString **ret);
    STDMETHODIMP EnumChangedAttrs(IEnumString **ret) { return E_FAIL; }
};