/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


class NodePersistor :
	public CComObjectRoot,
	public CComCoClass<NodePersistor,&CLSID_DGNodePersistor>,
	public IDGNodePersistor,
	public IGroupItem,
	public IPersistStream,
	public IDispatchImpl<DIPersistor>
{
	CComBSTR m_name;
	CComPtr<IGroup> m_group;
	CComPtr<IMoniker> m_mkEngine;
	CComPtr<IStream> m_cache;
	CComQIPtr<IDGDrawnNode> m_subject;
public:
	NodePersistor();
	~NodePersistor();
	REGISTER_GENERIC(L"NodePersistor");
BEGIN_COM_MAP(NodePersistor)
	COM_INTERFACE_ENTRY(IDGNodePersistor)
	COM_INTERFACE_ENTRY(IGroupItem)
	COM_INTERFACE_ENTRY(IPersist)
	COM_INTERFACE_ENTRY(IPersistStream)
	COM_INTERFACE_ENTRY(DIPersistor)
END_COM_MAP()
// IDGNodePersistor
	STDMETHODIMP put_Name(BSTR val);
	STDMETHODIMP put_Cache(IStream *dgdata);
	STDMETHODIMP put_MkEngine(IMoniker *val);
// IGroupItem
	STDMETHODIMP Connect(IGroup *group);
	STDMETHODIMP Copy(IBindCtx *bctx, IGroup *dest, IUnknown *aggr, REFIID riid, void **ret);
	STDMETHODIMP Realize(IBindCtx *bctx);
	STDMETHODIMP Remove();
// IPersistStream
	STDMETHODIMP GetClassID(CLSID *pClassID);
	STDMETHODIMP IsDirty(void);
	STDMETHODIMP Load(IStream *pStm);
	STDMETHODIMP Save(IStream *pStm,BOOL fClearDirty);
	STDMETHODIMP GetSizeMax(ULARGE_INTEGER *pcbSize);
// IPersistor
	STDMETHODIMP SetSubject(VARIANT_BOOL realized,IUnknown *pUnkSite);
	STDMETHODIMP get_Subject(IUnknown **ret);
};
