/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "stdafx.h"
#include "Engine.h"
#include "allocDGShapes.h"

// don't reorient node shapes because they are absolute (dynagraph shapegen translates
// them for the rest of dynagraph
void readDGSHAPEDESC(Engine *e,DGSHAPEDESC *val,Line &into,bool reor) {
	into.Clear();
	into.degree = val->isSpline?3:1;
	for(int i=0;i!=val->n;++i) {
		Coord c = Win2DG(val->pts[i]);
		into.push_back(reor?e->reorient(c,true):c);
	}
}
DGSHAPEDESC *writeDGSHAPEDESC(Engine *e,Line &from,bool reor) {
	if(from.degree==0)
		return 0;
	int n = from.size();
	DGSHAPEDESC *pdgep = allocDGShape(n);
	switch(from.degree) {
	case 1:
	default:
		pdgep->isSpline = false;
		break;
	case 3:
		pdgep->isSpline = true;
		break;
	}
	for(int i=0;i<n;i++)
		pdgep->pts[i] = DG2Win(reor?e->reorient(from[i],false):from[i]);
	return pdgep;
}
/*
// reverse shape order
ilshape_t *DGSHAPESDESC2ilshape(Engine *e,DGSHAPESDESC *val) {
	ilshape_t *rv = 0,*curr = 0;
	for(DGSHAPEDESC **i = val->sps;i!=val->sps+val->n;++i) {
		ilshape_t *s = (ilshape_t*)malloc(sizeof(ilshape_t));
		if(!rv)
			curr = rv = s;
		else
			curr->next = s;
		curr = s;
		s->type = (*i)->isSpline?IL_SPLINEGON:IL_POLYGON;
		DGSHAPEDESC2ilcurve(e,*i,&s->def.curve);
	}
	curr->next = 0;
	return rv;
}
ilshape_t *DGSHAPESDESC2ilshape(DGSHAPESDESC *val) {
	ilshape_t *rv = 0;
	for(DGSHAPEDESC **i = val->sps;i!=val->sps+val->n;++i) {
		ilshape_t *s = (ilshape_t*)malloc(sizeof(ilshape_t));
		s->type = (*i)->isSpline?IL_SPLINEGON:IL_POLYGON;
		DGSHAPEDESC2ilcurve(*i,&s->def.curve);
		s->next = rv;
		rv = s;
	}
	return rv;
}
*/
