Attribute VB_Name = "Boot"
Public drawer As DIDGMDrawer
' these globals are perhaps not the prettiest thing but convenient
Dim mc As DIMontageContainer
Dim g As DIGroup
Dim mkMontage As IUnknown
Dim switcher As DIMCCModeSwitcher
Dim selection As DIItemSet
Dim selectionActivator As MCCItemSetActivator
Dim dip As DIPersistor
Dim mainLayer As DIMCCLayer
Dim modeLayer As DIMCCLayer
Dim activeLayer As DIMCCLayer
Dim reader As MCCDataObjectReader
Dim getSubject As IUnknown
Dim mkSwitcher, mkSelection, mkActivator, mkReader As IUnknown
Dim mkMainLayer As IUnknown, mkModeLayer As IUnknown, mkActiveLayer As IUnknown
Dim keeps As ItemSet
Dim dataSet As New MCCSiteSet
Dim gi As IGroupItem
Dim editMode As New MCCContainerEditMode
Sub keep(ByVal mk As IUnknown)
    keeps.Add mk
End Sub
' most of this is a translation of Montage's BootStandard::InitializeOther
' (MUCH cleaner in VB than c++ don't you think?)
Sub Boot(montage As DIMontageContainer)
    Set mc = montage
    ' get group to put things into
    Set g = mc.Group
    ' get persistor and permanence list
    Dim mp As MontagePersistor
    Set mp = g.Bind(mc.RelMoniker)
    Set keeps = mp.KeepSet
    Set getSubject = New GetSubjectMoniker
    Set mkMontage = g.ComposeMonikers(mc.RelMoniker, getSubject)
    ' initializers for contained o's
    keep g.Paste(New MCCCacheInit, g.ItemMoniker("Cache Init"))
    keep g.Paste(New MCCRunInit, g.ItemMoniker("Run Init"))
    ' create mode switcher
    Set switcher = New MCCModeSwitcher
    Set mkSwitcher = g.Paste(switcher, g.ItemMoniker("Mode Switcher"))
    ' create coord transform & install
    'Set sizeToFit = New MCCSizeToFitTransform
    'mc.Transform = sizeToFit
    Dim scroller As New MCCScrollingTransform
    mc.Transform = scroller
    mp.TransformMk = g.Paste(scroller, g.ItemMoniker("Scrolling Transform"))
    Dim tman As New MCCTransformManager
    tman.Initialize mc
    tman.ShowScrollbars = True
    tman.UseExtraArea = False
    tman.Zoom = 10000
    Dim tmanPer As New OnePointerPersistor
    g.Paste tmanPer, g.ItemMoniker("Transform Manager")
    tmanPer.Moniker = mc.RelMoniker
    Set dip = tmanPer
    dip.SetSubject True, tman
    ' create layers
    Set mainLayer = mc.NewLayer
    mainLayer.PutBehind Nothing
    mainLayer.IsTransformed = True
    Set modeLayer = mc.NewLayer
    modeLayer.PutBehind Nothing
    Set grappleLayer = mc.NewLayer
    grappleLayer.PutBehind Nothing
    Set activeLayer = mc.NewLayer
    activeLayer.PutBehind Nothing
    activeLayer.IsTransformed = True
    ' create ambiance for main & active layers with a default font
    Dim ambiance As New MCCStyle
    Dim ambMap As New MCCAmbientMapper
    ' DIMCCStyle is not default interface of MCCStyle
    Dim ambStyle As DIMCCStyle
    Set ambStyle = ambiance
    ambStyle.Defer = ambMap
    Set mkAmbMap = g.Paste(ambMap, g.ItemMoniker("Ambient Map"))
    Dim ambPer As New OnePointerPersistor
    Set mkAmbiance = g.ComposeMonikers(g.Paste(ambPer, g.ItemMoniker("Ambiance")), New GetSubjectMoniker)
    ambPer.Moniker = mkAmbMap
    Set dip = ambPer
    dip.SetSubject True, ambiance
    Dim defaultFont As New StdFont
    With defaultFont
        .Name = "Arial"
        .Size = 8
    End With
    ambiance.Font = defaultFont
    mainLayer.DefaultAmbiance = ambiance
    activeLayer.DefaultAmbiance = ambiance
    ' install layer ordering
    Set mkLayerOrdering = g.Paste(New MCCLayerOrdering, g.ItemMoniker("Layer Ordering"))
    ' ... site orderings
    mainLayer.OrderMk = g.Paste(New MCCSiteOrdering, g.ItemMoniker("Main Site Ordering"))
    modeLayer.OrderMk = g.Paste(New MCCSiteOrdering, g.ItemMoniker("Mode Site Ordering"))
    grappleLayer.OrderMk = g.Paste(New MCCSiteOrdering, g.ItemMoniker("Grapple Site Ordering"))
    activeLayer.OrderMk = g.Paste(New MCCSiteOrdering, g.ItemMoniker("Active Site Ordering"))
    ' make layers persistent; make names available
    Set mainPer = New MCCLayerPersistor
    mainLayer.RelMoniker = g.Paste(mainPer, g.ItemMoniker("Main Layer"))
    mainPer.Initialize mkMontage, mkLayerOrdering, mainLayer.OrderMk, mkAmbiance
    Set modePer = New MCCLayerPersistor
    modeLayer.RelMoniker = g.Paste(modePer, g.ItemMoniker("Mode Layer"))
    modePer.Initialize mkMontage, mkLayerOrdering, modeLayer.OrderMk, Nothing
    Set grapplePer = New MCCLayerPersistor
    grappleLayer.RelMoniker = g.Paste(grapplePer, g.ItemMoniker("Grapple Layer"))
    grapplePer.Initialize mkMontage, mkLayerOrdering, grappleLayer.OrderMk, Nothing
    Set activePer = New MCCLayerPersistor
    activeLayer.RelMoniker = g.Paste(activePer, g.ItemMoniker("Active Layer"))
    activePer.Initialize mkMontage, mkLayerOrdering, activeLayer.OrderMk, mkAmbiance
    ' connect persistors with layers
    Set dip = mainPer
    dip.SetSubject True, mainLayer
    Set dip = modePer
    dip.SetSubject True, modeLayer
    Set dip = grapplePer
    dip.SetSubject True, grappleLayer
    Set dip = activePer
    dip.SetSubject True, activeLayer
    Set mkMainLayer = g.ComposeMonikers(mainLayer.RelMoniker, getSubject)
    Set mkModeLayer = g.ComposeMonikers(modeLayer.RelMoniker, getSubject)
    Set mkGrappleLayer = g.ComposeMonikers(grappleLayer.RelMoniker, getSubject)
    Set mkActiveLayer = g.ComposeMonikers(activeLayer.RelMoniker, getSubject)
    ' default IMCCSelectable sink
    Dim defSelectable As New DefaultMCCSelectable
    defSelectable.Initialize mc
    Dim selectablePer As New OnePointerPersistor
    keep g.Paste(selectablePer, g.ItemMoniker("Default IMCCSelectable"))
    selectablePer.Moniker = mkMontage
    Set dip = selectablePer
    dip.SetSubject True, defSelectable
    ' default IMCCSelectionDraw
    Dim defSelectionDraw As New DefaultMCCSelectionDraw
    defSelectionDraw.Initialize grappleLayer
    Dim selectionDrawPer As New OnePointerPersistor
    Set mkSelectionDraw = g.Paste(selectionDrawPer, g.ItemMoniker("Default IMCCSelectionDraw"))
    keep mkSelectionDraw
    selectionDrawPer.Moniker = mkGrappleLayer
    Set dip = selectionDrawPer
    dip.SetSubject True, defSelectionDraw
    ' selection set
    Dim sel As New MCCSiteSet
    Set mkSelection = g.Paste(sel, g.ItemMoniker("Selection"))
    sel.Initialize mkMontage
    Set gi = sel
    gi.Realize Nothing
    Set selection = sel
    ' sink to show grapples
    Dim selectionDrawer As New MCCItemSetDrawer
    selectionDrawer.Initialize mc, selection
    Dim selDrawerPer As New SomePointersPersistor
    keep g.Paste(selDrawerPer, g.ItemMoniker("Selection Drawer"))
    selDrawerPer.PushOne mkMontage
    selDrawerPer.PushOne mkSelection
    ' hack: selection drawer needs sink to be loaded first. thus this
    selDrawerPer.PushOne mkSelectionDraw
    Set dip = selDrawerPer
    dip.SetSubject True, selectionDrawer
    ' tool to activate selection
    Set selectionActivator = New MCCItemSetActivator
    selectionActivator.Initialize selection, mainLayer, activeLayer
    Dim selectionActivatorPer As New SomePointersPersistor
    Set mkActivator = g.ComposeMonikers(g.Paste(selectionActivatorPer, g.ItemMoniker("Selection Activator")), getSubject)
    selectionActivatorPer.PushOne mkSelection
    selectionActivatorPer.PushOne mkMainLayer
    selectionActivatorPer.PushOne mkActiveLayer
    Set dip = selectionActivatorPer
    dip.SetSubject True, selectionActivator
    ' view mode
    Dim del As DIMCCModeDelegate
    Set del = switcher.NewDelegate
    del.Name = "View"
    del.Order = 0 ' left
    del.Show
    Dim viewMode As New MCCViewMode
    viewMode.Initialize del, selection, selectionActivator, mainLayer
    Dim viewPer As New SomePointersPersistor
    Set mkViewMode = g.ComposeMonikers(g.Paste(viewPer, g.ItemMoniker("View Mode")), getSubject)
    viewPer.PushOne mkSwitcher
    viewPer.PushOne mkSelection
    viewPer.PushOne mkActivator
    viewPer.PushOne mkMainLayer
    Set dip = viewPer
    dip.SetSubject True, viewMode
    ' view mode site
    Set viewModeSite = mc.NewSite
    viewModeSite.Layer = modeLayer
    viewModeSite.Control = viewMode
    viewModeSite.Intent = MCCS_ACTIVE
    ' & site's persistor
    Dim viewSitePer As New MCCSitePersistor
    viewModeSite.RelMoniker = g.Paste(viewSitePer, g.ItemMoniker("View Mode Site"))
    keep viewModeSite.RelMoniker
    viewSitePer.Initialize mc.RelMoniker, mkModeLayer, modeLayer.OrderMk, mkViewMode, Nothing, Nothing
    Set dip = viewSitePer
    dip.SetSubject True, viewModeSite
    ' data stuff
    Set reader = New MCCDataObjectReader
    Set mkReader = g.Paste(reader, g.ItemMoniker("DataObject Reader"))
    ' native format
    Dim pasteSetUnpacker As New MCCPasteSetUnpacker
    pasteSetUnpacker.Initialize mc, reader
    Dim pasteSetUnpackerPer As New SomePointersPersistor
    keep g.Paste(pasteSetUnpackerPer, g.ItemMoniker("Paste Set Unpacker"))
    pasteSetUnpackerPer.PushOne mkMontage
    pasteSetUnpackerPer.PushOne mkReader
    ' embedded/embed source
    Dim embedUnpacker As New MCCEmbedUnpacker
    embedUnpacker.Initialize reader, mainLayer
    Dim embedUnpackerPer As New SomePointersPersistor
    keep g.Paste(embedUnpackerPer, g.ItemMoniker("Embed Unpacker"))
    embedUnpackerPer.PushOne mkReader
    embedUnpackerPer.PushOne mkMainLayer
    Set dip = embedUnpackerPer
    dip.SetSubject True, embedUnpacker
    ' edit mode
    editMode.Initialize selection, selectionActivator, mainLayer, reader
    Dim editModePer As New SomePointersPersistor
    Set mkEditMode = g.ComposeMonikers(g.Paste(editModePer, g.ItemMoniker("Edit Mode")), getSubject)
    editModePer.PushOne mkSelection
    editModePer.PushOne mkActivator
    editModePer.PushOne mkMainLayer
    editModePer.PushOne mkReader
    Set dip = editModePer
    dip.SetSubject True, editMode
    ' edit mode site
    Set editModeSite = mc.NewSite
    editModeSite.Layer = modeLayer
    editModeSite.Control = editMode
    ' mode delegate: space in mode list
    Set del = switcher.NewDelegate
    del.Name = "Edit"
    del.Order = 100 ' middle
    del.Show
    ' .. owner
    Dim editOwner As New MCCControlMode
    editOwner.Initialize del
    editOwner.Site = editModeSite
    editModeSite.Intent = MCCS_COUIACTIVE
    ' .. owner persistor
    Dim editOwnerPer As New SomePointersPersistor
    Set mkEditOwner = g.ComposeMonikers(g.Paste(editOwnerPer, g.ItemMoniker("Edit Mode Owner")), getSubject)
    editOwnerPer.PushOne mkSwitcher
    Set dip = editOwnerPer
    dip.SetSubject True, editOwner
    ' .. site persistor
    Dim editSitePer As New MCCSitePersistor
    editModeSite.RelMoniker = g.Paste(editSitePer, g.ItemMoniker("Edit Mode Site"))
    keep editModeSite.RelMoniker
    editSitePer.Initialize mkMontage, mkModeLayer, modeLayer.OrderMk, mkEditMode, Nothing, Nothing
    editSitePer.initlist(10) = mkEditOwner ' 10?
    Set dip = editSitePer
    dip.SetSubject True, editModeSite
    
    ' data set
    g.Paste dataSet, g.ItemMoniker("Data")
    dataSet.Initialize mkMontage
    Set gi = dataSet
    gi.Realize Nothing
End Sub

Sub bootDG()
    ' graph layout engine
    Dim engine As New DynaDagEngine
    engine.Initialize 1, 100, 0.5, 0.5
    Set mkLayout = g.Paste(engine, g.ItemMoniker("Graph Layout Engine"))
    ' connection to Montage
    Dim connector As New DGMEngineConnector
    connector.Initialize mc, engine
    Dim connectorPer As New SomePointersPersistor
    g.Paste connectorPer, g.ItemMoniker("Dynagraph-Montage Connector")
    connectorPer.PushOne mkMontage
    connectorPer.PushOne mkLayout
    Set dip = connectorPer
    dip.SetSubject True, connector
    ' node data source
    Dim nodeSource As New MCCDataObjectPersistent
    nodeSource.CreateEmbeddedObject CreateObject("DocugraphControls.stuffNode")
    Set mkNodeSource = g.Paste(nodeSource, g.ItemMoniker("Node Source"))
    ' edge data source
    Dim protoEdge As New DGMSimpleEdge
    Dim edgeSource As New MCCDataObjectPersistent
    edgeSource.CreateEmbeddedObject protoEdge
    Set mkEdgeSource = g.Paste(edgeSource, g.ItemMoniker("Edge Source"))
    ' drawer
    Set drawer = New DGMDrawer
    drawer.Initialize mc, engine, nodeSource, edgeSource, Nothing, reader, Nothing, mkReader
    ' graph draw mode
    Dim drawMode As New DGMGraphDrawMode
    drawMode.Initialize selection, selectionActivator, drawer, editMode
    drawMode.AddLayer activeLayer
    drawMode.AddLayer mainLayer
    Set drawSite = mc.NewSite
    drawSite.Control = drawMode
    drawSite.Layer = modeLayer
    Set del = switcher.NewDelegate
    del.Name = "Draw"
    del.Order = 200 ' right
    Dim drawOwner As New MCCControlMode
    drawOwner.Initialize del
    drawOwner.Site = drawSite
    drawSite.Intent = MCCS_COUIACTIVE
    ' persist drawer
    Dim drawerPer As New SomePointersPersistor
    Set mkDrawer = g.Paste(drawerPer, g.ItemMoniker("Graph Drawer"))
    drawerPer.PushOne mkMontage
    drawerPer.PushOne mkLayout
    drawerPer.PushOne mkNodeSource
    drawerPer.PushOne mkEdgeSource
    drawerPer.PushOne mkReader
    ' .. draw mode owner
    Dim drawOwnerPer As New SomePointersPersistor
    Set mkDrawOwner = g.ComposeMonikers(g.Paste(drawOwnerPer, g.ItemMoniker("Graph Draw Mode ControlMode")), getSubject)
    drawOwnerPer.PushOne mkSwitcher
    Set dip = drawOwnerPer
    dip.SetSubject True, drawOwner
    ' .. draw mode
    Dim drawModePer As New SomePointersPersistor
    Set mkDrawMode = g.ComposeMonikers(g.Paste(drawModePer, g.ItemMoniker("Graph Draw Mode")), getSubject)
    drawModePer.PushOne mkSelection
    drawModePer.PushOne mkActivator
    drawModePer.PushOne mkDrawer
    drawModePer.PushOne mkActiveLayer
    drawModePer.PushOne mkMainLayer
    Set dip = drawModePer
    dip.SetSubject True, drawMode
    ' .. draw mode's site
    Dim drawSitePer As New MCCSitePersistor
    g.Paste drawSitePer, g.ItemMoniker("Graph Draw Mode Site")
    drawSitePer.Initialize mkMontage, mkModeLayer, modeLayer.OrderMk, mkDrawMode, Nothing, Nothing
    Set dip = drawSitePer
    dip.SetSubject True, drawSite
    drawSitePer.initlist(10) = mkDrawOwner
End Sub
Sub addFileDrop()
    ' create mode
    Dim mode As Object
    Set mode = CreateObject("DocugraphControls.FileCatcherMode")
    ' site
    Dim s As DIMCCSite
    Set s = mc.NewSite
    s.Layer = modeLayer
    s.Control = mode
    ' enter into mode list
    Dim del As MCCModeDelegate
    Set del = switcher.NewDelegate
    del.Name = "GraphStuff"
    del.Order = 500 ' right
    del.Show
    ' init mode
    ' keeps a set of all nodes so it can activate them
    Dim activeSet As New MCCSiteSet
    g.Paste activeSet, g.ItemMoniker("GraphStuff Activation Set")
    activeSet.Initialize mkMontage
    Set gi = activeSet
    gi.Realize Nothing
    Dim act As New MCCItemSetActivator
    act.Initialize activeSet, mainLayer, activeLayer
    Dim aset2 As DIItemSet
    Set aset2 = activeSet
    mode.Initialize del, act, aset2
    ' owner.
    Dim fdOwner As New MCCControlMode
    fdOwner.Initialize del
    fdOwner.Site = s
    ' starting mode
    s.Intent = MCCS_COUIACTIVE
    del.Activate False
End Sub

