VERSION 5.00
Begin VB.UserControl stuffNode 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00800000&
   ClientHeight    =   3570
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4770
   FillColor       =   &H00FFFFFF&
   FillStyle       =   0  'Solid
   ForeColor       =   &H00FFFFFF&
   ScaleHeight     =   3570
   ScaleMode       =   0  'User
   ScaleWidth      =   4770
   Begin VB.TextBox textArea 
      BorderStyle     =   0  'None
      Height          =   3270
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   0
      Top             =   225
      Width           =   4575
   End
   Begin VB.Label closeIcon 
      BackColor       =   &H00400000&
      BackStyle       =   0  'Transparent
      Caption         =   "X"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFFFF&
      Height          =   180
      Left            =   4545
      TabIndex        =   1
      Top             =   30
      Width           =   225
   End
End
Attribute VB_Name = "stuffNode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "GraphStuff Node"
Dim firer As New MCCEventFirer
Dim firerInit As DIMCCEventFirer
Dim linkLeft, linkTop, linkWidth, linkHeight As Integer
Dim selWidth, selHeight As Integer
Dim site As DIMCCSite
Dim gdm As IDGMGraphDrawMode
Dim amTracking As Boolean
Dim amSelected As Boolean
Dim file As String
Public Property Let Selected(yn As Boolean)
    amSelected = yn
    UserControl_Resize
End Property
Public Property Get Selected() As Boolean
    Selected = amSelected
End Property
Public Property Let Description(val As String)
    textArea.Text = val
End Property
Public Property Get Description() As String
    Description = textArea.Text
End Property
Public Property Let Filename(val As String)
    file = val
End Property
Public Property Get Filename() As String
    Filename = file
End Property
Private Sub closeIcon_Click()
    firerInit.Initialize "{0590ea2d-25d5-11d1-9d64-00a02482bcc1}", 1, 0, "{0590ea32-25d5-11d1-9d64-00a02482bcc1}"
    firerInit.Subject = site
    firer.Intend MCCS_DELETED
End Sub

Private Sub UserControl_Initialize()
    Set firerInit = firer
    UserControl_Resize
End Sub
Private Sub drawLinkIcon()
    ptX = linkLeft + linkHeight / 2
    ptY = linkTop + linkHeight / 2
    Circle (ptX, ptY), linkHeight / 2 - 60, vbWhite
    Line -(linkLeft + linkWidth, linkTop + linkHeight / 2)
    Line -(linkLeft + linkWidth - linkHeight / 2, linkTop + 30)
    Line (linkLeft + linkWidth, linkTop + linkHeight / 2)-(linkLeft + linkWidth - linkHeight / 2, linkTop + linkHeight - 30)
End Sub
Private Function point(ByVal x As Integer, ByVal y As Integer) As tagPOINT
    Let px = ScaleX(x, vbTwips, vbPixels)
    Let py = ScaleY(y, vbTwips, vbPixels)
    Dim pt As tagPOINT
    pt.x = site.Left + px
    pt.y = site.Top + py
    point = pt
End Function
Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    ' in link icon?
    If x > linkLeft And x < (linkLeft + linkWidth) And _
        y > linkTop And y < (linkTop + linkHeight) Then
        Dim pt As tagPOINT
        Let pt = point(x, y)
        gdm.TempEdgeTail = pt
        gdm.TempEdgeHead = pt
        gdm.DrawTempEdge = True
        amTracking = True
    End If
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    If amTracking Then
        gdm.TempEdgeHead = point(x, y)
    End If
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    If amTracking Then
        gdm.TempEdgeHead = point(x, y)
        gdm.DrawEdge
        gdm.DrawTempEdge = False
        amTracking = False
    ElseIf x > 60 And x < (60 + selWidth) And _
        y > 60 And y < (60 + selHeight) Then
        Dim mc As IOleObject
        Set mc = Parent
        Dim vbs As IOleClientSite
        mc.GetClientSite vbs
        Dim gsOC As IOleContainer
        vbs.GetContainer gsOC
        Dim graphStuff As Object
        Set graphStuff = gsOC
        Set graphStuff.ActiveNode = Me
    End If
End Sub

Private Sub UserControl_Resize()
    Cls
    If Height > 200 And Width > closeIcon.Width Then
        ' draw selection indicator
        selWidth = Width / 3
        If selWidth > 720 Then selWidth = 720
        selHeight = 110
        If amSelected Then selco = &H80FF& Else selco = &H777777
        Line (60, 60)-(selWidth, 60 + selHeight), selco, BF
        ' draw link icon
        linkHeight = 200
        linkWidth = Width / 4
        If linkWidth > 720 Then linkWidth = 720
        linkLeft = Width / 2 - linkWidth / 2
        linkTop = 0
        drawLinkIcon
        closeIcon.Left = Width - closeIcon.Width - 60
        textArea.Width = Width - 240
        textArea.Height = Height - 320
    Else
        linkHeight = 0
        linkWidth = 0
        textArea.Width = 0
        textArea.Height = 0
    End If
End Sub

Private Sub UserControl_Show()
    ' for testing in non-montage containers
    On Error GoTo Ignore
    ' get site
    Dim oo As IOleObject
    Set oo = Me
    Dim osite As IOleClientSite
    oo.GetClientSite osite
    Set site = osite
    ' get graph draw mode
    Dim g As DIGroup
    Set g = site.Container.Group
    Set gdm = g.Bind(g.ComposeMonikers(g.ItemMoniker("Graph Draw Mode"), New GetSubjectMoniker))
Ignore:
End Sub
