/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// CntrItem.h : interface of the CHistograph2CntrItem class
//

#if !defined(AFX_CNTRITEM_H__16A9E408_C741_11D2_83D8_A589F2CAD60B__INCLUDED_)
#define AFX_CNTRITEM_H__16A9E408_C741_11D2_83D8_A589F2CAD60B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CHistograph2Doc;
class CHistograph2View;

class CHistograph2CntrItem : public COleDocObjectItem
{
	DECLARE_SERIAL(CHistograph2CntrItem)

// Constructors
public:
	CHistograph2CntrItem(CHistograph2Doc* pContainer = NULL);
		// Note: pContainer is allowed to be NULL to enable IMPLEMENT_SERIALIZE.
		//  IMPLEMENT_SERIALIZE requires the class have a constructor with
		//  zero arguments.  Normally, OLE items are constructed with a
		//  non-NULL document pointer.

// Attributes
public:
	CHistograph2Doc* GetDocument()
		{ return (CHistograph2Doc*)COleDocObjectItem::GetDocument(); }
	CHistograph2View* GetActiveView()
		{ return (CHistograph2View*)COleDocObjectItem::GetActiveView(); }

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHistograph2CntrItem)
	public:
	virtual void OnChange(OLE_NOTIFICATION wNotification, DWORD dwParam);
	virtual void OnActivate();
	protected:
	virtual void OnDeactivateUI(BOOL bUndoable);
	virtual BOOL OnChangeItemPosition(const CRect& rectPos);
	//}}AFX_VIRTUAL

	virtual void OnGetItemPosition( CRect& rPosition );

// Implementation
public:
	~CHistograph2CntrItem();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	virtual void Serialize(CArchive& ar);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CNTRITEM_H__16A9E408_C741_11D2_83D8_A589F2CAD60B__INCLUDED_)
