/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/



#if !defined(AFX_HISTOGRAPH2DOC_H__16A9E403_C741_11D2_83D8_A589F2CAD60B__INCLUDED_)
#define AFX_HISTOGRAPH2DOC_H__16A9E403_C741_11D2_83D8_A589F2CAD60B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CntrItem.h"

#define PTR(i) _COM_SMARTPTR_TYPEDEF(i,IID_##i)
PTR(IClickNodesMode);

class CHistograph2Doc : public COleDocument
{
protected: // create from serialization only
	CHistograph2Doc();
	DECLARE_DYNCREATE(CHistograph2Doc)

	CHistograph2CntrItem *m_browserItem;
	COleClientItem *m_graphItem;
	IClickNodesModePtr m_clickNodes;
	IWebBrowser2Ptr m_ie;

	// persistence info
	IMonikerPtr m_mkClickNodes;

	_bstr_t m_last;

	HRESULT SinkEvents();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHistograph2Doc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void OnCloseDocument();
	//}}AFX_VIRTUAL

// DWebBrowserEvents2 sink
	void NavigateComplete2(LPDISPATCH pDisp, BSTR URL);

// Implementation
public:
	virtual ~CHistograph2Doc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	BEGIN_INTERFACE_PART(ClickNodesSink,IClickNodesModeEvents)
		STDMETHODIMP OnClick(BSTR id);
	END_INTERFACE_PART(ClickNodesSink)

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CHistograph2Doc)
	afx_msg void OnGo();
	afx_msg void OnBack();
	afx_msg void OnForward();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	// Generated OLE dispatch map functions
	//{{AFX_DISPATCH(CHistograph2Doc)
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()
	DECLARE_INTERFACE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HISTOGRAPH2DOC_H__16A9E403_C741_11D2_83D8_A589F2CAD60B__INCLUDED_)
