/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#define STRINGDICT_USE_STL
#include <common/StringDict.h>
#include <map>
using namespace std;
struct Central :
	CComCoClass<Central,&CLSID_DinographCentral>,
	CComObjectRoot,
	IConnectionPointContainerImpl<Central>,
	IConnectionPointImpl<Central,&IID_IDinographCentralEvents>,
	IDinographCentral,
    IMCCFileFormat
{
    typedef map<DString,string> Defns;
    Defns m_defns[3];
	CComPtr<DIMontageContainerRef> m_mref;
    CComPtr<IDGIncrClient> m_incrClient;
	CComPtr<IDGLayout> m_dynagraph;

	Central();
	~Central();

    STDMETHODIMP writeAll(ostream &out);

    REGISTER_GENERIC(L"Central")
BEGIN_COM_MAP(Central)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(IDinographCentral)
	COM_INTERFACE_ENTRY(IMCCFileFormat)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(Central)
	CONNECTION_POINT_ENTRY(IID_IDinographCentralEvents)
END_CONNECTION_POINT_MAP()

// IDinographCentral
    STDMETHODIMP Initialize(IMCCFilePort *port, IMontageContainer *mc, IDGLayout *dynagraph, IDGIncrClient *incrClient);
    STDMETHODIMP SendAll();
    STDMETHODIMP ChangeInput(DINOGRAPH_INPUT_TYPES type,LPCOLESTR name,LPCOLESTR value);
	STDMETHODIMP GetInput(DINOGRAPH_INPUT_TYPES type,LPCOLESTR name,LPOLESTR *ret);
	STDMETHODIMP EnumExisting(DINOGRAPH_INPUT_TYPES type,IEnumString **ret);
	STDMETHODIMP HorribleIncrModeHack();
// IMCCFileFormat
	STDMETHODIMP Import(LPCOLESTR filename);
	STDMETHODIMP Export(LPCOLESTR filename);
};