/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#pragma once
#include "dispex.h"
#include "resource.h"       // main symbols
#include "..\Group\Group.h"
#include "..\Montage\Montage.h"
#include "..\comdg\comdg.h"
#include "..\DGM\DGM.h"


// DinographBoot

class ATL_NO_VTABLE DinographBoot :
	public CComObjectRoot,
	public CComCoClass<DinographBoot,&CLSID_DinographBoot>,
	public IInitializeOther
{
public:

	REGISTER_GENERIC(L"Boot")
	DinographBoot()
	{
	}


	DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_CATEGORY_MAP(DinographBoot)
	IMPLEMENTED_CATEGORY(CATID_MCCStarter)
END_CATEGORY_MAP()

BEGIN_COM_MAP(DinographBoot)
	COM_INTERFACE_ENTRY(IInitializeOther)
END_COM_MAP()

public:

	STDMETHODIMP InitializeOther(IUnknown *montage);

};

