/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#include "Dinograph.h"
#include "MontageConfig.h"
#include "ensureNativeFormat.h"
struct DinographDiagram : MontageConfig<DinographDiagram,&CLSID_DinographControl,
	MontageCreator<&CLSID_MontageControlContainer,&CLSID_DinographBoot>,IDR_MontageApp> {
BEGIN_REGMAP()
	REGMAP_GUID(L"CLSID",CLSID_DinographControl)
	REGMAP_GUID(L"TypeLib",LIBID_Dinograph)
	REGMAP_STRING(L"DocName",L"Dinograph Diagram")
	REGMAP_STRING(L"AppName",L"Dinograph")
	REGMAP_STRING(L"Short",L"Diagram")
	REGMAP_STRING(L"ProgID",L"Dinograph.Diagram.1")
	REGMAP_STRING(L"VersIndProgID",L"Dinograph.Diagram")
	REGMAP_FUN(L"ProgDir",progdirString)
	REGMAP_STRING(L"DefaultExt",L".dinog,Dinograph Definition File (.dinog)")
	REGMAP_STRING(L"Extra",L"HKCR { '.dinog' = s 'Dinograph.Diagram' { val 'Content Type' = s 'application/dinograph' } "
	L"NoRemove MIME { NoRemove Database { NoRemove 'Content Type' { application/dinograph { val Extension = s '.dinog' } } } } }")
END_REGMAP()
	static HRESULT moreReg() {
		return ensureNativeFormat(L"dinogwks");
	}
};
