/*
Date:         Tue, 8 Jul 1997 07:52:33 -0500
Reply-To:     ATL - Active Template Library <ATL@LISTSERV.MSN.COM>
Sender:       ATL - Active Template Library <ATL@LISTSERV.MSN.COM>
From:         Stephen W Gissendaner <Stephen_W_Gissendaner@HCONTROLS.COM>
Subject:      Re: _ATL_DEBUG_REFCOUNT
*/
//DEBUG_REFCOUNT_IMPL(classname)
/********************************************************************** 
PURPOSE:
**    To give the reference count of an object when degugging.
USE:
**    1) #define _ATL_DEBUG_REFCOUNT in the project settings
**    2) put this macro at the end of the class declarations that you
**       want to refcount, e.g.

DEBUG_REFCOUNT_IMPL(HSite);

**    3) Watch the messages in the debug output window.

*/
#ifdef _DEBUG
#define DEBUG_REFCOUNT_IMPL(classname)\
	ULONG InternalAddRef()\
		{ULONG ulReturn = CComObjectRoot::InternalAddRef();\
		ATLTRACE(_T("%p>%s::AddRef() to %d\n"),this, _T(#classname), m_dwRef);\
		return ulReturn;}\
	ULONG InternalRelease()\
		{ULONG ulReturn = CComObjectRoot::InternalRelease();\
		ATLTRACE(_T("%p>%s::Release()\t to %d ---\n"),this, _T(#classname), m_dwRef);\
		return ulReturn;}
#else
#define DEBUG_REFCOUNT_IMPL(classname)
#endif

