/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


// local.cpp : Implementation of WinMain


// Note: Proxy/Stub Information
//		To build a separate proxy/stub DLL,
//		run nmake -f localps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include "initguid.h"
#include "..\shared\qi.h"

LONG CExeModule::Unlock()
{
	LONG l = CComModule::Unlock();
	if (l == 0)
	{
#if _WIN32_WINNT >= 0x0400
		if (CoSuspendClassObjects() == S_OK)
			PostThreadMessage(dwThreadID, WM_QUIT, 0, 0);
#else
		PostThreadMessage(dwThreadID, WM_QUIT, 0, 0);
#endif
	}
	return l;
}

CExeModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
END_OBJECT_MAP()


LPCTSTR FindOneOf(LPCTSTR p1, LPCTSTR p2)
{
	while (*p1 != NULL)
	{
		LPCTSTR p = p2;
		while (*p != NULL)
		{
			if (*p1 == *p++)
				return p1+1;
		}
		p1++;
	}
	return NULL;
}

#include "dispex.h"
#include "..\Group\Group.h"
#include "..\Montage\Montage.h"
#include "..\comdg\comdg.h"
#include "..\dgm\dgm.h"
#include "..\Shared\run.h"

typedef HRESULT (STDAPICALLTYPE*DllGetClassObjectFunc)(REFCLSID rclsid, REFIID riid, LPVOID* ppv);

const CLSID *g_classes[3] = {&CLSID_MontageControlContainer,&CLSID_MontageManualLayout,&CLSID_DynagraphControl};
int g_nClasses = sizeof(g_classes)/sizeof(CLSID*);
/////////////////////////////////////////////////////////////////////////////
//
extern "C" int WINAPI _tWinMain(HINSTANCE hInstance,
	HINSTANCE /*hPrevInstance*/, LPTSTR lpCmdLine, int /*nShowCmd*/)
{
	HINSTANCE hMontage = LoadLibrary("Montage.ocx"),
		hDGM = LoadLibrary("dgm.dll");
	DllGetClassObjectFunc getMontageObject = (DllGetClassObjectFunc)GetProcAddress(hMontage,"DllGetClassObject"),
		getDGMObject = (DllGetClassObjectFunc)GetProcAddress(hDGM,"DllGetClassObject");


	lpCmdLine = GetCommandLine(); //this line necessary for _ATL_MIN_CRT
	HRESULT hRes = OleInitialize(0);
	_ASSERTE(SUCCEEDED(hRes));
	_Module.Init(ObjectMap, hInstance);
	_Module.dwThreadID = GetCurrentThreadId();
	TCHAR szTokens[] = _T("-/");

	int nRet = 0;
	BOOL bRun = TRUE;
	LPCTSTR lpszToken = FindOneOf(lpCmdLine, szTokens);
	while (lpszToken != NULL)
	{
		if (lstrcmpi(lpszToken, _T("UnregServer"))==0)
		{
			_Module.UpdateRegistryFromResource(IDR_Local, FALSE);
			nRet = _Module.UnregisterServer();
			bRun = FALSE;
			break;
		}
		if (lstrcmpi(lpszToken, _T("RegServer"))==0)
		{
			_Module.UpdateRegistryFromResource(IDR_Local, TRUE);
			nRet = _Module.RegisterServer(TRUE);
			bRun = FALSE;
			break;
		}
		lpszToken = FindOneOf(lpszToken, szTokens);
	}

	if (bRun)
	{
		hRes = _Module.RegisterClassObjects(CLSCTX_LOCAL_SERVER,
			REGCLS_MULTIPLEUSE);
		_ASSERTE(SUCCEEDED(hRes));

		DWORD *regs = new DWORD[g_nClasses];
		for(int i=0;i<g_nClasses;++i) {
			CComPtr<IUnknown> classObj;
			if(FAILED(getMontageObject(*g_classes[i],riidret(&classObj))))
				RUN(getDGMObject(*g_classes[i],riidret(&classObj)));
			RUN(CoRegisterClassObject(*g_classes[i],classObj,CLSCTX_LOCAL_SERVER,REGCLS_MULTIPLEUSE,&regs[i]));
		}

		MSG msg;
		while (GetMessage(&msg, 0, 0, 0))
			DispatchMessage(&msg);

		_Module.RevokeClassObjects();
		for(i=0;i<g_nClasses;++i)
			RUN(CoRevokeClassObject(regs[i]));
		delete [] regs;
	}

	OleUninitialize();
	return nRet;
}
