/**********************************************************
*      This software is part of the graphviz toolset      *
*                http://www.graphviz.org/                 *
*                                                         *
*            Copyright (c) 1994-2005 AT&T Corp.           *
*                and is licensed under the                *
*            Common Public License, Version 1.0           *
*                      by AT&T Corp.                      *
*                                                         *
*        Information and Software Systems Research        *
*              AT&T Research, Florham Park NJ             *
*                                                         *
*               This version available from               *
*                   http://dynagraph.org                  *
**********************************************************/


#pragma once
#include "resource.h"       // main symbols
#include <map>
// MTracer

// Montage will be stored in a memory storage and
class ATL_NO_VTABLE MTracer :
	public CComObjectRootEx<CComGlobalsThreadModel>,
	public CComCoClass<MTracer, &CLSID_MTracer>,
	public IMTracer
{
    FILE *m_debugOut;
	typedef enum {DONT,TO_FILE,TO_DEBUGGER} how_to;
	how_to m_prefs[1000];
    int m_callNumber;
    std::map<DWORD,int> m_callDepths; // indexed by thread
public:

    MTracer();

	REGISTER_GENERIC(L"MTracer")
    DECLARE_CLASSFACTORY_SINGLETON(MTracer)


BEGIN_COM_MAP(MTracer)
	COM_INTERFACE_ENTRY(IMTracer)
END_COM_MAP()


	DECLARE_PROTECT_FINAL_CONSTRUCT()

public:
// IMTracer
    STDMETHODIMP Start();
    STDMETHODIMP Trace(int category, LPCSTR lpszFormat);
    STDMETHODIMP CallNumber(int *ret);
    STDMETHODIMP CallDepth(BOOL enter,int *ret);
    STDMETHODIMP Stop();
};

OBJECT_ENTRY_AUTO(CLSID_MTracer, MTracer)
